"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var forms_1 = require('@angular/forms');
var router_1 = require('@angular/router');
var http_1 = require('@angular/http');
var primeng_1 = require('primeng/primeng');
var app_settings_1 = require('./app.settings');
var index_1 = require('./../components/index');
var index_2 = require('./../interfaces/index');
var index_3 = require('./../models/index');
var index_4 = require('./../services/index');
var index_5 = require('./../factories/index');
var BaseAppComponent = (function () {
    function BaseAppComponent(m_elementRef, logger, http, permissionService, loginService) {
        var _this = this;
        this.m_elementRef = m_elementRef;
        this.logger = logger;
        this.http = http;
        this.permissionService = permissionService;
        this.loginService = loginService;
        this.msgs = [];
        app_settings_1.AppSettings.API_ENDPOINT = location.origin + location.pathname + '/rest-api/';
        app_settings_1.AppSettings.LOGIN_ENDPOINT = location.origin + location.pathname + '/auth-api/';
        loginService.UserLoginInfoObservable.subscribe(function (next) {
            if (next.UserLoggedIn) {
                _this.permissionService.reloadPermissionsForResource(new index_3.Claim());
            }
        });
        setInterval(function () {
            _this.msgs.push({ severity: 'info', summary: 'Interval info', detail: 'Another 5 seconds passed.' });
        }, 5000);
    }
    BaseAppComponent.prototype.ngAfterViewInit = function () {
        this.logger.log("Application initialized!");
        this.msgs.push({ severity: 'info', summary: 'Info', detail: 'Application started.' });
    };
    BaseAppComponent = __decorate([
        index_1.AppComponent({
            selector: "base-app",
            directives: [router_1.RouterModule, primeng_1.Growl],
            template: "\n    <div class=\"container body-content\">\n        <p-growl [value]=\"msgs\"></p-growl>\n\t\t<h1>Base app</h1>\n        <login-component></login-component>\n\t\t<div class=\"col-md-12\" style=\"border:1px;\">\n\t\t\t<router-outlet></router-outlet>\n\t\t</div>\n\t</div>\n    ",
            providers: [
                index_4.RhetosRestService, index_4.PermissionProvider, index_4.LocalStorageService, index_5.ComponentCustomizationFactory, index_2.IEntityContainer, index_5.DataCustomizationFactory, index_4.LoginService,
                http_1.HttpModule, forms_1.FormsModule,
            ],
            productionMode: true
        }), 
        __metadata('design:paramtypes', [core_1.ElementRef, index_4.TestLogger, http_1.Http, index_4.PermissionProvider, index_4.LoginService])
    ], BaseAppComponent);
    return BaseAppComponent;
}());
exports.BaseAppComponent = BaseAppComponent;
