import { ChangeDetectionStrategy, Type, ViewEncapsulation } from '@angular/core';
export interface AppComponentMetadata {
    selector?: string;
    inputs?: string[];
    outputs?: string[];
    properties?: string[];
    events?: string[];
    host?: {
        [key: string]: string;
    };
    bindings?: any[];
    providers?: any[];
    exportAs?: string;
    moduleId?: string;
    queries?: {
        [key: string]: any;
    };
    viewBindings?: any[];
    viewProviders?: any[];
    changeDetection?: ChangeDetectionStrategy;
    templateUrl?: string;
    template?: string;
    styleUrls?: string[];
    styles?: string[];
    directives?: Array<Type<any> | any[]>;
    pipes?: Array<Type<any> | any[]>;
    encapsulation?: ViewEncapsulation;
    productionMode?: boolean;
}
export declare function AppComponent(config: AppComponentMetadata): (cls: any) => any;
