"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var index_1 = require("./../factories/index");
var index_2 = require("./../services/index");
var index_3 = require("./index");
var CustomizeableDetailComponent = (function () {
    function CustomizeableDetailComponent(logger_ODC, componentResolver, injector_ODC, elementRef_ODC, cd_ODC) {
        this.logger_ODC = logger_ODC;
        this.componentResolver = componentResolver;
        this.injector_ODC = injector_ODC;
        this.elementRef_ODC = elementRef_ODC;
        this.cd_ODC = cd_ODC;
        this.controls = new Array();
        this.initializationComplete = new core_1.EventEmitter();
        this.componentsToPrepare = -1;
        this.customizeComponents = null;
        logger_ODC.log("Customizeable support initiated!");
        var that = this;
        var factory = this.injector_ODC.get(index_1.ComponentCustomizationFactory);
        this.customizeComponents = factory.getAllComponentCustomization(this.getCustomizeListeners());
        this.componentsToPrepare = this.customizeComponents.length;
        this.initializationComplete.subscribe(function (next_val) {
            that.cd_ODC.detectChanges();
        });
    }
    CustomizeableDetailComponent.prototype.getCustomizeListeners = function () {
        return [this["constructor"].toString().match(/\w+/g)[1]];
    };
    CustomizeableDetailComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        var that = this;
        var customizeComponentsLeft = new core_1.EventEmitter();
        var createdComponents = new Array();
        customizeComponentsLeft.subscribe(function (_x) {
            that.componentsToPrepare--;
            if (that.componentsToPrepare <= 0) {
                _this.controls.map(function (desc) {
                    var componentCreate = function (newComp, propPlaceHolder) {
                        that.logger_ODC.log(" *** //// *** Control loaded at (" + propPlaceHolder + ")");
                        that.controls.filter(function (x) { return x.placeHolder == propPlaceHolder; }).map(function (x) { return x.componentInstance = newComp.instance; });
                    };
                    if (_this.placeHolders.filter(function (comp) { return comp.name == desc.placeHolder; }).length == 0) {
                        that.logger_ODC.log('*** * ** ** No Anchor ' + desc.placeHolder);
                    }
                    else {
                        console.log(desc.controlComponent);
                        var childComponent = _this.componentResolver.resolveComponentFactory(desc.controlComponent);
                        var newComp = _this.placeHolders.filter(function (comp) { return comp.name == desc.placeHolder; })[0].container.createComponent(childComponent);
                        newComp.instance.setParentComponent(that, desc.propertyName);
                        componentCreate(newComp, desc.placeHolder);
                    }
                });
                createdComponents.map(function (comp) {
                    if (comp.instance.postControlsCreatedCallback)
                        comp.instance.postControlsCreatedCallback();
                });
                _this.initializationComplete.next(1);
            }
        });
        if (this.componentsToPrepare == 0)
            customizeComponentsLeft.next(0);
        this.customizeComponents.map(function (desc) {
            var componentCreate = function (newComp) {
                if (newComp.instance.initializationComplete && newComp.instance.componentsToPrepare && newComp.instance.componentsToPrepare > 0) {
                    newComp.instance.initializationComplete.subscribe(function (comp) {
                        createdComponents.push(newComp);
                        customizeComponentsLeft.next(0);
                    });
                }
                else {
                    createdComponents.push(newComp);
                    customizeComponentsLeft.next(0);
                }
            };
            if (_this.placeHolders.filter(function (comp) { return comp.name == desc.placeHolder; }).length == 0) {
                that.logger_ODC.log('*** * ** ** No Anchor ' + desc.hostElementPlaceHolder);
            }
            else {
                var childComponent = _this.componentResolver.resolveComponentFactory(desc.customizeComponents);
                var newComp = _this.placeHolders.filter(function (comp) { return comp.name == desc.placeHolder; })[0].container.createComponent(childComponent);
                componentCreate(newComp);
            }
        });
    };
    __decorate([
        core_1.ViewChildren(index_3.PlaceholderComponent, { read: "ViewContainerRef" }), 
        __metadata('design:type', core_1.QueryList)
    ], CustomizeableDetailComponent.prototype, "placeHolders", void 0);
    CustomizeableDetailComponent = __decorate([
        core_1.Component({
            template: "<div #DEFAULTANCHOR></div>"
        }),
        core_1.Injectable(), 
        __metadata('design:paramtypes', [index_2.TestLogger, core_1.ComponentFactoryResolver, core_1.Injector, core_1.ViewContainerRef, core_1.ChangeDetectorRef])
    ], CustomizeableDetailComponent);
    return CustomizeableDetailComponent;
}());
exports.CustomizeableDetailComponent = CustomizeableDetailComponent;
