"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var domhandler_1 = require("primeng/components/dom/domhandler");
var index_1 = require("../services/index");
var index_2 = require("../models/index");
var ForgotPasswordComponent = (function () {
    function ForgotPasswordComponent(fb, formsLoginService, notifications, _currentZone) {
        this.fb = fb;
        this.formsLoginService = formsLoginService;
        this.notifications = notifications;
        this._currentZone = _currentZone;
        this.forgotPasswordData = new index_2.ForgotPasswordData();
        this.busy = false;
        this.submitAttempt = false;
        this.errorMessage = "";
        var that = this;
        this.forgotPasswordForm = fb.group({
            UserName: ["", forms_1.Validators.compose([this.emailValidator(), forms_1.Validators.required])],
            RedirectUrl: []
        });
        domhandler_1.DomHandler.zindex = 10000;
    }
    ForgotPasswordComponent.prototype.onSubmit = function () {
        var that = this;
        if (this.forgotPasswordForm.valid) {
            this.forgotPasswordData.RedirectUrl = window.location.origin;
            this.formsLoginService.forgotPassword(this.forgotPasswordData).then(function (res) {
                if (res.isSuccess == true) {
                    that.notifications.emitter.emit({ severity: 'info', summary: 'Success!', detail: "A reset password email has been sent to " + that.forgotPasswordData.UserName + ". Please check it for further information." });
                }
                else {
                    that.notifications.emitter.emit({ severity: 'error', summary: 'Error!', detail: res.message });
                }
            });
            this.submitAttempt = false;
        }
        else
            this.submitAttempt = true;
    };
    ForgotPasswordComponent.prototype.emailValidator = function () {
        return function (ac) {
            if (ac.value == "" || ac.value.match(/[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?/)) {
                return null;
            }
            else {
                return { invalidEmailAddress: true };
            }
        };
    };
    ForgotPasswordComponent = __decorate([
        core_1.Component({
            selector: 'forgot-password-component',
            providers: [forms_1.ReactiveFormsModule, index_1.FormsLoginService],
            template: '<busy-overlay [busy]="busy"></busy-overlay><section class="body-sign appear-animation fadeInUp appear-animation-visible" *ngIf="!_loginInfo_.UserLoggedIn"><div class="center-sign"><a href="#" class="logo pull-left"></a><div class="panel panel-sign" *ngIf="!_resetPass"><div class="panel-title-sign mt-xl text-right"><h2 class="title text-uppercase text-weight-bold m-none"><i class="fa fa-user mr-xs"></i>Forgot your password</h2></div><div class="panel-body"><form [formGroup]="loginForm" (ngSubmit)="onSignInSubmit()"><div class="form-group mb-lg"><label>Username</label><div class="input-group input-group-icon"><input formControlName="UserName" type="text" [(ngModel)]="loginData.UserName" class="form-control input-lg"> <span class="input-group-addon"><span class="icon icon-lg"><i class="fa fa-user"></i></span></span></div><div *ngIf="loginForm.controls[\'UserName\'].hasError(\'required\') && !loginForm.controls[\'UserName\'].pristine" class="ui error message">Username is required</div></div><div class="form-group mb-lg"><div class="clearfix"><label class="pull-left">Password</label></div><div class="input-group input-group-icon"><input formControlName="Password" type="password" [(ngModel)]="loginData.Password" class="form-control input-lg"> <span class="input-group-addon"><span class="icon icon-lg"><i class="fa fa-lock"></i></span></span></div><div class="clearfix"><a role="button" (click)="_resetPass=true" class="pull-right">Lost Password?</a></div></div><div class="row"><div class="col-sm-8"><div class="checkbox-custom checkbox-default"><input formControlName="PersistCookie" [(ngModel)]="loginData.PersistCookie" type="checkbox"> <label for="RememberMe">Remember Me</label></div></div><div class="col-sm-4 text-right"><button class="btn btn-primary" [disabled]="!loginForm.valid" #submitButton>Sign In</button> <button class="btn btn-default hidden" type="button" [disabled]="!_loginInfo_.UserLoggedIn" #logoutButton><span class="glyphicon glyphicon-log-out" aria-hidden="true"></span></button></div></div><div class="row" *ngIf="!_loginInfo_.Success"><div class="col-sm-12"><div class="alert alert-danger">{{ _loginInfo_.Message }}</div></div></div></form></div></div><div class="panel panel-sign" *ngIf="_resetPass"><div class="panel-title-sign mt-xl text-right"><h2 class="title text-uppercase text-weight-bold m-none"><i class="fa fa-user mr-xs"></i> Recover Password</h2></div><div class="panel-body"><div class="alert alert-info"><p class="m-none text-weight-semibold h6">Enter your Username below and we will send you reset instructions to your registered Email!</p></div><form [formGroup]="resetForm" (ngSubmit)="onResetSubmit()"><div class="form-group mb-none"><div class="input-group"><input formControlName="UserName" [(ngModel)]="resetData.UserName" placeholder="User name" class="form-control input-lg"> <span class="input-group-btn"><button class="btn btn-primary btn-lg" [disabled]="!resetForm.valid" #submitButton>Reset!</button></span></div></div><p class="text-center mt-lg">Remembered? <a role="button" (click)="_resetPass=false">Sign In!</a></p></form></div></div></div></section>'
        }),
        core_1.Injectable(), 
        __metadata('design:paramtypes', [forms_1.FormBuilder, index_1.FormsLoginService, index_1.NotificationService, core_1.NgZone])
    ], ForgotPasswordComponent);
    return ForgotPasswordComponent;
}());
exports.ForgotPasswordComponent = ForgotPasswordComponent;
