"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var forms_1 = require('@angular/forms');
var router_1 = require('@angular/router');
var index_1 = require('./../services/index');
var index_2 = require('./../interfaces/index');
var index_3 = require('./../models/index');
var index_4 = require('./index');
var core_2 = require('../basecode/core');
var index_5 = require('./../controls/index');
var GenericFormComponent = (function (_super) {
    __extends(GenericFormComponent, _super);
    function GenericFormComponent(logger, entityService, dynamicComponentLoader, injector, elementRef, fb, cd, zone, router) {
        var _this = this;
        _super.call(this, logger, dynamicComponentLoader, injector, elementRef, cd);
        this.logger = logger;
        this.entityService = entityService;
        this.dynamicComponentLoader = dynamicComponentLoader;
        this.injector = injector;
        this.elementRef = elementRef;
        this.fb = fb;
        this.cd = cd;
        this.zone = zone;
        this.router = router;
        this.entity = null;
        this.showSubmit = true;
        this.formTitle = "";
        this.formSubTitle = "";
        this.entityType = index_3.BaseEntity;
        this.submitButtonName = "";
        this.closeButtonName = "Back";
        this.showCloseButton = true;
        this.showSubmitButton = true;
        this.comparedEntity = null;
        this.isHiddenView = true;
        this.controls = [];
        this.loaded = false;
        this.busy = false;
        this.entitySaved = new core_1.EventEmitter();
        this.formSubmitted = new core_1.EventEmitter();
        this.formCancelled = new core_1.EventEmitter();
        this.entityChangeSubscription = null;
        this.subscription = null;
        this.subscription_param = null;
        this.errorSubscription = null;
        this.errorDescription = '';
        this.entityChangeSubscription = this.entityService.dataObserver.subscribe(function (updatedEntities) {
            _this.entity.setModelData(updatedEntities.data.find(function (ent) { return ent.ID === _this.entityID && ent instanceof _this.entityType; }));
            if (!_this.entity)
                _this.entity = _this.entityService.getDummy(_this.entityType);
        });
    }
    Object.defineProperty(GenericFormComponent.prototype, "entityEditing", {
        set: function (entity) {
            if (entity)
                this.entity = entity;
            else
                this.entity = null;
        },
        enumerable: true,
        configurable: true
    });
    GenericFormComponent.prototype.ngOnDestroy = function () {
        if (this.subscription != null)
            this.subscription.unsubscribe();
        if (this.entityChangeSubscription != null)
            this.entityChangeSubscription.unsubscribe();
        if (this.subscription_param != null)
            this.subscription_param.unsubscribe();
        if (this.errorSubscription != null)
            this.errorSubscription.unsubscribe();
    };
    GenericFormComponent.prototype.ngAfterViewInit = function () {
        _super.prototype.ngAfterViewInit.call(this);
        if (!this.showSubmit) {
            var btn = document.getElementById('btnGenericFormSubmit');
            btn.style.display = "none";
        }
    };
    GenericFormComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (this.entityType === index_3.BaseEntity)
            try {
                this.entityType = this.injector.get('entityType');
            }
            catch (e) {
                console.log("cant find entityType");
            }
        ;
        if (!this.entity && this.entityType)
            this.entity = new this.entityType();
        this.controls = this.entity.browseFields.map(function (col) {
            return {
                placeHolder: 'formStart', propertyName: col.Name, controlComponent: _this.setControlComponent(col), componentInstance: null
            };
        });
        var controls = {};
        this.entityForm = this.fb.group(controls);
        if (this.formTitle === "")
            this.formTitle = ((this.entity.ID || '').length == 0) ? 'New' : 'Edit';
        if (this.submitButtonName === "")
            this.submitButtonName = ((this.entity.ID || '').length == 0) ? ' Create' : ' Update';
        this.isRouteMappedComponent = true;
        this.logger.log("Generic detail form initiated!");
    };
    GenericFormComponent.prototype.refreshItem = function (id) {
        this.busy = true;
        var that = this;
        this.entityService.fetchEntity(this.entityType, id).then(function (entity) {
            return that.zone.run(function () {
                that.entity = entity;
                that.busy = false;
            });
        });
    };
    GenericFormComponent.prototype.onSubmit = function () {
        var myChangeID = "Generic_Detail_Form_" + (Math.random() * 1000013);
        this.busy = true;
        var that = this;
        if (this.subscription != null)
            this.subscription.unsubscribe();
        this.subscription = this.entityService.dataObserver.subscribe(function (updatedEntities) {
            if (updatedEntities.ID === myChangeID) {
                that.entity = updatedEntities.data[0];
                that.busy = false;
                that.entitySaved.emit(that.entity);
                if (that.isRouteMappedComponent)
                    window.history.back();
            }
        });
        if (this.errorSubscription != null)
            this.errorSubscription.unsubscribe();
        this.errorSubscription = this.entityService.errorObserver.subscribe(function (next) {
            if (next.ID === myChangeID) {
                that.zone.run(function () {
                    if (next.errorMessage)
                        that.errorDescription = next.errorMessage;
                    that.busy = false;
                });
            }
        });
        this.entityService.updateEntity(this.entityType, this.entity, myChangeID);
        this.formSubmitted.emit({ data: [this.entity], DataType: this.entityType, ChangeType: index_2.DataChangeType.Update, ID: myChangeID });
    };
    GenericFormComponent.prototype.onCancel = function () {
        this.formCancelled.emit(!this.entityForm.pristine);
        if (this.isRouteMappedComponent)
            window.history.back();
    };
    GenericFormComponent.prototype.setControlComponent = function (col) {
        if (col.DataType == core_2.DataTypeEnum.datetime)
            return index_5.DatePickerWrapperControl;
        else if (this.isReferenceField(col.Name))
            return index_5.DropDownAndAutoCompleteExtendedWrapperControl;
        else if (col.DataType === core_2.DataTypeEnum.boolean)
            return index_5.CheckboxWrapperControl;
        else if (col.DataType === core_2.DataTypeEnum.longstring)
            return index_5.SuperTextboxWrapperControl;
        return index_5.TextboxWrapperControl;
    };
    GenericFormComponent.prototype.isReferenceField = function (field) {
        return (field.length > 2 && field.endsWith('ID'));
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object), 
        __metadata('design:paramtypes', [Object])
    ], GenericFormComponent.prototype, "entityEditing", null);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], GenericFormComponent.prototype, "entityID", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], GenericFormComponent.prototype, "entity", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], GenericFormComponent.prototype, "showSubmit", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], GenericFormComponent.prototype, "formTitle", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], GenericFormComponent.prototype, "formSubTitle", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], GenericFormComponent.prototype, "entityType", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], GenericFormComponent.prototype, "submitButtonName", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], GenericFormComponent.prototype, "closeButtonName", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], GenericFormComponent.prototype, "showCloseButton", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], GenericFormComponent.prototype, "showSubmitButton", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], GenericFormComponent.prototype, "comparedEntity", void 0);
    __decorate([
        core_1.ViewChildren(index_4.PlaceholderComponent), 
        __metadata('design:type', core_1.QueryList)
    ], GenericFormComponent.prototype, "placeHolders", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], GenericFormComponent.prototype, "entitySaved", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], GenericFormComponent.prototype, "formSubmitted", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], GenericFormComponent.prototype, "formCancelled", void 0);
    GenericFormComponent = __decorate([
        core_1.Component({
            selector: 'generic-detail',
            template: "\n    \n<div #DEFAULTANCHOR></div>\n<form [formGroup]=\"entityForm\" (ngSubmit)=\"onSubmit()\" name=\"genericEditForm\">\n    <div #busyOverlayPlace></div>\n    <section class=\"panel\">\n        <header class=\"panel-heading\">\n            <h2 class=\"panel-title\">{{formTitle}}</h2>\n            <p class=\"panel-subtitle\">{{formSubTitle}}</p>\n        </header>\n        <div class=\"panel-body\">\n            <place-holder [name]=\"'formStart'\"></place-holder>\n            <div #formStart></div>\n            <div #formEnd></div>\n        </div>\n        <footer *ngIf=\"showSubmitButton || showCloseButton\" class=\"panel-footer\">\n            <div #formFooter></div>\n            <div class=\"row\" *ngIf=\"errorDescription.length > 0\">\n                <div class=\"alert alert-danger\">\n                    {{errorDescription}}\n                </div>\n            </div>\n            <div class=\"row\">\n                <div>\n                        <button id=\"btnGenericFormSubmit\" class=\"btn btn-primary\"  type=\"button\" *ngIf=\"showSubmitButton\" (click)=\"onSubmit()\" [disabled]=\"!entityForm.valid || entityForm.pristine\"><i class=\"fa fa-save\"></i>{{submitButtonName}}</button>\n                        <button class=\"btn btn-default ml-xs\" type=\"button\" *ngIf=\"showCloseButton\" (click)=\"onCancel()\"><i class=\"fa fa-reply\" style=\"color:#000\"></i>{{closeButtonName}}</button>\n                </div>\n            </div>\n        </footer>\n    </section>\n</form>\n        "
        }),
        core_1.Injectable(), 
        __metadata('design:paramtypes', [index_1.TestLogger, index_2.IEntityDataService, core_1.ComponentFactoryResolver, core_1.Injector, core_1.ViewContainerRef, forms_1.FormBuilder, core_1.ChangeDetectorRef, core_1.NgZone, router_1.ActivatedRoute])
    ], GenericFormComponent);
    return GenericFormComponent;
}(index_4.CustomizeableDetailComponent));
exports.GenericFormComponent = GenericFormComponent;
var EntityChangeService = (function () {
    function EntityChangeService() {
    }
    EntityChangeService.entityChange = new core_1.EventEmitter();
    EntityChangeService.entityTypeChange = new core_1.EventEmitter();
    EntityChangeService.entiTyIDChange = new core_1.EventEmitter();
    EntityChangeService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [])
    ], EntityChangeService);
    return EntityChangeService;
}());
exports.EntityChangeService = EntityChangeService;
var EntityWithType = (function () {
    function EntityWithType(key, type) {
        this.key = key;
        this.type = type;
    }
    return EntityWithType;
}());
exports.EntityWithType = EntityWithType;
