"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var core_2 = require('@angular/core');
var index_1 = require("../interfaces/index");
var index_2 = require("../services/index");
var IProfilePageComponent = (function () {
    function IProfilePageComponent(entityService, loginService, notifications) {
        this.entityService = entityService;
        this.loginService = loginService;
        this.notifications = notifications;
        this.entitySaved = new core_2.EventEmitter();
        this.formSubmitted = new core_2.EventEmitter();
        this.busy = false;
        this.inProgressChangeID = null;
        this.errorDescription = {};
        var that = this;
        this.entityService.dataObserver.subscribe(function (dataChanged) {
            if (that.inProgressChangeID && that.inProgressChangeID == dataChanged.ID) {
                that.inProgressChangeID = null;
                that.busy = false;
                if (that.entitySaved) {
                    dataChanged.data.map(function (data) {
                        that.entitySaved.next(data);
                    });
                }
            }
        });
        this.entityService.registerNewChangesStream(this.formSubmitted);
    }
    IProfilePageComponent.prototype.emailValidator = function () {
        return function (ac) {
            if (ac.value) {
                var emailReg = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
                if (!emailReg.test(ac.value))
                    return { invalidEmail: true };
            }
        };
    };
    __decorate([
        core_2.Input(), 
        __metadata('design:type', Object)
    ], IProfilePageComponent.prototype, "entityEditing", void 0);
    __decorate([
        core_2.Output(), 
        __metadata('design:type', core_2.EventEmitter)
    ], IProfilePageComponent.prototype, "entitySaved", void 0);
    __decorate([
        core_2.Output(), 
        __metadata('design:type', core_2.EventEmitter)
    ], IProfilePageComponent.prototype, "formSubmitted", void 0);
    __decorate([
        core_2.Output(), 
        __metadata('design:type', Boolean)
    ], IProfilePageComponent.prototype, "busy", void 0);
    IProfilePageComponent = __decorate([
        core_1.Component({
            selector: 'user-profile',
            template: '<p>Your principal name is: {{ userName }}</p><p>Roles that you have:</p><li *ngFor="let role of roleName"><ul>{{role}}</ul></li>',
        }),
        core_1.Injectable(), 
        __metadata('design:paramtypes', [index_1.IEntityDataService, index_1.ILoginService, index_2.NotificationService])
    ], IProfilePageComponent);
    return IProfilePageComponent;
}());
exports.IProfilePageComponent = IProfilePageComponent;
