"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
exports.IMAGE_ERRORS = {
    IMAGE_FAILED_TO_LOAD: 0,
    SMALL_IMAGE: 1,
};
var ProfilePictureComponent = (function () {
    function ProfilePictureComponent() {
        this.strURIImageFormat = 'data:image/png;base64,';
        this.defaultImg = "/css/user_no_image.jpg";
        this.isShowError = false;
        this.isShowSaveButton = false;
        this.errorMessage = "";
        this.limitsize = 5;
        this.widthImg = 250;
        this.heightImg = 250;
        this.changeProfilePictureUrl = '';
        this.changeProfilePictureEvent = new core_1.EventEmitter();
    }
    ProfilePictureComponent.prototype.ngOnInit = function () {
        var that = this;
        jQuery('.image-editor').cropit({
            onImageError: function (e) {
                that.onCheckImageSize(e.code);
            },
            onImageLoaded: function (e) {
                that.busy = false;
            }
        });
        jQuery('input.cropit-image-input').css("width", this.widthImg);
        jQuery('.image-editor').cropit('previewSize', { width: this.widthImg, height: this.heightImg });
    };
    ProfilePictureComponent.prototype.onCheckImageSize = function (errorCode) {
        var that = this;
        that.isShowSaveButton = false;
        that.isShowError = true;
        if (exports.IMAGE_ERRORS.SMALL_IMAGE == errorCode) {
            that.errorMessage = "Please use an image that's at least " + that.widthImg + "px in width and " + that.heightImg + "px in height.";
        }
        else if (exports.IMAGE_ERRORS.IMAGE_FAILED_TO_LOAD == errorCode) {
            that.errorMessage = "Can not load this image, please try another image.";
        }
        jQuery('.image-editor').cropit('imageSrc', this.defaultImg);
        that.busy = false;
    };
    ProfilePictureComponent.prototype.setProfilePicture = function (value) {
        var that = this;
        if (value) {
            that.defaultImg = that.strURIImageFormat + value;
        }
        jQuery('.image-editor').cropit('imageSrc', that.defaultImg);
        jQuery('.image-editor').cropit('disable');
    };
    ProfilePictureComponent.prototype.onEnableCropit = function () {
        jQuery('.image-editor').cropit('reenable');
    };
    ProfilePictureComponent.prototype.onEditPictureChange = function () {
        var that = this;
        that.busy = true;
        that.isShowError = false;
        that.errorMessage = "";
        that.isShowSaveButton = false;
        var fileControl = jQuery('input.cropit-image-input');
        var image = fileControl.prop('files')[0];
        if ((image.size / (1024 * 1024)) > that.limitsize) {
            fileControl.val("");
            that.errorMessage = "Please use an image smaller than " + that.limitsize + " MB.";
            that.isShowError = true;
            that.busy = false;
            jQuery('.image-editor').cropit('imageSrc', this.defaultImg);
        }
        else {
            that.isShowSaveButton = true;
        }
    };
    ProfilePictureComponent.prototype.onChangeImg = function () {
        var imageData = jQuery('.image-editor').cropit('export', {
            type: 'image/png',
            quality: 0.55
        }) + '';
        this.defaultImg = imageData;
        jQuery('.image-editor').cropit('disable');
        this.isShowSaveButton = false;
        jQuery('input.cropit-image-input').val("");
        this.updateProfilePicture(imageData.substring(22));
    };
    ProfilePictureComponent.prototype.onCancelImg = function () {
        jQuery('.image-editor').cropit('imageSrc', this.defaultImg);
        this.isShowSaveButton = false;
        jQuery('input.cropit-image-input').val("");
        var imageData = jQuery('.image-editor').cropit('disable');
    };
    ProfilePictureComponent.prototype.updateProfilePicture = function (imageData) {
        this.changeProfilePictureEvent.emit(this.convertStringToByteArray(imageData));
    };
    ProfilePictureComponent.prototype.convertByteArrayToString = function (dataByteArray) {
        var dataString = "";
        for (var i = 0; i < dataByteArray.length; i++) {
            dataString += String.fromCharCode(dataByteArray[i]);
        }
        return dataString;
    };
    ProfilePictureComponent.prototype.convertStringToByteArray = function (dataBinaryStr) {
        var byteNumbers = [];
        for (var i = 0; i < dataBinaryStr.length; i++) {
            byteNumbers.push(dataBinaryStr.charCodeAt(i));
        }
        return byteNumbers;
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], ProfilePictureComponent.prototype, "limitsize", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], ProfilePictureComponent.prototype, "widthImg", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], ProfilePictureComponent.prototype, "heightImg", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], ProfilePictureComponent.prototype, "changeProfilePictureUrl", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], ProfilePictureComponent.prototype, "changeProfilePictureEvent", void 0);
    ProfilePictureComponent = __decorate([
        core_1.Component({
            selector: 'profile-picture',
            template: '<div class="row"><div class="image-editor"><input type="file" class="cropit-image-input btn btn-primary" (change)="onEditPictureChange()" (click)="onEnableCropit()"><div class="cropit-preview"><busy-overlay [busy]="busy"></busy-overlay></div><div *ngIf="isShowSaveButton && !busy" class="edit-picture-profile edit-buttons"><button class="btn btn-default" (click)="onCancelImg()">Cancel</button> <button class="btn btn-primary" (click)="onChangeImg()">OK</button></div><div *ngIf="isShowError" class="alert alert-danger error-panel">{{ errorMessage }}</div></div></div>',
            styleUrls: ['templates/components/profile-picture.component.css']
        }),
        core_1.Injectable(), 
        __metadata('design:paramtypes', [])
    ], ProfilePictureComponent);
    return ProfilePictureComponent;
}());
exports.ProfilePictureComponent = ProfilePictureComponent;
