"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var index_1 = require("../services/index");
var index_2 = require("../models/index");
var RegisterComponent = (function () {
    function RegisterComponent(fb, formsLoginService, currentZone, notifications) {
        this.fb = fb;
        this.formsLoginService = formsLoginService;
        this.currentZone = currentZone;
        this.notifications = notifications;
        this.registerData = new index_2.RegisterData();
        this.submitAttempt = false;
        this.busy = false;
        this.errorMessage = "";
        var that = this;
        this.registerForm = fb.group({
            UserName: ["", forms_1.Validators.required],
            Password: ["", forms_1.Validators.compose([this.passwordValidator(), forms_1.Validators.required])],
            ConfirmPassword: ["", forms_1.Validators.required]
        }, { validator: that.matchingPasswords('Password', 'ConfirmPassword') });
    }
    RegisterComponent.prototype.onRegisterSubmit = function () {
        if (!this.registerForm.valid) {
            this.submitAttempt = true;
            return;
        }
        else {
            this.errorMessage = "";
            var that = this;
            this.submitAttempt = false;
            this.registerData.RedirectUrl = window.location.origin;
            this.formsLoginService.register(this.registerData).then(function (res) {
                if (res == "true") {
                    that.notifications.emitter.emit({ severity: 'info', summary: 'Success!', detail: "A register activate email has been sent to " + that.registerData.Email + ". Please check it for further information." });
                }
                else {
                    that.errorMessage = res;
                }
            });
        }
    };
    RegisterComponent.prototype.matchingPasswords = function (passwordKey, confirmPasswordKey) {
        return function (group) {
            var password = group.controls[passwordKey];
            var confirmPassword = group.controls[confirmPasswordKey];
            if (password.value !== confirmPassword.value) {
                return {
                    mismatchedPasswords: true
                };
            }
        };
    };
    RegisterComponent.prototype.passwordValidator = function () {
        return function (ac) {
            if (ac.value) {
                if (ac.value.match(/^(?=.*[A-Z])(?=.*[0-9])(?=.*(\d|\W)).{8,100}$/)) {
                    return null;
                }
                else {
                    return { invalidPassword: true };
                }
            }
        };
    };
    RegisterComponent = __decorate([
        core_1.Component({
            selector: 'register-component',
            providers: [forms_1.ReactiveFormsModule, index_1.FormsLoginService],
            template: '<div class="container"><div class="row"><div class="col-md-12 text-center"><a href="/"><img alt="ArchivComplete" src="/css/logo.svg" class="ac-logo ac-logo-account"></a></div></div><form [formGroup]="registerForm" (ngSubmit)="onRegisterSubmit()"><div class="row"><div class="col-md-4 col-md-offset-4"><div class="panel panel-default ac-login-panel"><div class="panel-heading"><h2 class="panel-title">Create new account</h2></div><div class="panel-body"><div class="form-group"><label for="UserName">Email</label> <input class="form-control" formControlName="Email" placeholder="Email" type="text"> <span *ngIf="registerForm.controls[\'Email\'].hasError(\'required\') && !registerForm.controls[\'Email\'].pristine" class="field-validation-valid">Username is required</span></div><div class="form-group"><label for="Password">Password</label> <input class="form-control" formControlName="Password" placeholder="Password" type="text"> <span *ngIf="registerForm.controls[\'Password\'].hasError(\'required\') && !registerForm.controls[\'Password\'].pristine" class="field-validation-valid">Password is required</span></div><div class="form-group"><label for="ConfirmPassword">Confirm password</label> <input class="form-control" formControlName="ConfirmPassword" placeholder="ConfirmPassword" type="text"> <span *ngIf="registerForm.controls[\'ConfirmPassword\'].hasError(\'required\') && !registerForm.controls[\'ConfirmPassword\'].pristine" class="field-validation-valid">Confirm Password is required</span></div><button type="submit" class="btn btn-success" [disabled]="!registerForm.valid" #submitButton>Create account</button></div></div></div></div></form></div>'
        }),
        core_1.Injectable(), 
        __metadata('design:paramtypes', [forms_1.FormBuilder, index_1.FormsLoginService, core_1.NgZone, index_1.NotificationService])
    ], RegisterComponent);
    return RegisterComponent;
}());
exports.RegisterComponent = RegisterComponent;
