"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var index_1 = require("../services/index");
var index_2 = require("../models/index");
var ResetPasswordComponent = (function () {
    function ResetPasswordComponent(fb, formsLoginService, router, notifications, activatedRoute) {
        this.fb = fb;
        this.formsLoginService = formsLoginService;
        this.router = router;
        this.notifications = notifications;
        this.activatedRoute = activatedRoute;
        this.busy = false;
        this._entity = new index_2.ResetPasswordData();
        this._confirmPassword = "";
        this._matched = true;
        this.errorMessage = "";
        this.resetPasswordForm = fb.group({
            NewPassword: ['', forms_1.Validators.compose([this.passwordRangeValidator(), this.passwordStrongValidator(), forms_1.Validators.required])],
            ConfirmPassword: ['', forms_1.Validators.required]
        });
    }
    ResetPasswordComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.routerSubscribe = this.activatedRoute.params.subscribe(function (params) {
            _this._entity.UserId = params['userId'];
            _this._entity.PasswordResetToken = params['token'];
        });
    };
    ResetPasswordComponent.prototype.onSubmit = function () {
        this.busy = true;
        var that = this;
        this.formsLoginService.resetPasswordWithToken(this._entity).then(function (res) {
            if (res.isSuccess == true) {
                that.notifications.emitter.emit({ severity: 'info', summary: 'Success!', detail: res.message });
            }
            else {
                that.notifications.emitter.emit({ severity: 'error', summary: 'Error!', detail: res.message });
            }
            that.busy = false;
        });
    };
    ResetPasswordComponent.prototype.checkMatched = function () {
        this._matched = (this._entity.NewPassword === this._confirmPassword) && this.resetPasswordForm.controls['ConfirmPassword'].touched;
    };
    ResetPasswordComponent.prototype.passwordStrongValidator = function () {
        return function (ac) {
            if (ac.value) {
                var isContainNumber = false;
                var isContainUpcaseCharacter = false;
                for (var i = 0; i < ac.value.length; i++) {
                    var character = ac.value.charAt(i);
                    if (!isNaN(character * 1))
                        isContainNumber = true;
                    else {
                        if (!isContainUpcaseCharacter && character == character.toUpperCase())
                            isContainUpcaseCharacter = true;
                    }
                }
                if (!isContainNumber || !isContainUpcaseCharacter)
                    return { invalidPassword: true };
            }
        };
    };
    ResetPasswordComponent.prototype.passwordRangeValidator = function () {
        return function (ac) {
            if (ac.value && ac.value.length < 8)
                return { invalidRange: true };
        };
    };
    ResetPasswordComponent = __decorate([
        core_1.Component({
            selector: 'resetpassword-component',
            providers: [forms_1.ReactiveFormsModule, index_1.FormsLoginService],
            template: '<div *ngIf="busy" class="inside-div-overlay"><img class="working-icon" src="./../css/cog11.svg" data-cog="cog11"></div><section class="body-sign appear-animation fadeInUp appear-animation-visible"><div class="center-sign"><form class="form-horizontal" [formGroup]="resetPasswordForm" (ngSubmit)="onSubmit()"><section class="panel panel-primary"><header class="panel-heading"><h2 class="panel-title">Reset Password</h2><p class="panel-subtitle">Type in your new password below.</p></header><div class="panel-body"><div class="form-group"><label class="col-sm-4 control-label">New Password:</label><div class="col-sm-8"><input type="password" class="form-control" formControlName="NewPassword" [(ngModel)]="_entity.NewPassword" placeholder="New password"> <label *ngIf="resetPasswordForm.controls[\'NewPassword\'].hasError(\'invalidRange\') && !resetPasswordForm.controls[\'NewPassword\'].pristine" class="error">At least 8 characters</label> <label *ngIf="!resetPasswordForm.controls[\'NewPassword\'].hasError(\'invalidRange\') && resetPasswordForm.controls[\'NewPassword\'].hasError(\'invalidPassword\') && !resetPasswordForm.controls[\'NewPassword\'].pristine" class="error">Password musts have 1 capital letter and 1 number.</label></div></div><div class="form-group"><label class="col-sm-4 control-label">Confirm Password:</label><div class="col-sm-8"><input type="password" class="form-control" formControlName="ConfirmPassword" [(ngModel)]="_confirmPassword" placeholder="Confirm password" (ngModelChange)="checkMatched()"> <label *ngIf="!_matched" class="error">Confirm Password does not match.</label></div></div></div><footer class="panel-footer"><button class="btn btn-primary" #submitButton [disabled]="!_matched">Change password</button></footer></section></form></div></section>'
        }), 
        __metadata('design:paramtypes', [forms_1.FormBuilder, index_1.FormsLoginService, router_1.Router, index_1.NotificationService, router_1.ActivatedRoute])
    ], ResetPasswordComponent);
    return ResetPasswordComponent;
}());
exports.ResetPasswordComponent = ResetPasswordComponent;
