"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var index_1 = require("./../interfaces/index");
var index_2 = require('./../components/index');
var AutocompleteExtendedJqueryControl = (function () {
    function AutocompleteExtendedJqueryControl(cd, elRef, dataSource, dynamicComponentLoader, container) {
        this.elRef = elRef;
        this.dataSource = dataSource;
        this.dynamicComponentLoader = dynamicComponentLoader;
        this.container = container;
        this.id = "";
        this.disabled = false;
        this.additionalFilters = [];
        this.styleClass = '';
        this.displayProperty = "Name";
        this.top = 30;
        this.isHighlight = false;
        this.showPopup = new core_1.EventEmitter();
        this.changeEvent = new core_1.EventEmitter();
        this.saveEvent = new core_1.EventEmitter();
        this.entitySubmitted = new core_1.EventEmitter();
        this.selected = new core_1.EventEmitter();
        this.idString = "";
        cd.valueAccessor = this;
        this.controlID = ++AutocompleteExtendedJqueryControl.staticID;
    }
    AutocompleteExtendedJqueryControl.prototype.getValue = function () {
        return this.id;
    };
    AutocompleteExtendedJqueryControl.prototype.registerOnChange = function (fn) {
        this.changeEvent.subscribe(fn);
    };
    AutocompleteExtendedJqueryControl.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    AutocompleteExtendedJqueryControl.prototype.writeValue = function (valueID) {
        var _this = this;
        if (!valueID) {
            this.idString = "";
            return;
        }
        if (!this.id || this.id !== valueID) {
            this.id = valueID;
            if (this.entityType) {
                this.dataSource.fetchEntity(this.entityType, valueID).then(function (rest) { _this.idString = rest[_this.displayProperty]; });
            }
        }
    };
    AutocompleteExtendedJqueryControl.prototype.setValue = function (valueID) {
        var _this = this;
        this.id = valueID;
        this.onTouched();
        this.changeEvent.next(valueID);
        if (this.id && this.id !== '') {
            this.dataSource.fetchEntity(this.entityType, valueID).then(function (rest) { _this.idString = rest[_this.displayProperty]; });
        }
        else
            this.idString = null;
    };
    AutocompleteExtendedJqueryControl.prototype.onAdd = function () {
        this.showPopup.next('');
        this.popupComponentInstance.formTitle = "Add new";
        this.popupComponentInstance.entityEditing = new this.entityType();
        this.popupComponentInstance.isHiddenView = false;
        jQuery(this.modalPopup.nativeElement).modal('show');
    };
    AutocompleteExtendedJqueryControl.prototype.ngAfterViewInit = function () {
        var _this = this;
        var that = this;
        if (this.entityType && this.id && this.id !== '') {
            this.dataSource.fetchEntity(this.entityType, this.id).then(function (rest) { _this.idString = rest[_this.displayProperty]; });
        }
        if (!this.additionalFilters)
            this.additionalFilters = [];
        if (that.sortArray) {
            that.sort = that.sortArray.join(",");
        }
        else {
            that.sort = that.displayProperty;
        }
        jQuery(this.elRef.nativeElement).find("#inputCon").attr('id', 'inputCon_SuperAC_' + this.controlID);
        jQuery(this.elRef.nativeElement).find('#inputCon_SuperAC_' + this.controlID).autocomplete({
            source: function (request, response) {
                that.dataSource.loadData(that.entityType, [{ Field: that.displayProperty, Operator: "startsWith", Term: request.term }].concat(that.additionalFilters), [], that.sort, (request.term.length == 0) ? that.top : null, null).then(function (res) {
                    response(Array.from(res.records, function (rec) { return { value: rec[that.displayProperty], id: rec.ID }; }));
                }).catch(function (err) {
                    console.log("Error while filtering data: " + err);
                });
            },
            minLength: 0,
            select: function (event, ui) {
                that.changeEvent.next(ui.item.id);
                that.idString = ui.item.value;
                that.selected.next(ui.item);
            },
            focus: function (event, ui) {
                event.preventDefault();
                jQuery(that.elRef.nativeElement).find('#inputCon_SuperAC_' + that.controlID).val(ui.item.value);
            },
            change: function (event, ui) {
                if (that.idString != jQuery(that.elRef.nativeElement).find('#inputCon_SuperAC_' + that.controlID).val()) {
                    jQuery(that.elRef.nativeElement).find('#inputCon_SuperAC_' + that.controlID).val("");
                    that.idString = "";
                    that.changeEvent.next(null);
                }
            }
        }).focus(function () {
            jQuery(this).autocomplete("search", jQuery(this).val());
        });
    };
    AutocompleteExtendedJqueryControl.prototype.ngAfterContentInit = function () {
        var that = this;
        jQuery(that.modalPopup.nativeElement).modal('hide');
        var Comp = that.dynamicComponentLoader.resolveComponentFactory(that.popupComponent);
        var newComp = that.placeHolders.container.createComponent(Comp, 0, this.dynamicBinding);
        that.popupComponentInstance = newComp.instance;
        that.popupComponentInstance.formSubmitted.subscribe(function (next) {
            that.entitySubmitted.emit(next);
        });
        that.popupComponentInstance.formCancelled.subscribe(function (hasChanges) {
            that.popupComponentInstance.isHiddenView = true;
            jQuery(that.modalPopup.nativeElement).modal('hide');
        });
        that.popupComponentInstance.entitySaved.subscribe(function (nextValue) {
            that.popupComponentInstance.isHiddenView = true;
            jQuery(that.modalPopup.nativeElement).modal('hide');
            that.saveEvent.next(nextValue);
            that.idString = nextValue[that.displayProperty];
            if (that.id != nextValue.ID) {
                that.writeValue(nextValue.ID);
                that.changeEvent.emit(nextValue.ID);
                that.selected.emit(nextValue.ID);
            }
        });
    };
    AutocompleteExtendedJqueryControl.prototype.changeZIndex = function () {
        var autocomplele = document.getElementsByClassName('ui-autocomplete ui-front ui-menu ui-widget ui-widget-content');
        for (var i = 0; i < autocomplele.length; i++) {
            var temp = document.getElementById(autocomplele.item(i).id);
            temp.style.setProperty("z-index", "1055");
        }
    };
    AutocompleteExtendedJqueryControl.staticID = 1;
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], AutocompleteExtendedJqueryControl.prototype, "id", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], AutocompleteExtendedJqueryControl.prototype, "entityType", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], AutocompleteExtendedJqueryControl.prototype, "popupComponent", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], AutocompleteExtendedJqueryControl.prototype, "disabled", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], AutocompleteExtendedJqueryControl.prototype, "additionalFilters", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], AutocompleteExtendedJqueryControl.prototype, "styleClass", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], AutocompleteExtendedJqueryControl.prototype, "displayProperty", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], AutocompleteExtendedJqueryControl.prototype, "sortArray", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], AutocompleteExtendedJqueryControl.prototype, "top", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], AutocompleteExtendedJqueryControl.prototype, "isHighlight", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', core_1.ReflectiveInjector)
    ], AutocompleteExtendedJqueryControl.prototype, "dynamicBinding", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], AutocompleteExtendedJqueryControl.prototype, "showPopup", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], AutocompleteExtendedJqueryControl.prototype, "changeEvent", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], AutocompleteExtendedJqueryControl.prototype, "saveEvent", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], AutocompleteExtendedJqueryControl.prototype, "entitySubmitted", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], AutocompleteExtendedJqueryControl.prototype, "selected", void 0);
    __decorate([
        core_1.HostListener('blur', ['$event']), 
        __metadata('design:type', Function)
    ], AutocompleteExtendedJqueryControl.prototype, "onTouched", void 0);
    __decorate([
        core_1.ViewChild(core_1.forwardRef(function () { return index_2.PlaceholderComponent; })), 
        __metadata('design:type', index_2.PlaceholderComponent)
    ], AutocompleteExtendedJqueryControl.prototype, "placeHolders", void 0);
    __decorate([
        core_1.ViewChild("lookupPopupModal"), 
        __metadata('design:type', core_1.ElementRef)
    ], AutocompleteExtendedJqueryControl.prototype, "modalPopup", void 0);
    AutocompleteExtendedJqueryControl = __decorate([
        core_1.Component({
            selector: 'autocompleter-extended[ngControl], autocompleter-extended[ngFormControl], autocompleter-extended[ngModel]',
            encapsulation: core_1.ViewEncapsulation.Emulated,
            template: '<div class="input-group input-group-icon input-group-btn"><input id="inputCon" [controlHighlight]="isHighlight" type="text" [(value)]="idString" [class]="styleClass" [disabled]="disabled" (click)="changeZIndex()"> <button type="button" class="mb-xs btn btn-default" (click)="onAdd()"><i class="fa fa-plus"></i></button></div><div class="modal fade" tabindex="-1" role="dialog" #lookupPopupModal><div class="modal-block modal-header-color modal-block-primary lookup-popup"><place-holder [name]="popupComponent"></place-holder></div></div>'
        }),
        __param(0, core_1.Self()), 
        __metadata('design:paramtypes', [forms_1.NgControl, core_1.ElementRef, index_1.IEntityDataService, core_1.ComponentFactoryResolver, core_1.ViewContainerRef])
    ], AutocompleteExtendedJqueryControl);
    return AutocompleteExtendedJqueryControl;
}());
exports.AutocompleteExtendedJqueryControl = AutocompleteExtendedJqueryControl;
