"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var index_1 = require("./../interfaces/index");
var AutocompleteJqueryControl = (function () {
    function AutocompleteJqueryControl(cd, elRef, dataSource) {
        this.elRef = elRef;
        this.dataSource = dataSource;
        this.id = "";
        this.disabled = false;
        this.additionalFilters = [];
        this.styleClass = '';
        this.displayProperty = "Name";
        this.top = 30;
        this.isHighlight = false;
        this.change = new core_1.EventEmitter();
        this.selected = new core_1.EventEmitter();
        this.idString = "";
        cd.valueAccessor = this;
        this.controlID = ++AutocompleteJqueryControl.staticID;
    }
    AutocompleteJqueryControl.prototype.getValue = function () {
        return this.id;
    };
    AutocompleteJqueryControl.prototype.registerOnChange = function (fn) {
        this.change.subscribe(fn);
    };
    AutocompleteJqueryControl.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    AutocompleteJqueryControl.prototype.writeValue = function (valueID) {
        var _this = this;
        if (!valueID) {
            this.idString = "";
            return;
        }
        if (!this.id || this.id !== valueID) {
            this.id = valueID;
            if (this.entityType) {
                this.dataSource.fetchEntity(this.entityType, valueID).then(function (rest) { _this.idString = rest[_this.displayProperty]; });
            }
        }
    };
    AutocompleteJqueryControl.prototype.setValue = function (valueID) {
        var _this = this;
        this.id = valueID;
        this.onTouched();
        this.change.next(valueID);
        if (this.id && this.id !== '') {
            this.dataSource.fetchEntity(this.entityType, valueID).then(function (rest) { _this.idString = rest[_this.displayProperty]; });
        }
        else
            this.idString = null;
    };
    AutocompleteJqueryControl.prototype.ngAfterViewInit = function () {
        var _this = this;
        var that = this;
        if (this.entityType && this.id && this.id !== '') {
            this.dataSource.fetchEntity(this.entityType, this.id).then(function (rest) { _this.idString = rest[_this.displayProperty]; });
        }
        if (!this.additionalFilters)
            this.additionalFilters = [];
        if (that.sortArray) {
            that.sort = that.sortArray.join(",");
        }
        else {
            that.sort = that.displayProperty;
        }
        jQuery(this.elRef.nativeElement).find("#inputCon").attr('id', 'inputCon_SuperAC_' + this.controlID);
        jQuery(this.elRef.nativeElement).find('#inputCon_SuperAC_' + this.controlID).autocomplete({
            source: function (request, response) {
                that.dataSource.loadData(that.entityType, [{ Field: that.displayProperty, Operator: "startsWith", Term: request.term }].concat(that.additionalFilters), [], that.sort, (request.term.length == 0) ? that.top : null, null).then(function (res) {
                    response(Array.from(res.records, function (rec) { return { value: rec[that.displayProperty], id: rec.ID }; }));
                }).catch(function (err) {
                    console.log("Error while filtering data: " + err);
                });
            },
            minLength: 0,
            select: function (event, ui) {
                that.change.next(ui.item.id);
                that.idString = ui.item.value;
                that.selected.next(ui.item);
            },
            focus: function (event, ui) {
                event.preventDefault();
                jQuery(that.elRef.nativeElement).find('#inputCon_SuperAC_' + that.controlID).val(ui.item.value);
            },
            change: function (event, ui) {
                if (that.idString != jQuery(that.elRef.nativeElement).find('#inputCon_SuperAC_' + that.controlID).val()) {
                    jQuery(that.elRef.nativeElement).find('#inputCon_SuperAC_' + that.controlID).val("");
                    that.idString = "";
                    that.change.next(null);
                }
            }
        }).focus(function () {
            jQuery(this).autocomplete("search", jQuery(this).val());
        });
    };
    AutocompleteJqueryControl.staticID = 1;
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], AutocompleteJqueryControl.prototype, "id", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], AutocompleteJqueryControl.prototype, "entityType", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], AutocompleteJqueryControl.prototype, "disabled", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], AutocompleteJqueryControl.prototype, "additionalFilters", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], AutocompleteJqueryControl.prototype, "styleClass", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], AutocompleteJqueryControl.prototype, "displayProperty", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], AutocompleteJqueryControl.prototype, "sortArray", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], AutocompleteJqueryControl.prototype, "top", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], AutocompleteJqueryControl.prototype, "isHighlight", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], AutocompleteJqueryControl.prototype, "change", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], AutocompleteJqueryControl.prototype, "selected", void 0);
    __decorate([
        core_1.HostListener('blur', ['$event']), 
        __metadata('design:type', Function)
    ], AutocompleteJqueryControl.prototype, "onTouched", void 0);
    AutocompleteJqueryControl = __decorate([
        core_1.Component({
            selector: 'autocompleter[ngControl], autocompleter[ngFormControl], autocompleter[ngModel]',
            encapsulation: core_1.ViewEncapsulation.Emulated,
            template: "<input id=\"inputCon\" [controlHighlight]=\"isHighlight\" type=\"text\" [(value)]=\"idString\" [class]=\"styleClass\" [disabled]=\"disabled\">"
        }),
        __param(0, core_1.Self()), 
        __metadata('design:paramtypes', [forms_1.NgControl, core_1.ElementRef, index_1.IEntityDataService])
    ], AutocompleteJqueryControl);
    return AutocompleteJqueryControl;
}());
exports.AutocompleteJqueryControl = AutocompleteJqueryControl;
