"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require('@angular/core');
var forms_1 = require('@angular/forms');
var momment = require('moment');
var moment = momment["default"] || momment;
var DatePickerJqueryControl = (function () {
    function DatePickerJqueryControl(cd, elRef) {
        this.elRef = elRef;
        this.date = new Date();
        this.showIcon = true;
        this.startRadius = false;
        this.endRadius = true;
        this.change = new core_1.EventEmitter();
        this.dateString = (new Date()).toLocaleDateString('hr');
        this.isHighlight = false;
        cd.valueAccessor = this;
        this.id = ++DatePickerJqueryControl.staticID;
    }
    Object.defineProperty(DatePickerJqueryControl.prototype, "minDate", {
        get: function () {
            return jQuery(this.elRef.nativeElement).find("#" + 'inputCon_SuperDP_' + this.id).datepicker("option", "minDate");
        },
        set: function (value) { jQuery(this.elRef.nativeElement).find("#" + 'inputCon_SuperDP_' + this.id).datepicker("option", "minDate", value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DatePickerJqueryControl.prototype, "maxDate", {
        get: function () { return jQuery(this.elRef.nativeElement).find("#" + 'inputCon_SuperDP_' + this.id).datepicker("option", "maxDate"); },
        set: function (value) { jQuery(this.elRef.nativeElement).find("#" + 'inputCon_SuperDP_' + this.id).datepicker("option", "maxDate", value); },
        enumerable: true,
        configurable: true
    });
    DatePickerJqueryControl.prototype.getValue = function () { return this.date; };
    DatePickerJqueryControl.prototype.registerOnChange = function (fn) {
        this.change.subscribe(fn);
    };
    DatePickerJqueryControl.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    DatePickerJqueryControl.prototype.writeValue = function (value) {
        this.date = value;
        if (this.date instanceof Date)
            this.dateString = this.date.toLocaleDateString('hr');
        else
            this.dateString = "";
    };
    DatePickerJqueryControl.prototype.isValidDate = function (d) {
        if (Object.prototype.toString.call(d) !== "[object Date]")
            return false;
        return !isNaN(d.getTime());
    };
    DatePickerJqueryControl.prototype.setDate = function (newValue) {
        if (moment(this.date).valueOf() !== moment(newValue, "DD.MM.YYYY.").valueOf()) {
            this.dateString = newValue;
            var newDateValue = moment(newValue, "DD.MM.YYYY.").toDate();
            if (this.isValidDate(newDateValue)) {
                this.date = newDateValue;
                this.change.next(newDateValue);
            }
            else {
                this.date = null;
                this.change.next(null);
            }
        }
    };
    DatePickerJqueryControl.prototype.ngAfterViewInit = function () {
        var that = this;
        jQuery.datepicker.setDefaults(jQuery.datepicker.regional['hr']);
        jQuery(this.elRef.nativeElement).find("#inputCon").attr('id', 'inputCon_SuperDP_' + this.id);
        jQuery(this.elRef.nativeElement).find("#" + 'inputCon_SuperDP_' + this.id).datepicker({
            changeMonth: true,
            dateFormat: "dd.mm.yy.",
            onClose: function (selectedDate) {
                that.setDate(selectedDate);
            }
        });
    };
    DatePickerJqueryControl.prototype.changeZIndex = function () {
        var datepicker = document.getElementById('ui-datepicker-div');
        datepicker.style.setProperty("z-index", "1055");
    };
    DatePickerJqueryControl.staticID = 1;
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Date)
    ], DatePickerJqueryControl.prototype, "date", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], DatePickerJqueryControl.prototype, "showIcon", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], DatePickerJqueryControl.prototype, "startRadius", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], DatePickerJqueryControl.prototype, "endRadius", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], DatePickerJqueryControl.prototype, "change", void 0);
    __decorate([
        core_1.HostListener('blur', ['$event']), 
        __metadata('design:type', Function)
    ], DatePickerJqueryControl.prototype, "onTouched", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], DatePickerJqueryControl.prototype, "isHighlight", void 0);
    DatePickerJqueryControl = __decorate([
        core_1.Component({
            selector: 'datepick[ngControl], datepick[ngFormControl], datepick[ngModel]',
            encapsulation: core_1.ViewEncapsulation.Emulated,
            template: '<div [attr.class]="showIcon ? \'input-group\':\'\'"><span *ngIf="showIcon" class="input-group-addon"><span *ngIf="showIcon" class="glyphicon glyphicon-calendar"></span></span> <span *ngIf="endRadius || !startRadius" class="input-group-addon hidden"></span> <input id="inputCon" type="text" [(value)]="dateString" class="form-control" (click)="changeZIndex()" [controlHighlight]="isHighlight"> <span *ngIf="startRadius || !endRadius" class="input-group-addon hidden"></span></div>',
            inputs: ['minDate', 'maxDate']
        }),
        __param(0, core_1.Self()), 
        __metadata('design:paramtypes', [forms_1.NgControl, core_1.ElementRef])
    ], DatePickerJqueryControl);
    return DatePickerJqueryControl;
}());
exports.DatePickerJqueryControl = DatePickerJqueryControl;
