"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require('@angular/core');
var forms_1 = require('@angular/forms');
var index_1 = require('./../interfaces/index');
var DropdownJqueryControl = (function () {
    function DropdownJqueryControl(cd, elRef, dataSource, ngZone) {
        this.elRef = elRef;
        this.dataSource = dataSource;
        this.ngZone = ngZone;
        this.additionalFilters = [];
        this.placeholder = 'Not selected';
        this.valueProperty = 'ID';
        this.displayProperty = 'Name';
        this.sortProperty = 'ID';
        this.sortDirection = 'ASC';
        this.disabled = false;
        this.isHighlight = false;
        this.iconClass = '';
        this.changeEvent = new core_1.EventEmitter();
        this.selected = new core_1.EventEmitter();
        this.valueID = '';
        cd.valueAccessor = this;
        this.controlID = ++DropdownJqueryControl.staticID;
    }
    DropdownJqueryControl.prototype.registerOnChange = function (fn) {
        this.changeEvent.subscribe(fn);
    };
    DropdownJqueryControl.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    DropdownJqueryControl.prototype.writeValue = function (valueID) {
        if (!valueID) {
            return;
        }
        else {
            this.valueID = valueID;
        }
    };
    DropdownJqueryControl.prototype.ngOnDestroy = function () {
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
    };
    DropdownJqueryControl.prototype.ngAfterViewInit = function () {
        var _this = this;
        jQuery(this.elRef.nativeElement).find("#inputCon_DD").attr('id', 'inputCon_DD_' + this.controlID);
        var that = this;
        setTimeout(function () {
            that.subscription = that.dataSource.dataObserver.subscribe(function (changes) {
                if (changes.ID === "DropDown_InitDataLoad_" + _this.controlID) {
                    that.ngZone.run(function () {
                        if (!that.additionalFilters) {
                            that.availableEntities = that.dataSource.getCurrentLibrary(that.entityType).sort(function (a, b) {
                                if (typeof (a[that.sortProperty]) === 'string') {
                                    return a[that.sortProperty].localeCompare(b[that.sortProperty]);
                                }
                                else {
                                    return a[that.sortProperty] - b[that.sortProperty];
                                }
                            });
                        }
                        else {
                            that.availableEntities = that.dataSource.getCurrentLibrary(that.entityType, that.additionalFilters).sort(function (a, b) {
                                if (typeof (a[that.sortProperty]) === 'string') {
                                    return a[that.sortProperty].localeCompare(b[that.sortProperty]);
                                }
                                else {
                                    return a[that.sortProperty] - b[that.sortProperty];
                                }
                            });
                        }
                        that.availableItems = that.availableEntities.map(function (x) { return { value: x[that.valueProperty], name: x[that.displayProperty] }; });
                    });
                }
            });
            that.dataSource.reloadData(that.entityType, "DropDown_InitDataLoad_" + _this.controlID);
            if (!that.additionalFilters) {
                that.availableEntities = that.dataSource.getCurrentLibrary(that.entityType).sort(function (a, b) { return a[that.sortProperty] - b[that.sortProperty]; });
            }
            else {
                that.availableEntities = that.dataSource.getCurrentLibrary(that.entityType, that.additionalFilters).sort(function (a, b) { return a[that.sortProperty] - b[that.sortProperty]; });
            }
            that.availableItems = that.availableEntities.map(function (x) { return { value: x[that.valueProperty], name: x[that.displayProperty] }; });
        }, 0);
    };
    DropdownJqueryControl.prototype.setValue = function (newValue) {
        var _this = this;
        this.valueID = newValue;
        this.onTouched();
        this.changeEvent.next(newValue);
        if (this.valueID && this.valueID !== '') {
            this.selectedItem = this.availableEntities.filter(function (x) { return x.ID === _this.valueID; })[0];
        }
        else
            this.selectedItem = null;
    };
    DropdownJqueryControl.prototype.getValue = function () {
        return this.valueID;
    };
    DropdownJqueryControl.prototype.reLoadFilters = function (updateFilters) {
        var that = this;
        jQuery(this.elRef.nativeElement).find("#inputCon_DD").attr('id', 'inputCon_DD_' + this.controlID);
        if (!updateFilters) {
            that.availableEntities = that.dataSource.getCurrentLibrary(that.entityType).sort(function (a, b) { return a[that.sortProperty] - b[that.sortProperty]; });
        }
        else {
            that.availableEntities = that.dataSource.getCurrentLibrary(that.entityType, updateFilters).sort(function (a, b) { return a[that.sortProperty] - b[that.sortProperty]; });
        }
        that.availableItems = that.availableEntities.map(function (x) { return { value: x[that.valueProperty], name: x[that.displayProperty] }; });
        that.valueID = '';
    };
    DropdownJqueryControl.staticID = 1;
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], DropdownJqueryControl.prototype, "entityType", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], DropdownJqueryControl.prototype, "additionalFilters", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], DropdownJqueryControl.prototype, "placeholder", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], DropdownJqueryControl.prototype, "valueProperty", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], DropdownJqueryControl.prototype, "displayProperty", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], DropdownJqueryControl.prototype, "sortProperty", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], DropdownJqueryControl.prototype, "sortDirection", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], DropdownJqueryControl.prototype, "disabled", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], DropdownJqueryControl.prototype, "isHighlight", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], DropdownJqueryControl.prototype, "iconClass", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], DropdownJqueryControl.prototype, "changeEvent", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], DropdownJqueryControl.prototype, "selected", void 0);
    __decorate([
        core_1.HostListener('blur', ['$event']), 
        __metadata('design:type', Function)
    ], DropdownJqueryControl.prototype, "onTouched", void 0);
    DropdownJqueryControl = __decorate([
        core_1.Component({
            selector: 'dropdown[ngControl], dropdown[ngFormControl], dropdown[ngModel]',
            encapsulation: core_1.ViewEncapsulation.Emulated,
            template: '<select [controlHighlight]="isHighlight" id="inputCon_DD" class="form-control" [(ngModel)]="valueID" (change)="setValue($event.target.value)" autocomplete="off"><option>{{placeholder}}</option><option *ngFor="let opt of availableItems" [value]="opt.value">{{opt.name}}</option></select>'
        }),
        __param(0, core_1.Self()), 
        __metadata('design:paramtypes', [forms_1.NgControl, core_1.ElementRef, index_1.IEntityDataService, core_1.NgZone])
    ], DropdownJqueryControl);
    return DropdownJqueryControl;
}());
exports.DropdownJqueryControl = DropdownJqueryControl;
