import { OnInit, AfterViewInit, NgZone, ApplicationRef, PipeTransform, OnDestroy } from '@angular/core';
import { Http } from '@angular/http';
import { Router } from '@angular/router';
import { TestLogger } from './../services/index';
import { IDataStructure, IEntityDataService, IEmptyConstruct, FieldFilter } from './../interfaces/index';
import { GlobalDataSharing } from './../models/index';
export declare class WrapperPipe implements PipeTransform {
    registeredPipes: Map<string, PipeTransform>;
    constructor();
    transform(value: string, args: string[]): any;
}
export declare class EntityListControl implements OnInit, AfterViewInit, OnDestroy {
    private logger;
    private http;
    private router;
    private entityService;
    private zone;
    private applicationRef;
    dataLoadOnInit: boolean;
    entityType: IEmptyConstruct;
    editLink: string;
    static idComponent: number;
    static destroyedOnes: Array<number>;
    private filters;
    private showEntityList;
    private showEntity;
    private EntityDataStructure;
    private fields;
    private rerenderRequired;
    private cd;
    private myIDComponent;
    private subscription;
    constructor(logger: TestLogger, gds: GlobalDataSharing, http: Http, router: Router, entityService: IEntityDataService, zone: NgZone, applicationRef: ApplicationRef);
    setFilters(newFilters: Array<FieldFilter>): void;
    ngOnDestroy(): void;
    triggerRefreshData(): void;
    newEntity(): void;
    openDetail(entity: IDataStructure): void;
    ngAfterViewInit(): void;
    ngOnInit(): void;
    private registerDataService();
}
