import { ElementRef, OnInit, AfterViewInit, NgZone, ApplicationRef, PipeTransform, OnDestroy, EventEmitter } from '@angular/core';
import { Http } from '@angular/http';
import { Router } from '@angular/router';
import { TestLogger } from './../services/logger';
import { IButtonInfo, IDataStructure, IEntityDataService, IEmptyConstruct, FieldFilter } from './../interfaces/index';
import { GlobalDataSharing } from './../models/global-data-sharing.model';
import { DataTable, LazyLoadEvent } from 'primeng/primeng';
import { IComposableFilter } from '../basecode/core';
import { ErrorService } from './../services/error.service';
export declare class WrapperPipe implements PipeTransform {
    registeredPipes: Map<string, PipeTransform>;
    constructor(locale?: string);
    transform(value: string, args: string[]): any;
}
export declare class CheckItem {
    IsChecked: boolean;
    ID: string;
}
export declare class GridPrimeControl implements OnInit, AfterViewInit, OnDestroy {
    private logger;
    private http;
    private router;
    private entityService;
    private zone;
    private elRef;
    private applicationRef;
    private errorService;
    entityType: IEmptyConstruct;
    showExportExcelButton: boolean;
    fileName: string;
    showRefreshButton: boolean;
    addNewLink: string;
    showAddButton: boolean;
    private canAdd;
    editLink: string;
    openEntityDetail: boolean;
    doubleClickEvent: EventEmitter<any>;
    private canEdit;
    private showDeleteButton;
    private canDelete;
    pageLinks: number;
    pageSize: number;
    buttonsInFirstColumn: boolean;
    private pageNumber;
    private totalRecords;
    filters: Array<FieldFilter>;
    clearFilterEvent: EventEmitter<any>;
    private primeFilters;
    private totalFilters;
    orderBy: string;
    orderDirection: string;
    actionButtons: Array<IButtonInfo>;
    actionInvoked: EventEmitter<{
        FunctionName: string;
        ids: string[];
    }>;
    showCheckList: boolean;
    checkedEvent: EventEmitter<IDataStructure[]>;
    private checkLists;
    errorEvent: EventEmitter<any>;
    srclink: string;
    parentType: IEmptyConstruct;
    private showEntityList;
    private showEntity;
    private entityDataStructure;
    static idComponent: number;
    private myIDComponent;
    private subscription;
    private errorSubscription;
    private dataTypeEnum;
    static destroyedOnes: Array<number>;
    private cd;
    table: DataTable;
    private tableWidthEM;
    itemFilter: Array<IComposableFilter>;
    private toolTipConfig;
    private busy;
    constructor(logger: TestLogger, gds: GlobalDataSharing, http: Http, router: Router, entityService: IEntityDataService, zone: NgZone, elRef: ElementRef, applicationRef: ApplicationRef, errorService: ErrorService);
    loadData(): void;
    loadLazy(event: LazyLoadEvent): void;
    private registerDataService();
    private btnMultipleClick(btn);
    private btnSingleClick(btn, data);
    private dblClick(event);
    private getTotalFilters();
    private newEntity();
    private openDetail(entity);
    private clearFilters();
    private delete();
    private onDelete();
    private CheckedChanged(id, isChecked);
    private numberOfMultipleSelection(value, index, array);
    private numberOfSingleSelection(value, index, array);
    private numberOfSelectedItems(value, index, array);
    private getIndex(id);
    exportExcel(): void;
    exportExcelByFilter(itemList: IDataStructure[]): void;
    exportExcelByItemSelected(): boolean;
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngAfterViewInit(): void;
    private changePageSize(event);
}
