"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var common_1 = require('@angular/common');
var http_1 = require('@angular/http');
var router_1 = require('@angular/router');
var Rx_1 = require('rxjs/Rx');
var logger_1 = require('./../services/logger');
var index_1 = require('./../interfaces/index');
var index_2 = require('./../models/index');
var global_data_sharing_model_1 = require('./../models/global-data-sharing.model');
var ms_date_pipe_1 = require('./../pipes/ms-date.pipe');
var ms_datewithformat_pipe_1 = require('./../pipes/ms-datewithformat.pipe');
var decimal_number_pipe_1 = require('./../pipes/decimal-number.pipe');
var primeng_1 = require('primeng/primeng');
var error_service_1 = require('./../services/error.service');
var WrapperPipe = (function () {
    function WrapperPipe(locale) {
        if (locale === void 0) { locale = 'en-US'; }
        this.registeredPipes = new Map();
        if (!this.registeredPipes.get("date"))
            this.registeredPipes.set("date", new common_1.DatePipe(locale));
        if (!this.registeredPipes.get("msDate"))
            this.registeredPipes.set("msDate", new ms_date_pipe_1.MSDatePipe());
        if (!this.registeredPipes.get("msDateWithFormat"))
            this.registeredPipes.set("msDateWithFormat", new ms_datewithformat_pipe_1.MSDateWithFormatPipe());
        if (!this.registeredPipes.get("decimalNumber"))
            this.registeredPipes.set("decimalNumber", new decimal_number_pipe_1.DecimalNumberPipe());
    }
    WrapperPipe.prototype.transform = function (value, args) {
        if (!args || args.length === 0 || !args[0] || args[0].length === 0)
            return value;
        else {
            var pipes = args[0].split(',');
            for (var ix = 0; ix < pipes.length; ix++)
                if (this.registeredPipes.get(pipes[ix]))
                    value = this.registeredPipes.get(pipes[ix]).transform(value, null);
            return value;
        }
    };
    WrapperPipe = __decorate([
        core_1.Pipe({ name: 'pipeWrapper' }), 
        __metadata('design:paramtypes', [String])
    ], WrapperPipe);
    return WrapperPipe;
}());
exports.WrapperPipe = WrapperPipe;
var CheckItem = (function () {
    function CheckItem() {
        this.IsChecked = false;
        this.ID = '';
    }
    return CheckItem;
}());
exports.CheckItem = CheckItem;
var GridPrimeControl = (function () {
    function GridPrimeControl(logger, gds, http, router, entityService, zone, elRef, applicationRef, errorService) {
        var _this = this;
        this.logger = logger;
        this.http = http;
        this.router = router;
        this.entityService = entityService;
        this.zone = zone;
        this.elRef = elRef;
        this.applicationRef = applicationRef;
        this.errorService = errorService;
        this.showExportExcelButton = true;
        this.fileName = "";
        this.showRefreshButton = false;
        this.addNewLink = "";
        this.showAddButton = true;
        this.canAdd = false;
        this.editLink = "";
        this.openEntityDetail = true;
        this.doubleClickEvent = new core_1.EventEmitter();
        this.canEdit = false;
        this.showDeleteButton = true;
        this.canDelete = false;
        this.pageLinks = 3;
        this.pageSize = 10;
        this.buttonsInFirstColumn = false;
        this.pageNumber = 1;
        this.filters = new Array();
        this.clearFilterEvent = new core_1.EventEmitter();
        this.primeFilters = new Array();
        this.totalFilters = new Array();
        this.orderBy = "ID";
        this.orderDirection = "asc";
        this.actionButtons = new Array();
        this.actionInvoked = new core_1.EventEmitter();
        this.showCheckList = true;
        this.checkedEvent = new core_1.EventEmitter();
        this.checkLists = new Array();
        this.errorEvent = new core_1.EventEmitter();
        this.srclink = "./../css/cog11.svg";
        this.parentType = null;
        this.showEntityList = new Array();
        this.showEntity = new index_2.BaseEntity();
        this.entityDataStructure = index_2.BaseEntity;
        this.dataTypeEnum = index_1.DataTypeEnum;
        this.cd = 0;
        this.tableWidthEM = 100;
        this.itemFilter = new Array();
        this.toolTipConfig = {
            placement: "top",
            toggle: "tooltip"
        };
        this.busy = false;
        var that = this;
        setInterval(function () {
            if (_this.cd != _this.showEntityList.length) {
                _this.cd = _this.showEntityList.length;
                that.applicationRef.tick();
            }
        }, 250);
        this.myIDComponent = GridPrimeControl.idComponent++;
        logger.log("Entity list component initiated!");
    }
    Object.defineProperty(GridPrimeControl.prototype, "entityType", {
        set: function (EntityType) {
            this.showEntity = new EntityType();
            this.entityDataStructure = EntityType;
            this.registerDataService();
        },
        enumerable: true,
        configurable: true
    });
    GridPrimeControl.prototype.loadData = function () {
        var _this = this;
        setTimeout(function () { return _this.busy = true; }, 0);
        var that = this;
        var skip = this.pageSize * (this.pageNumber - 1);
        this.getTotalFilters();
        this.entityService.loadData(this.entityDataStructure, this.totalFilters, this.itemFilter, this.orderBy + ' ' + this.orderDirection, this.pageSize, skip)
            .then(function (res) {
            that.showEntityList = res.records;
            that.totalRecords = res.totalCount;
            that.checkLists = [];
            that.showEntityList.forEach(function (value, index, array) {
                that.checkLists.push({ IsChecked: false, ID: value.ID });
            });
            setTimeout(function () {
                if (CurrentTheme && CurrentTheme.tooltipInit)
                    CurrentTheme.tooltipInit(jQuery);
            }, 200);
            setTimeout(function () { return _this.busy = false; }, 0);
        }, function (error) {
            var errorMessage = JSON.parse(error._body).UserMessage;
            _this.errorService.errorObserver.emit(errorMessage);
        });
    };
    GridPrimeControl.prototype.loadLazy = function (event) {
        var _this = this;
        setTimeout(function () { return _this.busy = true; }, 0);
        this.pageNumber = Math.trunc(event.first / this.pageSize) + 1;
        this.orderBy = event.sortField == null ? this.orderBy : event.sortField;
        this.orderDirection = event.sortOrder == 1 ? 'asc' : 'desc';
        if (event.filters != null) {
            this.primeFilters = new Array();
            for (var i = 0; i < this.showEntity.browseFields.length; i++)
                if (this.showEntity.browseFields[i].IsFilterEnabled && event.filters[this.showEntity.browseFields[i].Name] != null) {
                    if (event.filters[this.showEntity.browseFields[i].Name].value) {
                        var filter = new index_1.FieldFilter();
                        filter.Field = this.showEntity.browseFields[i].Name;
                        filter.Operator = this.showEntity.browseFields[i].FilterMatchMode ? index_1.FilterMatchMode[this.showEntity.browseFields[i].FilterMatchMode] : index_1.FilterMatchMode[index_1.FilterMatchMode.contains];
                        if (this.showEntity.browseFields[i].DataType == index_1.DataTypeEnum.number) {
                            filter.Term = Number.parseFloat(event.filters[this.showEntity.browseFields[i].Name].value);
                        }
                        else if (this.showEntity.browseFields[i].DataType == index_1.DataTypeEnum.boolean) {
                            filter.Term = event.filters[this.showEntity.browseFields[i].Name].value == "true";
                        }
                        else {
                            filter.Term = event.filters[this.showEntity.browseFields[i].Name].value;
                        }
                        this.primeFilters.push(filter);
                    }
                }
        }
        var skip = this.pageSize * (this.pageNumber - 1);
        var that = this;
        this.getTotalFilters();
        this.entityService.loadData(this.entityDataStructure, this.totalFilters, this.itemFilter, this.orderBy + ' ' + this.orderDirection, this.pageSize, skip)
            .then(function (res) {
            that.showEntityList = res.records;
            that.totalRecords = res.totalCount;
            that.checkLists = [];
            that.showEntityList.forEach(function (value, index, array) {
                that.checkLists.push({ IsChecked: false, ID: value.ID });
            });
            setTimeout(function () {
                if (CurrentTheme && CurrentTheme.tooltipInit)
                    CurrentTheme.tooltipInit(jQuery);
            }, 200);
            setTimeout(function () { return _this.busy = false; }, 0);
        }, function (error) {
            console.log("lazy");
            console.log(error);
        });
    };
    GridPrimeControl.prototype.registerDataService = function () {
        var _this = this;
        if (this.showEntity) {
            var that = this;
            this.subscription = this.entityService.dataObserver.subscribe(function (next) {
                if ((next.dataStructure == that.showEntity.getInstance() || next.dataStructure == that.showEntity.getRootEntity().getInstance()) || (next.dataChangedType == index_1.DataChangeType.Insert || next.dataChangedType == index_1.DataChangeType.Delete))
                    that.loadData();
                else {
                    if (next.data && next.data.length > 0) {
                        next.data.forEach(function (value) {
                            if (value instanceof that.entityDataStructure)
                                that.showEntityList.map(function (v) {
                                    if (v.ID === value.ID) {
                                        v.setModelData(value);
                                        that.logger.log("Updated data with EntityID: " + v.ID);
                                    }
                                });
                        });
                    }
                }
            });
            this.errorSubscription = this.entityService.errorObserver.subscribe(function (emit) {
                if (emit.ID == 'Grid_Prime_' + that.myIDComponent)
                    that.errorEvent.emit(emit.errorMessage);
            });
            this.entityService.userHasPermission(this.showEntity.getRootEntity().getInstance(), 'New').then(function (result) {
                that.canAdd = result;
            });
            this.entityService.userHasPermission(this.showEntity.getRootEntity().getInstance(), 'Edit').then(function (result) {
                that.canEdit = result;
            });
            this.entityService.userHasPermission(this.showEntity.getRootEntity().getInstance(), 'Remove').then(function (result) {
                that.canDelete = result || (_this.parentType != null);
            });
        }
    };
    GridPrimeControl.prototype.btnMultipleClick = function (btn) {
        var listID = new Array();
        this.checkLists.forEach(function (value, index, array) { if (value.IsChecked)
            listID.push(value.ID); });
        this.actionInvoked.emit({ FunctionName: btn.FunctionName, ids: listID });
    };
    GridPrimeControl.prototype.btnSingleClick = function (btn, data) {
        var listID = new Array();
        listID.push(data.ID);
        this.actionInvoked.emit({ FunctionName: btn.FunctionName, ids: listID });
    };
    GridPrimeControl.prototype.dblClick = function (event) {
        if (this.canEdit && this.openEntityDetail)
            this.openDetail(event.data);
        this.doubleClickEvent.emit(event.data);
    };
    GridPrimeControl.prototype.getTotalFilters = function () {
        this.totalFilters = new Array();
        for (var i = 0; i < this.filters.length; i++)
            this.totalFilters.push(this.filters[i]);
        for (var i = 0; i < this.primeFilters.length; i++)
            this.totalFilters.push(this.primeFilters[i]);
    };
    GridPrimeControl.prototype.newEntity = function () {
        this.router.navigate([this.addNewLink]);
    };
    GridPrimeControl.prototype.openDetail = function (entity) {
        if (this.editLink.length > 0) {
            this.router.navigate([this.editLink, entity.ID]);
        }
    };
    GridPrimeControl.prototype.clearFilters = function () {
        var _this = this;
        this.primeFilters = [];
        this.pageSize = 10;
        this.pageNumber = 1;
        this.table.totalRecords = 0;
        setTimeout(function () {
            _this.table.totalRecords = _this.totalRecords;
            _this.table.paginate({ first: 0, rows: _this.pageSize });
            _this.clearFilterEvent.emit(true);
        });
        this.table.reset();
    };
    GridPrimeControl.prototype.delete = function () {
        jQuery("#deactiveConfirm").modal("show");
    };
    GridPrimeControl.prototype.onDelete = function () {
        var _this = this;
        this.showEntityList.forEach(function (entity) {
            if (_this.checkLists.findIndex(function (checkItem) {
                if (checkItem.ID == entity.ID && checkItem.IsChecked)
                    return true;
            }) >= 0) {
                if (!_this.parentType)
                    _this.entityService.deleteEntity(_this.entityDataStructure, entity, 'Grid_Prime_' + _this.myIDComponent);
                else
                    _this.entityService.deleteEntity(_this.parentType, entity, 'Grid_Prime_' + _this.myIDComponent);
            }
        });
    };
    GridPrimeControl.prototype.CheckedChanged = function (id, isChecked) {
        var listItem = [];
        var checkListTemp = [];
        this.checkLists.forEach(function (v, i, a) {
            var checkItem = new CheckItem();
            checkItem.ID = v.ID;
            if (checkItem.ID == id)
                checkItem.IsChecked = !v.IsChecked;
            else
                checkItem.IsChecked = v.IsChecked;
            checkListTemp.push(checkItem);
        });
        this.showEntityList.forEach(function (value, index, array) { if (checkListTemp.findIndex(function (item) { if (item.ID == value.ID && item.IsChecked)
            return true; }) >= 0)
            listItem.push(value); });
        this.checkedEvent.emit(listItem);
    };
    GridPrimeControl.prototype.numberOfMultipleSelection = function (value, index, array) {
        if (value.MultipleSelection)
            return true;
    };
    GridPrimeControl.prototype.numberOfSingleSelection = function (value, index, array) {
        if (value.SingleSelection)
            return true;
    };
    GridPrimeControl.prototype.numberOfSelectedItems = function (value, index, array) {
        if (value.IsChecked)
            return true;
    };
    GridPrimeControl.prototype.getIndex = function (id) {
        return this.checkLists.findIndex(function (value) { if (value.ID == id)
            return true; });
    };
    GridPrimeControl.prototype.exportExcel = function () {
        var that = this;
        var isNotExportExcelByFilter = that.exportExcelByItemSelected();
        if (isNotExportExcelByFilter) {
            this.busy = true;
            var skip = this.pageSize * (this.pageNumber - 1);
            this.getTotalFilters();
            this.entityService.loadData(this.entityDataStructure, this.totalFilters, [], this.orderBy + ' ' + this.orderDirection, this.pageSize, skip)
                .then(function (res) {
                that.showEntityList = res.records;
                that.totalRecords = res.totalCount;
                that.checkLists = [];
                that.showEntityList.forEach(function (value, index, array) {
                    that.checkLists.push({ IsChecked: false, ID: value.ID });
                });
                that.exportExcelByFilter(that.showEntityList);
                setTimeout(function () {
                    if (CurrentTheme && CurrentTheme.tooltipInit)
                        CurrentTheme.tooltipInit(jQuery);
                }, 200);
                that.busy = false;
            });
        }
    };
    GridPrimeControl.prototype.exportExcelByFilter = function (itemList) {
        var fieldName = "";
        var fieldNameList = this.showEntity.browseFields;
        for (var index = 0; index < fieldNameList.length; index++) {
            if (fieldNameList[index].DataType == index_1.DataTypeEnum.datetime) {
                fieldName += 'datetime([' + fieldNameList[index].Name + ']) AS ';
            }
            if (index == fieldNameList.length - 1)
                fieldName += '[' + fieldNameList[index].Name + ']';
            else
                fieldName += '[' + fieldNameList[index].Name + ']' + ",";
        }
        if (this.fileName === '')
            this.fileName = 'ExportToExcel';
        alasql("SELECT " + fieldName + " INTO XLSX('" + this.fileName + ".xlsx',{headers:true}) FROM ? ", [itemList]);
    };
    GridPrimeControl.prototype.exportExcelByItemSelected = function () {
        var _this = this;
        var itemList = [];
        this.showEntityList.forEach(function (value, index, array) { if (_this.checkLists.findIndex(function (item) { if (item.ID == value.ID && item.IsChecked)
            return true; }) >= 0)
            itemList.push(value); });
        if (itemList.length > 0) {
            this.exportExcelByFilter(itemList);
            return false;
        }
        else
            return true;
    };
    GridPrimeControl.prototype.ngOnInit = function () {
        var _this = this;
        this.actionButtons.map(function (button) {
            if (!button.ButtonClass)
                button.ButtonClass = 'mb- xs mt- xs mr- xs btn btn-default';
        });
        this.showEntity.browseFields.map(function (column) {
            if (!column.IsSortedColumn)
                column.IsSortedColumn = false;
            if (!column.FilterMatchMode)
                column.FilterMatchMode = index_1.FilterMatchMode.contains;
            if (!column.DataStyle)
                column.DataStyle = {};
            if (!column.ClassName)
                column.ClassName = 'ui - cell - data';
            if (column.Width)
                column.DataStyle['width'] = ((_this.tableWidthEM < 40) ? 100 : column.Width) + '%';
        });
        this.logger.log('Entity list component OnInit invoked.');
    };
    GridPrimeControl.prototype.ngOnDestroy = function () {
        GridPrimeControl.destroyedOnes.push(this.myIDComponent);
        this.logger.log("ENTITYLIST TO BE destroyed: (ID: " + this.myIDComponent + ', entityType: ' + this.entityDataStructure + ', filters: ' + ((this.filters) ? this.filters.length : 0) + ')');
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
        if (this.errorSubscription) {
            this.errorSubscription.unsubscribe();
        }
    };
    GridPrimeControl.prototype.ngAfterViewInit = function () {
        this.logger.log('Entity list component AfterViewInit invoked.');
        var nativeElem = this.table.el.nativeElement.children[0];
        var that = this;
        that.tableWidthEM = nativeElem.clientWidth / parseFloat(jQuery("body").css("font-size"));
        Rx_1.Observable.fromEvent(window, 'resize').debounceTime(50).subscribe(function (_) {
            that.zone.run(function () {
                that.tableWidthEM = nativeElem.clientWidth / parseFloat(jQuery("body").css("font-size"));
            });
        });
    };
    GridPrimeControl.prototype.changePageSize = function (event) {
        var _this = this;
        if (this.pageSize < 1) {
            event.preventDefault();
            event.target.value = 1;
            this.pageSize = 1;
        }
        this.table.totalRecords = 0;
        setTimeout(function () {
            _this.table.totalRecords = _this.totalRecords;
            _this.table.paginate({ first: 0, rows: _this.pageSize });
        });
    };
    GridPrimeControl.idComponent = 0;
    GridPrimeControl.destroyedOnes = [];
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object), 
        __metadata('design:paramtypes', [Object])
    ], GridPrimeControl.prototype, "entityType", null);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], GridPrimeControl.prototype, "showExportExcelButton", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], GridPrimeControl.prototype, "fileName", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], GridPrimeControl.prototype, "showRefreshButton", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], GridPrimeControl.prototype, "addNewLink", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], GridPrimeControl.prototype, "showAddButton", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], GridPrimeControl.prototype, "editLink", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], GridPrimeControl.prototype, "openEntityDetail", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], GridPrimeControl.prototype, "doubleClickEvent", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], GridPrimeControl.prototype, "showDeleteButton", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], GridPrimeControl.prototype, "pageLinks", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], GridPrimeControl.prototype, "pageSize", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], GridPrimeControl.prototype, "buttonsInFirstColumn", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], GridPrimeControl.prototype, "filters", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], GridPrimeControl.prototype, "clearFilterEvent", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], GridPrimeControl.prototype, "orderBy", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], GridPrimeControl.prototype, "orderDirection", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], GridPrimeControl.prototype, "actionButtons", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], GridPrimeControl.prototype, "actionInvoked", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], GridPrimeControl.prototype, "showCheckList", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], GridPrimeControl.prototype, "checkedEvent", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], GridPrimeControl.prototype, "errorEvent", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], GridPrimeControl.prototype, "srclink", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], GridPrimeControl.prototype, "parentType", void 0);
    __decorate([
        core_1.ViewChild('dataTable'), 
        __metadata('design:type', primeng_1.DataTable)
    ], GridPrimeControl.prototype, "table", void 0);
    GridPrimeControl = __decorate([
        core_1.Component({
            selector: 'grid-prime',
            template: '<style>\r\n    .middle {\r\n        width:100%;\r\n        margin:0 0 auto;\r\n        white-space: nowrap;\r\n        overflow: hidden;\r\n        text-overflow: ellipsis;\r\n    }\r\n</style><busy-overlay [busy]="busy" [srclink]="srclink"></busy-overlay><div class="row col-sm-11"><div class="mb-xs mt-xs mr-xs btn-group" *ngIf="(showRefreshButton || showExportExcelButton || addNewLink.length > 0 || (showDeleteButton && canDelete))"><button *ngIf="showRefreshButton" class="btn btn-default" type="button" (click)="loadData()" attr.data-placement="{{toolTipConfig[\'placement\']}}" attr.data-toggle="{{toolTipConfig[\'toggle\']}}" data-original-title="Refresh"><i class="fa fa-refresh"></i>&nbsp;</button> <button *ngIf="showExportExcelButton" class="btn btn-default" type="button" (click)="exportExcel()" attr.data-placement="{{toolTipConfig[\'placement\']}}" attr.data-toggle="{{toolTipConfig[\'toggle\']}}" data-original-title="Export excel"><i class="fa fa-file-excel-o"></i>&nbsp;</button> <button *ngIf="addNewLink.length > 0" class="btn btn-default" type="button" (click)="newEntity()" attr.data-placement="{{toolTipConfig[\'placement\']}}" attr.data-toggle="{{toolTipConfig[\'toggle\']}}" data-original-title="New"><i class="fa fa-plus-circle"></i>&nbsp;</button> <button *ngIf="showDeleteButton && canDelete" class="btn btn-danger" [disabled]="checkLists.filter(numberOfSelectedItems).length==0" type="button" (click)="delete()" attr.data-placement="{{toolTipConfig[\'placement\']}}" attr.data-toggle="{{toolTipConfig[\'toggle\']}}" data-original-title="Deactivate"><i class="fa fa-trash"></i>&nbsp;</button></div><div class="mb-xs mt-xs mr-xs btn-group" *ngIf="actionButtons.filter(numberOfMultipleSelection).length > 0"><template ngFor let-bt [ngForOf]="actionButtons"><button [disabled]="bt.IsDisabled" *ngIf="bt.MultipleSelection" [ngClass]="bt.ButtonClass" (click)="btnMultipleClick(bt)" attr.data-placement="{{toolTipConfig[\'placement\']}}" attr.data-toggle="{{toolTipConfig[\'toggle\']}}" attr.data-original-title="{{bt.IsDisabled?bt.DisabledReason:bt.Title}}"><i *ngIf="bt.IconClass" [ngClass]="bt.IconClass"></i><span [innerHTML]="bt.Text"></span></button></template></div></div><div class="col-sm-offset-11"><div class="input-group" style="width:100px;float:right"><input type="number" class="form-control text-right" placeholder="Page Size" [(ngModel)]="pageSize" (change)="changePageSize($event)" maxlength="3" style="width:60px"><div class="input-group-btn"><button class="btn btn-default" type="button" (click)="clearFilters()" attr.data-placement="{{toolTipConfig[\'placement\']}}" attr.data-toggle="{{toolTipConfig[\'toggle\']}}" data-original-title="Clear Filters" style="height:34px"><i class="fa fa-eraser"></i>&nbsp;</button></div></div></div><p-datatable id="data-grid-view" [value]="showEntityList" [rows]="pageSize" [paginator]="true" [totalRecords]="totalRecords" [pageLinks]="pageLinks" lazy="true" (onLazyLoad)="loadLazy($event)" (onRowDblclick)="dblClick($event)" [responsive]="true" #dataTable><p-column styleClass="col-button" [style]="{\'width\': \'40px\',\'text-align\':\'center\'}" [header]="\'#\'" *ngIf="actionButtons.filter(numberOfMultipleSelection).length > 0 || canDelete"><template let-col let-rowData="rowData" pTemplate type="body"><div class="checkbox-custom checkbox-default checkbox-inline"><input type="checkbox" [(ngModel)]="checkLists[getIndex(rowData.ID)].IsChecked" (change)="CheckedChanged(rowData.ID,checkLists[getIndex(rowData.ID)].IsChecked)"> <label>&nbsp;</label></div></template></p-column><p-column *ngIf="actionButtons.filter(numberOfSingleSelection).length > 0 && buttonsInFirstColumn" styleClass="col-button" [header]="\'☼\'" [style]="{\'text-align\':\'center\'}"><template let-rowData="rowData" pTemplate type="body"><div class="mb-xs mt-xs mr-xs btn-group"><template ngFor let-bt [ngForOf]="actionButtons" pTemplate type="body"><button [disabled]="rowData[bt.DisabledBy] || bt.IsDisabled" *ngIf="bt.SingleSelection" [ngClass]="bt.ButtonClass" (click)="btnSingleClick(bt,rowData)" attr.data-toggle="{{toolTipConfig[\'toggle\']}}" attr.data-original-title="{{(rowData[bt.DisabledBy] || bt.IsDisabled) ? bt.DisabledReason:bt.Title}}"><i *ngIf="bt.IconClass" [ngClass]="bt.IconClass"></i><span [innerHTML]="bt.Text"></span></button></template></div></template></p-column><p-column *ngFor="let column of showEntity.browseFields" [styleClass]="column.ClassName" [field]="column.Name" [header]="column.Title" [filter]="column.IsFilterEnabled" [filterMatchMode]="\'contains\'" [sortable]="column.IsSortedColumn" [style]="column.DataStyle"><template let-col let-data="rowData" pTemplate type="body"><div *ngIf="column.DataType == dataTypeEnum.boolean" style="text-align:center"><div *ngIf="!(column.Name == \'Status\' || column.Name == \'Active\')" class="checkbox-custom checkbox-default checkbox-inline"><input [ngModel]="data[column.Name]" type="checkbox" disabled> <label>&nbsp;</label></div><div *ngIf="column.Name == \'Status\' || column.Name == \'Active\'"><i *ngIf="data[column.Name] == true" class="fa fa-check" style="color:#228B22"></i> <i *ngIf="!data[column.Name] == true" class="fa fa-times" style="color:#ff0000"></i></div></div><p *ngIf="column.DataType != dataTypeEnum.boolean" [ngStyle]="column.DataType == dataTypeEnum.number ? {\'text-align\':\'right\'}:{\'width\':\'100%\',\'white-space\':\'nowrap\',\'display\':\'inline-block\',\'overflow\':\'hidden\',\'text-overflow\':\'ellipsis\'}">{{data[column.Name] | pipeWrapper:[column.Pipe]}}</p></template></p-column><p-column *ngIf="actionButtons.filter(numberOfSingleSelection).length > 0 && !buttonsInFirstColumn" styleClass="col-button" [header]="\'☼\'" [style]="{\'text-align\':\'center\'}"><template let-rowData="rowData" pTemplate type="body"><div class="mb-xs mt-xs mr-xs btn-group"><template ngFor let-bt [ngForOf]="actionButtons"><button [disabled]="rowData[bt.DisabledBy] || bt.IsDisabled" *ngIf="bt.SingleSelection" [ngClass]="bt.ButtonClass" (click)="btnSingleClick(bt,rowData)" attr.data-toggle="{{toolTipConfig[\'toggle\']}}" attr.data-original-title="{{(rowData[bt.DisabledBy] || bt.IsDisabled) ? bt.DisabledReason:bt.Title}}"><i *ngIf="bt.IconClass" [ngClass]="bt.IconClass"></i><span [innerHTML]="bt.Text"></span></button></template></div></template></p-column></p-datatable><div class="modal fade" tabindex="-1" role="dialog" id="deactiveConfirm" data-keyboard="false" data-backdrop="static"><div class="vertical-alignment-helper"><div class="modal-dialog vertical-align-center"><div class="modal-content"><div class="modal-header"><button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button><h4 class="modal-title">Confirm</h4></div><div class="modal-body"><p>Do you want to deactive those data?</p></div><div class="modal-footer"><button type="button" class="btn btn-primary" data-dismiss="modal" (click)="onDelete()">Confirm</button> <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button></div></div></div></div></div>'
        }), 
        __metadata('design:paramtypes', [logger_1.TestLogger, global_data_sharing_model_1.GlobalDataSharing, http_1.Http, router_1.Router, index_1.IEntityDataService, core_1.NgZone, core_1.ElementRef, core_1.ApplicationRef, error_service_1.ErrorService])
    ], GridPrimeControl);
    return GridPrimeControl;
}());
exports.GridPrimeControl = GridPrimeControl;
