"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var forms_1 = require('@angular/forms');
var router_1 = require('@angular/router');
var index_1 = require('./../services/index');
var index_2 = require('./../models/index');
var HeaderAppComponent = (function () {
    function HeaderAppComponent(fb, currentZone, loginService, router) {
        var _this = this;
        this.fb = fb;
        this.currentZone = currentZone;
        this.loginService = loginService;
        this.router = router;
        this.loginInfo = new index_2.LoginInfo();
        var that = this;
        loginService.UserLoginInfoObservable.subscribe(function (info) {
            that.currentZone.run(function () {
                that.loginInfo = info;
                console.log(_this.loginInfo);
            });
        });
        that.loginInfo.LoggedAs = loginService.loggedAs;
        that.loginInfo.UserLoggedIn = loginService.userLoggedIn;
    }
    HeaderAppComponent.prototype.navigateProfilePage = function () {
        this.router.navigateByUrl("/app/profile-page");
    };
    HeaderAppComponent.prototype.logOut = function () {
        var isLogOut = confirm("Are you sure you want to logout?");
        if (isLogOut) {
            this.loginService.logout();
        }
    };
    HeaderAppComponent = __decorate([
        core_1.Component({
            selector: 'header-app',
            template: '<header class="header"><div class="logo-container"><a href="../" class="logo"><img height="35" alt="Base app"></a><div class="visible-xs toggle-sidebar-left" data-toggle-class="sidebar-left-opened" data-target="html" data-fire-event="sidebar-left-opened"><i class="fa fa-bars" aria-label="Toggle sidebar"></i></div></div><div class="header-right"><span class="separator"></span><div id="userbox" class="userbox" *ngIf="loginInfo.UserLoggedIn"><a href="#" class="dropdown-toggle" data-toggle="dropdown"><figure class="profile-picture"><img src="assets/images/!logged-user.jpg" alt="2CS" class="img-circle" data-lock-picture="assets/images/!logged-user.jpg"></figure><div class="profile-info"><span class="name">{{loginInfo.LoggedAs}}</span></div><i class="fa custom-caret"></i></a><div class="dropdown-menu"><ul class="list-unstyled"><li class="divider"></li><li><a role="menuitem" tabindex="-1" (click)="navigateProfilePage()"><i class="fa fa-user"></i> My Profile</a></li><li><a role="menuitem" tabindex="-1" href="#" data-lock-screen="true"><i class="fa fa-lock"></i> Lock Screen</a></li><li><a role="menuitem" tabindex="-1" (click)="logOut()" href="#"><i class="fa fa-power-off"></i> Logout</a></li></ul></div></div></div></header>'
        }), 
        __metadata('design:paramtypes', [forms_1.FormBuilder, core_1.NgZone, index_1.LoginService, router_1.Router])
    ], HeaderAppComponent);
    return HeaderAppComponent;
}());
exports.HeaderAppComponent = HeaderAppComponent;
