"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require('@angular/core');
var core_2 = require('@angular/core');
var forms_1 = require('@angular/forms');
var index_1 = require('./../interfaces/index');
var index_2 = require('./../components/index');
var LookupJqueryControl = (function () {
    function LookupJqueryControl(cd, elRef, dynamicComponentLoader, container, dataSource) {
        this.elRef = elRef;
        this.dynamicComponentLoader = dynamicComponentLoader;
        this.container = container;
        this.dataSource = dataSource;
        this.id = "";
        this.placeholder = "";
        this.displayProperty = "Name";
        this.additionalFilters = [];
        this.top = 30;
        this.showPopup = new core_2.EventEmitter();
        this.changeEvent = new core_2.EventEmitter();
        this.saveEvent = new core_2.EventEmitter();
        this.entitySubmitted = new core_2.EventEmitter();
        this.selected = new core_2.EventEmitter();
        this.idString = "";
        cd.valueAccessor = this;
        this.controlID = ++LookupJqueryControl.staticID;
    }
    LookupJqueryControl.prototype.ngOnInit = function () {
        var _this = this;
        if (this.entityType) {
            this.dataSource.fetchEntity(this.entityType, this.id).then(function (rest) { _this.idString = rest[_this.displayProperty]; });
        }
    };
    LookupJqueryControl.prototype.onAdd = function () {
        this.showPopup.next('');
        this.popupComponentInstance.formTitle = "Add new";
        this.popupComponentInstance.entityEditing = new this.entityType();
        this.popupComponentInstance.isHiddenView = false;
        jQuery(this.modalPopup.nativeElement).modal('show');
    };
    LookupJqueryControl.prototype.onEdit = function () {
        var _this = this;
        this.showPopup.next(this.id);
        var that = this;
        this.dataSource.fetchEntity(this.entityType, this.id).then(function (entity) {
            that.popupComponentInstance.formTitle = "Edit";
            that.popupComponentInstance.entityEditing = entity;
            _this.popupComponentInstance.isHiddenView = false;
            jQuery(that.modalPopup.nativeElement).modal('show');
        });
    };
    LookupJqueryControl.prototype.registerOnChange = function (fn) {
        this.changeEvent.subscribe(fn);
    };
    LookupJqueryControl.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    LookupJqueryControl.prototype.writeValue = function (valueID) {
        var _this = this;
        if (!valueID) {
            return;
        }
        this.id = valueID;
        if (this.entityType) {
            this.dataSource.fetchEntity(this.entityType, valueID).then(function (rest) { _this.idString = rest[_this.displayProperty]; });
        }
    };
    LookupJqueryControl.prototype.ngAfterContentInit = function () {
        var that = this;
        jQuery(that.modalPopup.nativeElement).modal('hide');
        var Comp = that.dynamicComponentLoader.resolveComponentFactory(that.popupComponent);
        var newComp = that.placeHolders.container.createComponent(Comp, 0, this.dynamicBinding);
        that.popupComponentInstance = newComp.instance;
        that.popupComponentInstance.formSubmitted.subscribe(function (next) {
            that.entitySubmitted.emit(next);
        });
        that.popupComponentInstance.formCancelled.subscribe(function (hasChanges) {
            that.popupComponentInstance.isHiddenView = true;
            jQuery(that.modalPopup.nativeElement).modal('hide');
        });
        that.popupComponentInstance.entitySaved.subscribe(function (nextValue) {
            that.popupComponentInstance.isHiddenView = true;
            jQuery(that.modalPopup.nativeElement).modal('hide');
            that.saveEvent.next(nextValue);
            that.idString = nextValue[that.displayProperty];
            if (that.id != nextValue.ID) {
                that.writeValue(nextValue.ID);
                that.changeEvent.emit(nextValue.ID);
                that.selected.emit(nextValue.ID);
            }
        });
        if (that.sortArray) {
            that.sort = that.sortArray.join(",");
        }
        else {
            that.sort = that.displayProperty;
        }
        if (!this.additionalFilters)
            this.additionalFilters = [];
        jQuery(this.elRef.nativeElement).find("#inputCon").attr('id', 'inputCon_SuperAC_' + this.controlID);
        jQuery(this.elRef.nativeElement).find('#inputCon_SuperAC_' + this.controlID).autocomplete({
            source: function (request, response) {
                that.dataSource.loadData(that.entityType, [{ Field: that.displayProperty, Operator: "contains", Term: request.term }].concat(that.additionalFilters), [], that.sort, (request.term.length == 0) ? that.top : null, null).then(function (res) {
                    response(Array.from(res.records, function (rec) { return { value: rec[that.displayProperty], id: rec.ID }; }));
                }).catch(function (err) {
                    console.log("Error while filtering data: " + err);
                });
            },
            minLength: 0,
            select: function (event, ui) {
                that.id = ui.item.id;
                that.changeEvent.next(ui.item.id);
                that.idString = ui.item.value;
                that.selected.next(ui.item.id);
            },
            focus: function (event, ui) {
                event.preventDefault();
                jQuery(that.elRef.nativeElement).find('#inputCon_SuperAC_' + that.controlID).val(ui.item.value);
            },
            change: function (event, ui) {
                if (that.idString != jQuery(that.elRef.nativeElement).find('#inputCon_SuperAC_' + that.controlID).val()) {
                    jQuery(that.elRef.nativeElement).find('#inputCon_SuperAC_' + that.controlID).val("");
                    that.idString = "";
                    that.changeEvent.next(null);
                }
            }
        }).focus(function () {
            jQuery(this).autocomplete("search", jQuery(this).val());
        });
    };
    LookupJqueryControl.prototype.changeZIndex = function () {
        var datepicker = document.getElementsByClassName('ui-autocomplete ui-front ui-menu ui-widget ui-widget-content');
        for (var i = 0; i < datepicker.length; i++) {
            var temp = document.getElementById(datepicker.item(i).id);
            temp.style.setProperty("z-index", "1055");
        }
    };
    LookupJqueryControl.staticID = 1;
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], LookupJqueryControl.prototype, "id", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], LookupJqueryControl.prototype, "placeholder", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], LookupJqueryControl.prototype, "entityType", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], LookupJqueryControl.prototype, "popupComponent", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], LookupJqueryControl.prototype, "displayProperty", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], LookupJqueryControl.prototype, "additionalFilters", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], LookupJqueryControl.prototype, "sortArray", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], LookupJqueryControl.prototype, "top", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', core_1.ReflectiveInjector)
    ], LookupJqueryControl.prototype, "dynamicBinding", void 0);
    __decorate([
        core_1.HostListener('blur', ['$event']), 
        __metadata('design:type', Function)
    ], LookupJqueryControl.prototype, "onTouched", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_2.EventEmitter)
    ], LookupJqueryControl.prototype, "showPopup", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_2.EventEmitter)
    ], LookupJqueryControl.prototype, "changeEvent", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_2.EventEmitter)
    ], LookupJqueryControl.prototype, "saveEvent", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_2.EventEmitter)
    ], LookupJqueryControl.prototype, "entitySubmitted", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_2.EventEmitter)
    ], LookupJqueryControl.prototype, "selected", void 0);
    __decorate([
        core_2.ViewChild(core_1.forwardRef(function () { return index_2.PlaceholderComponent; })), 
        __metadata('design:type', index_2.PlaceholderComponent)
    ], LookupJqueryControl.prototype, "placeHolders", void 0);
    __decorate([
        core_2.ViewChild("lookupPopupModal"), 
        __metadata('design:type', core_2.ElementRef)
    ], LookupJqueryControl.prototype, "modalPopup", void 0);
    LookupJqueryControl = __decorate([
        core_2.Component({
            selector: 'lookup[ngControl], lookup[ngFormControl], lookup[ngModel]',
            encapsulation: core_2.ViewEncapsulation.Emulated,
            template: '<div class="input-group input-group-icon input-group-btn"><input id="inputCon" type="text" [(value)]="idString" class="form-control" [placeholder]="placeholder" style="border-top-left-radius:4px; border-bottom-left-radius:4px;" (click)="changeZIndex()"> <button type="button" class="mb-xs btn btn-default" (click)="onAdd()"><i class="fa fa-plus"></i></button> <button type="button" class="mb-xs btn btn-warning" style="border-top-right-radius:4px; border-bottom-right-radius:4px;" (click)="onEdit()"><i class="fa fa-pencil"></i></button></div><div class="modal fade" tabindex="-1" role="dialog" #lookupPopupModal><div class="modal-block modal-header-color modal-block-primary lookup-popup"><place-holder [name]="popupComponent"></place-holder></div></div>'
        }),
        __param(0, core_2.Self()), 
        __metadata('design:paramtypes', [forms_1.NgControl, core_2.ElementRef, core_1.ComponentFactoryResolver, core_2.ViewContainerRef, index_1.IEntityDataService])
    ], LookupJqueryControl);
    return LookupJqueryControl;
}());
exports.LookupJqueryControl = LookupJqueryControl;
