"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var router_1 = require('@angular/router');
var index_1 = require('./../interfaces/index');
var index_2 = require('./../models/index');
var index_3 = require('./../services/index');
require('rxjs/Rx');
var MenuComponent = (function () {
    function MenuComponent(globalDataShare, logger, router, loginService, permissionService, activeMenuItem, zone) {
        var _this = this;
        this.globalDataShare = globalDataShare;
        this.logger = logger;
        this.router = router;
        this.loginService = loginService;
        this.permissionService = permissionService;
        this.activeMenuItem = activeMenuItem;
        this.zone = zone;
        this.home = "";
        this.rootRoute = "";
        this.methodCall = new core_1.EventEmitter();
        this.plainMenu = new Array();
        this.permissionsLoadedEE = new core_1.EventEmitter();
        this.permissionsLoaded = false;
        logger.log('MenuComponent instatinated!');
        index_1.DecoratorRegistrations.registeredDecorators.filter(function (x) { return x instanceof index_2.MenuItem; }).map(function (exDecorated) { return _this.plainMenu.push(exDecorated); });
        if (loginService.userLoggedIn) {
            this.permissionCheck(this.plainMenu);
        }
        else {
            var that = this;
            loginService.UserLoginInfoObservable.subscribe(function (next) {
                if (next.UserLoggedIn) {
                    that.permissionCheck(that.plainMenu);
                }
            });
        }
        this.permissionsLoadedEE.subscribe(function (next) { return _this.permissionsLoaded = next; });
    }
    MenuComponent.prototype.sortMenuItem = function () {
        this.recursiveSortMenuItem(this.plainMenu);
    };
    MenuComponent.prototype.recursiveSortMenuItem = function (level) {
        var remain = level.length;
        level.sort(function (x, y) {
            if (x.Name == null && y.Name == null)
                return 0;
            else if (x.Name == null)
                return -1;
            else if (y.Name == null)
                return 1;
            else if (x.Name < y.Name)
                return -1;
            else if (x.Name > y.Name)
                return 1;
            else
                return 0;
        });
        for (var i = 0; i < remain; i++) {
            this.recursiveSortMenuItem(level[i].Children);
        }
    };
    MenuComponent.prototype.getAllClaims = function (menuItems, claims) {
        var that = this;
        menuItems.map(function (item) {
            if (item.Children.length > 0)
                that.getAllClaims(item.Children, claims);
            if (item.ClaimResource !== '' && claims.filter(function (v) { return v.ClaimResource == item.ClaimResource && v.ClaimRight == item.ClaimRight; }).length == 0)
                claims.push(new index_2.MyClaim(item.ClaimResource, item.ClaimRight));
        });
    };
    MenuComponent.prototype.applyMyClaims = function (menuItems, claims) {
        var that = this;
        var anyVisible = false;
        for (var i = 0; i < menuItems.length; i++) {
            if (menuItems[i].Children.length > 0) {
                menuItems[i].Visible = that.applyMyClaims(menuItems[i].Children, claims);
                anyVisible = menuItems[i].Visible || anyVisible;
            }
            else {
                if (menuItems[i].ClaimResource !== '' && claims.filter(function (v) { return v.ClaimResource == menuItems[i].ClaimResource && v.ClaimRight == menuItems[i].ClaimRight && v.Applies; }).length > 0) {
                    menuItems[i].Visible = anyVisible = true;
                }
                else {
                    menuItems[i].Visible = anyVisible = false;
                }
            }
        }
        return anyVisible;
    };
    MenuComponent.prototype.permissionCheck = function (menuItems) {
        var _this = this;
        var claimsToLoad = [];
        this.getAllClaims(menuItems, claimsToLoad);
        var that = this;
        this.permissionService.reloadAllClaims().then(function (claims) {
            _this.zone.run(function () {
                that.applyMyClaims(menuItems, claims);
                that.permissionsLoadedEE.next(true);
            });
        });
    };
    MenuComponent.prototype.gotoHome = function ($event) {
        this.activeMenuItem.Crumbs = [this.home];
        this.activeMenuItem.SelectedItem = { Name: this.home, Link: "/", Icon: "", Tooltip: "", Children: [] };
        this.router.navigate([this.rootRoute]);
        jQuery(".nano li").removeClass("nav-active");
        jQuery("li.home").addClass("nav-active");
    };
    MenuComponent.prototype.gotoMenuDirection = function ($event, menuItem) {
        this.activeMenuItem.SelectedItem = menuItem;
        this.activeMenuItem.Crumbs = menuItem.Parent.split('/');
        jQuery(".nano li.nav-active").removeClass("nav-active");
        jQuery($event.target).parents("li").first().addClass("nav-active");
    };
    MenuComponent.prototype.ngAfterViewInit = function () {
        var that = this;
        if (this.permissionsLoaded)
            this.executeThemeScript();
        else {
            this.permissionsLoadedEE.subscribe(function (next) {
                setTimeout(function () { if (next)
                    that.executeThemeScript(); }, 100);
            });
        }
    };
    MenuComponent.prototype.executeThemeScript = function () {
        if (CurrentTheme) {
            if (CurrentTheme.navigationInit)
                CurrentTheme.navigationInit(jQuery);
            if (CurrentTheme.skeletonInit)
                CurrentTheme.skeletonInit(jQuery);
            if (CurrentTheme.bootstrapToggle)
                CurrentTheme.bootstrapToggle(jQuery);
            if (jQuery(".nano").nanoScroller)
                jQuery(".nano").nanoScroller();
        }
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], MenuComponent.prototype, "home", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], MenuComponent.prototype, "rootRoute", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Object)
    ], MenuComponent.prototype, "methodCall", void 0);
    MenuComponent = __decorate([
        core_1.Component({
            selector: 'app-menu',
            template: '<div class="nano"><div class="nano-content"><nav id="menu" class="nav-main" role="navigation"><ul class="nav nav-main"><li class="nav-active home"><a href="#/app" (click)="gotoHome($event)"><i class="fa fa-home" aria-hidden="true"></i> <span>{{home}}</span></a></li><li *ngFor="let menuItem1 of plainMenu" ngClass="{{menuItem1.CSSClass}}"><a *ngIf="menuItem1.Visible && menuItem1.Children.length === 0" href="#/{{menuItem1.Link}}" (click)="gotoMenuDirection($event, menuItem1)" data-placement="top" data-toggle="tooltip" [attr.data-original-title]="menuItem1.Tooltip"><i aria-hidden="true"></i> <span>{{menuItem1.Name}}</span></a> <a *ngIf="menuItem1.Visible && menuItem1.Children.length !== 0"><i class="{{menuItem1.Icon}}" aria-hidden="true"></i> <span>{{menuItem1.Name}}</span></a><ul *ngIf="menuItem1.Visible && menuItem1.Children.length !== 0" class="nav nav-children"><li *ngFor="let menuItem2 of menuItem1.Children" ngClass="{{menuItem2.CSSClass}}"><a *ngIf="menuItem2.Visible && menuItem2.Children.length === 0" href="#/{{menuItem2.Link}}" (click)="gotoMenuDirection($event, menuItem2)" data-placement="top" data-toggle="tooltip" [attr.data-original-title]="menuItem2.Tooltip"><i aria-hidden="true"></i> <span>{{menuItem2.Name}}</span></a> <a *ngIf="menuItem2.Visible && menuItem2.Children.length !== 0"><i class="{{menuItem2.Icon}}" aria-hidden="true"></i> <span>{{menuItem2.Name}}</span></a><ul *ngIf="menuItem2.Visible && menuItem2.Children.length !== 0" class="nav nav-children"><li *ngFor="let menuItem3 of menuItem2.Children" ngClass="{{menuItem3.CSSClass}}"><a *ngIf="menuItem3.Visible && menuItem3.Children.length === 0" href="#/{{menuItem3.Link}}" (click)="gotoMenuDirection($event, menuItem3)" data-placement="top" data-toggle="tooltip" [attr.data-original-title]="menuItem3.Tooltip"><i aria-hidden="true"></i> <span>{{menuItem3.Name}}</span></a></li></ul></li></ul></li></ul></nav></div></div><script>\r\n            // Preserve Scroll Position\r\n            if (typeof localStorage !== \'undefined\') {\r\n                if (localStorage.getItem(\'sidebar-left-position\') !== null) {\r\n                    var initialPosition = localStorage.getItem(\'sidebar-left-position\'),\r\n                    sidebarLeft = document.querySelector(\'#sidebar-left .nano-content\');\r\n                    sidebarLeft.scrollTop = initialPosition;\r\n                }\r\n            }\r\n</script>'
        }), 
        __metadata('design:paramtypes', [index_2.GlobalDataSharing, index_3.TestLogger, router_1.Router, index_3.LoginService, index_3.PermissionProvider, index_2.ActiveMenuItem, core_1.NgZone])
    ], MenuComponent);
    return MenuComponent;
}());
exports.MenuComponent = MenuComponent;
