"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var index_1 = require("./../interfaces/index");
var TagAutocompleteJqueryControl = (function () {
    function TagAutocompleteJqueryControl(cd, elRef, dataSource, currentZone) {
        var _this = this;
        this.elRef = elRef;
        this.dataSource = dataSource;
        this.currentZone = currentZone;
        this.additionalFilters = [];
        this.disabled = false;
        this.displayProperty = 'Name';
        this.iconClass = '';
        this.placeholder = '';
        this.sortDirection = 'ASC';
        this.sortProperty = 'ID';
        this.styleClass = '';
        this.tagClass = 'label label-info';
        this.top = 30;
        this.valueProperty = 'ID';
        this.change = new core_1.EventEmitter();
        this.selected = new core_1.EventEmitter();
        this.loadedEE = new core_1.EventEmitter();
        this.values = [];
        cd.valueAccessor = this;
        this.controlID = ++TagAutocompleteJqueryControl.staticID;
        this.loadedEE.subscribe(function (next) {
            if (!next)
                return;
            if (!_this.values && _this.values.length > 0) {
                jQuery.each(_this.values, function (i, item) {
                    _this.addTag(item);
                });
                _this.change.next(_this.values);
            }
            else {
                var $input = jQuery(_this.elRef.nativeElement).find('#inputCon_SuperTAC_' + _this.controlID);
                var self = $input.data("ui-autocomplete");
                self.clear();
                _this.change.next([]);
            }
        });
    }
    TagAutocompleteJqueryControl.prototype.addTag = function (valueID) {
        var $input = jQuery(this.elRef.nativeElement).find('#inputCon_SuperTAC_' + this.controlID);
        var self = $input.data("ui-autocomplete");
        var that = this;
        this.dataSource.fetchEntity(this.entityType, valueID).then(function (rest) {
            var data = { value: rest[that.displayProperty], id: rest[that.valueProperty] };
            self.addTag(data);
            that.values.push(valueID);
        });
    };
    TagAutocompleteJqueryControl.prototype.ngAfterViewInit = function () {
        var that = this;
        if (that.entityType && that.values && that.values.length !== 0) {
            this.currentZone.run(function () {
                that.loadedEE.next(true);
            });
        }
        that.additionalFilters = [];
        if (that.additionalFilters) {
            that.additionalFilters = this.additionalFilters.filter(function (x) { return x.Term; });
        }
        var sort = that.sortProperty + ' ' + that.sortDirection;
        jQuery(that.elRef.nativeElement).find("#inputCon").attr('id', 'inputCon_SuperTAC_' + that.controlID);
        jQuery(that.elRef.nativeElement).find('#inputCon_SuperTAC_' + that.controlID).autocomplete({
            source: function (request, response) {
                that.dataSource.loadData(that.entityType, [{ Field: that.displayProperty, Operator: "startsWith", Term: request.term }].concat(that.additionalFilters), [], sort, that.top, 0).then(function (res) {
                    response(Array.from(res.records, function (rest) { return { value: rest[that.displayProperty], id: rest[that.valueProperty] }; }));
                }).catch(function (err) {
                    console.log("Error while filtering data: " + err);
                });
            },
            minLength: 0,
            multiselect: true,
            tagClass: that.tagClass,
            select: function (event, ui) {
                if (ui)
                    that.values.push(ui.item.id);
                that.change.next(that.values);
                that.selected.next(ui.item.id);
            },
            remove: function (event, item) {
                if (item)
                    that.values.splice(that.values.indexOf(item.id), 1);
                that.change.next(that.values);
            }
        });
    };
    TagAutocompleteJqueryControl.prototype.setValue = function (value) {
        var _this = this;
        if (typeof value !== 'object')
            return;
        this.values = value;
        this.touched();
        this.change.next(value);
        this.currentZone.run(function () {
            _this.loadedEE.next(true);
        });
    };
    TagAutocompleteJqueryControl.prototype.registerOnChange = function (fn) {
        this.change.subscribe(fn);
    };
    TagAutocompleteJqueryControl.prototype.registerOnTouched = function (fn) {
        this.touched = fn;
    };
    TagAutocompleteJqueryControl.prototype.writeValue = function (value) {
        if (typeof value !== 'object')
            return;
        if (!value) {
            this.values = [];
            return;
        }
        if (!this.values || !this.values.equals(value)) {
            this.values = value;
            if (this.entityType) {
                this.loadedEE.next(true);
            }
        }
    };
    TagAutocompleteJqueryControl.staticID = 1;
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], TagAutocompleteJqueryControl.prototype, "additionalFilters", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], TagAutocompleteJqueryControl.prototype, "disabled", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], TagAutocompleteJqueryControl.prototype, "displayProperty", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], TagAutocompleteJqueryControl.prototype, "entityType", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], TagAutocompleteJqueryControl.prototype, "iconClass", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], TagAutocompleteJqueryControl.prototype, "placeholder", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], TagAutocompleteJqueryControl.prototype, "sortDirection", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], TagAutocompleteJqueryControl.prototype, "sortProperty", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], TagAutocompleteJqueryControl.prototype, "styleClass", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], TagAutocompleteJqueryControl.prototype, "tagClass", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], TagAutocompleteJqueryControl.prototype, "top", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], TagAutocompleteJqueryControl.prototype, "valueProperty", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], TagAutocompleteJqueryControl.prototype, "change", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], TagAutocompleteJqueryControl.prototype, "selected", void 0);
    __decorate([
        core_1.HostListener('blur', ['$event']), 
        __metadata('design:type', Function)
    ], TagAutocompleteJqueryControl.prototype, "touched", void 0);
    TagAutocompleteJqueryControl = __decorate([
        core_1.Component({
            selector: 'tag-autocompleter[ngControl], tag-autocompleter[ngFormControl], tag-autocompleter[ngModel]',
            encapsulation: core_1.ViewEncapsulation.Emulated,
            template: '<input id="inputCon" type="text" [class]="styleClass" [disabled]="disabled" [placeholder]="placeholder"> <span *ngIf="iconClass" class="input-group-addon"><span class="icon"><i class="{{iconClass}}"></i></span></span>',
            styleUrls: ['/templates/controls/tag-autocomplete-jquery.control.css']
        }),
        __param(0, core_1.Self()), 
        __metadata('design:paramtypes', [forms_1.NgControl, core_1.ElementRef, index_1.IEntityDataService, core_1.NgZone])
    ], TagAutocompleteJqueryControl);
    return TagAutocompleteJqueryControl;
}());
exports.TagAutocompleteJqueryControl = TagAutocompleteJqueryControl;
