"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var forms_1 = require('@angular/forms');
var index_1 = require('./../../models/index');
var index_2 = require('./../../services/index');
var AutocompleteWrapperControl = (function () {
    function AutocompleteWrapperControl(logger, fb) {
        this.logger = logger;
        this.fb = fb;
        this.parent = { entity: new index_1.BaseEntity(), entityForm: null };
        this.propertyName = "ID";
        this.disabled = false;
        this.additionalFilters = [];
        this.styleClass = '';
        this.selected = new core_1.EventEmitter();
        this.change = new core_1.EventEmitter();
        this.validators = [];
        this.isHighlight = false;
        this.customizedForm = fb.group({ TextField: [""] });
        logger.log("Autocomplete control constructed!");
    }
    AutocompleteWrapperControl.prototype.setParentComponent = function (parentComponent, propertyName) {
        this.parent = parentComponent;
        this.propertyName = propertyName;
        this.validators = this.parent.entity.getValidators()[this.propertyName];
        this.customizedForm.controls['TextField'].validator = forms_1.Validators.compose(this.validators.map(function (x) { return x.Validator; }));
        parentComponent.entityForm.addControl(this.propertyName, this.customizedForm.controls["TextField"]);
        var comparedEntity = this.parent.comparedEntity;
        if (comparedEntity) {
            this.isHighlight = comparedEntity[this.propertyName] !== this.parent.entity[this.propertyName];
        }
    };
    AutocompleteWrapperControl.prototype.onChangeEvent = function (value) {
        this.change.next(value);
    };
    AutocompleteWrapperControl.prototype.onSelectedEvent = function (value) {
        this.selected.next(value);
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], AutocompleteWrapperControl.prototype, "propertyName", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], AutocompleteWrapperControl.prototype, "entityType", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], AutocompleteWrapperControl.prototype, "disabled", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], AutocompleteWrapperControl.prototype, "additionalFilters", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], AutocompleteWrapperControl.prototype, "styleClass", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], AutocompleteWrapperControl.prototype, "selected", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], AutocompleteWrapperControl.prototype, "change", void 0);
    AutocompleteWrapperControl = __decorate([
        core_1.Component({
            template: '<div [formGroup]="customizedForm"><div class="form-group"><label for="TextField">New {{propertyName}}</label><autocompleter [isHighlight]="isHighlight" formControlName="TextField" [(ngModel)]="parent.entity[propertyName]" (change)="onChangeEvent($event)" (selected)="onSelectedEvent($event)" [entityType]="entityType" [styleClass]="styleClass" [additionalFilters]="additionalFilters" [disabled]="disabled"></autocompleter><div *ngFor="let validator of validators"><div *ngIf="customizedForm.controls[\'TextField\'].hasError(validator.ErrorCode) && !customizedForm.controls[\'TextField\'].pristine" class="ui error message">{{validator.ErrorMessage}}</div></div></div></div>'
        }), 
        __metadata('design:paramtypes', [index_2.TestLogger, forms_1.FormBuilder])
    ], AutocompleteWrapperControl);
    return AutocompleteWrapperControl;
}());
exports.AutocompleteWrapperControl = AutocompleteWrapperControl;
