"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var index_1 = require('./../../models/index');
var index_2 = require('./../../services/index');
var ClaimWrapperControl = (function () {
    function ClaimWrapperControl(logger, elRef) {
        this.logger = logger;
        this.elRef = elRef;
        this.title = "";
        this.claimResource = "";
        this.ReadRight = false;
        this.NewRight = false;
        this.EditRight = false;
        this.RemoveRight = false;
        this.controlID = ++ClaimWrapperControl.staticID;
        logger.log("Claim control constructed!");
    }
    ClaimWrapperControl.prototype.ngAfterViewInit = function () {
        var that = this;
        jQuery(this.elRef.nativeElement).find("#read-claim").attr('id', 'read-claim_SuperTX_' + this.controlID);
        jQuery(this.elRef.nativeElement).find("#new-claim").attr('id', 'new-claim_SuperTX_' + this.controlID);
        jQuery(this.elRef.nativeElement).find("#edit-claim").attr('id', 'edit-claim_SuperTX_' + this.controlID);
        jQuery(this.elRef.nativeElement).find("#remove-claim").attr('id', 'remove-claim_SuperTX_' + this.controlID);
    };
    ClaimWrapperControl.prototype.GetClaim = function () {
        var claims = new Array();
        if (this.ReadRight)
            claims.push(new index_1.MyClaim(this.claimResource, index_1.MyClaim.READ_CLAIM_RIGHT));
        if (this.NewRight)
            claims.push(new index_1.MyClaim(this.claimResource, index_1.MyClaim.NEW_CLAIM_RIGHT));
        if (this.EditRight)
            claims.push(new index_1.MyClaim(this.claimResource, index_1.MyClaim.EDIT_CLAIM_RIGHT));
        if (this.RemoveRight)
            claims.push(new index_1.MyClaim(this.claimResource, index_1.MyClaim.REMOVE_CLAIM_RIGHT));
        return claims;
    };
    ClaimWrapperControl.prototype.SetClaim = function (claims) {
        for (var _i = 0, claims_1 = claims; _i < claims_1.length; _i++) {
            var claim = claims_1[_i];
            if (claim.ClaimRight == index_1.MyClaim.READ_CLAIM_RIGHT)
                this.ReadRight = true;
            if (claim.ClaimRight == index_1.MyClaim.NEW_CLAIM_RIGHT)
                this.NewRight = true;
            if (claim.ClaimRight == index_1.MyClaim.EDIT_CLAIM_RIGHT)
                this.EditRight = true;
            if (claim.ClaimRight == index_1.MyClaim.REMOVE_CLAIM_RIGHT)
                this.RemoveRight = true;
        }
    };
    ClaimWrapperControl.staticID = 1;
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], ClaimWrapperControl.prototype, "title", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], ClaimWrapperControl.prototype, "claimResource", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], ClaimWrapperControl.prototype, "claimEntity", void 0);
    ClaimWrapperControl = __decorate([
        core_1.Component({
            selector: 'claim',
            template: '<div class="col-md-12"><label class="col-md-4" for="TextField">{{title}}</label><checkbox class="col-md-2" id="read-claim" [(ngModel)]="claimEntity[0].Applies" [value]="claimEntity[0].Applies" [text]="claimEntity[0].ClaimRight"></checkbox><checkbox class="col-md-2" id="new-claim" [(ngModel)]="claimEntity[1].Applies" [value]="claimEntity[1].Applies" [text]="claimEntity[1].ClaimRight"></checkbox><checkbox class="col-md-2" id="edit-claim" [(ngModel)]="claimEntity[2].Applies" [value]="claimEntity[2].Applies" [text]="claimEntity[2].ClaimRight"></checkbox><checkbox class="col-md-2" id="remove-claim" [(ngModel)]="claimEntity[3].Applies" [value]="claimEntity[3].Applies" [text]="claimEntity[3].ClaimRight"></checkbox></div>'
        }), 
        __metadata('design:paramtypes', [index_2.TestLogger, core_1.ElementRef])
    ], ClaimWrapperControl);
    return ClaimWrapperControl;
}());
exports.ClaimWrapperControl = ClaimWrapperControl;
