"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var forms_1 = require('@angular/forms');
var index_1 = require('./../../models/index');
var index_2 = require('./../../services/index');
var datepicker_jquery_control_1 = require('./../datepicker-jquery.control');
var index_3 = require('./../../components/index');
var DatePickerWrapperControl = (function () {
    function DatePickerWrapperControl(logger, fb, zone) {
        this.logger = logger;
        this.fb = fb;
        this.zone = zone;
        this.parent = { entity: new index_1.BaseEntity(), entityForm: null };
        this.propertyName = "ID";
        this.validators = [];
        this.isHighlight = false;
        this.customizedForm = fb.group({ DateField: [""] });
        logger.log("DatePicker control constructed!");
        var that = this;
        this.sub = index_3.EntityChangeService.entityChange.subscribe(function (entity) {
            return that.zone.run(function () {
                var msDate = entity[that.propertyName];
                that.proxyDateValue = that.msDateToDate(msDate);
            });
        });
    }
    DatePickerWrapperControl.prototype.setParentComponent = function (parentComponent, propertyName) {
        this.parent = parentComponent;
        this.propertyName = propertyName;
        this.validators = this.parent.entity.getValidators()[this.propertyName];
        if (!this.validators)
            this.validators = [];
        this.customizedForm.controls['DateField'].validator = forms_1.Validators.compose(this.validators.map(function (x) { return x.Validator; }));
        parentComponent.entityForm.addControl(this.propertyName, this.customizedForm.controls["DateField"]);
        var propertyData = parentComponent.entity[propertyName];
        if (propertyData)
            this.proxyDateValue = this.msDateToDate(propertyData);
        var comparedEntity = this.parent.comparedEntity;
        if (comparedEntity) {
            this.isHighlight = comparedEntity[this.propertyName] !== this.parent.entity[this.propertyName];
        }
    };
    DatePickerWrapperControl.prototype.onChange = function () {
        var date = this.dateTime.getValue();
        if (date)
            this.parent.entity[this.propertyName] = this.dateToMsDate(date);
    };
    DatePickerWrapperControl.prototype.msDateToDate = function (msDate) {
        var msTime = msDate.split('(')[1].split(')')[0];
        if (msTime.includes('+'))
            msTime = msTime.split('+')[0];
        return new Date(Number(msTime));
    };
    DatePickerWrapperControl.prototype.dateToMsDate = function (date) {
        return "\/Date(" + date.getTime() + "+" + date.getTimezoneOffset() + ")\/";
    };
    DatePickerWrapperControl.prototype.ngOnDestroy = function () {
        if (this.sub)
            this.sub.unsubscribe();
    };
    __decorate([
        core_1.ViewChild('dateTimeJquery'), 
        __metadata('design:type', datepicker_jquery_control_1.DatePickerJqueryControl)
    ], DatePickerWrapperControl.prototype, "dateTime", void 0);
    DatePickerWrapperControl = __decorate([
        core_1.Component({
            template: '<div [formGroup]="customizedForm"><div class="form-group"><label for="DateField">{{propertyName}}</label><datepick #dateTimeJquery formControlName="DateField" [(ngModel)]="proxyDateValue" (change)="onChange()" [isHighlight]="isHighlight"></datepick><div *ngFor="let validator of validators"><div *ngIf="customizedForm.controls[\'DateField\'].hasError(validator.ErrorCode) && !customizedForm.controls[\'DateField\'].pristine" class="ui error message">{{validator.ErrorMessage}}</div></div></div></div>',
        }), 
        __metadata('design:paramtypes', [index_2.TestLogger, forms_1.FormBuilder, core_1.NgZone])
    ], DatePickerWrapperControl);
    return DatePickerWrapperControl;
}());
exports.DatePickerWrapperControl = DatePickerWrapperControl;
