"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var forms_1 = require('@angular/forms');
var entitybase_1 = require('./../../models/entitybase');
var logger_1 = require('./../../services/logger');
var dropdown_jquery_control_1 = require('./../dropdown-jquery.control');
var index_1 = require('./../../components/index');
var DropDownWrapperControl = (function () {
    function DropDownWrapperControl(logger, fb, zone) {
        this.logger = logger;
        this.fb = fb;
        this.zone = zone;
        this.parent = { entity: new entitybase_1.BaseEntity(), entityForm: null };
        this.propertyName = "ID";
        this.validators = [];
        this.displayProperty = "Name";
        this.isHighlight = false;
        this.customizedForm = fb.group({ ReferenceField: [""] });
        logger.log("DropDown control constructed!");
        var that = this;
        this.entityTypeSubcribe = index_1.EntityChangeService.entityTypeChange.subscribe(function (entitys) {
            return that.zone.run(function () {
                var entityDic = entitys.filter(function (e) { return e.key == that.propertyReference; })[0];
                if (entityDic) {
                    that.entityType = entityDic.type;
                    var entity = new that.entityType();
                    var propertyArray = entity.browseFields.filter(function (col) { return col.Name != 'ID'; });
                    if (propertyArray.length == 0)
                        that.displayProperty = "ID";
                    else
                        that.displayProperty = propertyArray[0].Name;
                }
            });
        });
    }
    DropDownWrapperControl.prototype.setParentComponent = function (parentComponent, propertyName) {
        var _this = this;
        this.parent = parentComponent;
        this.propertyName = propertyName;
        this.propertyReference = this.parent.entity.browseFields.find(function (item) { return item.Name == _this.propertyName; }).ReferenceType;
        this.validators = this.parent.entity.getValidators()[this.propertyName];
        if (!this.validators)
            this.validators = [];
        this.customizedForm.controls['ReferenceField'].validator = forms_1.Validators.compose(this.validators.map(function (x) { return x.Validator; }));
        parentComponent.entityForm.addControl(this.propertyName, this.customizedForm.controls["ReferenceField"]);
        index_1.EntityChangeService.entiTyIDChange.emit(this.propertyReference);
        var comparedEntity = this.parent.comparedEntity;
        if (comparedEntity) {
            this.isHighlight = comparedEntity[this.propertyName] !== this.parent.entity[this.propertyName];
        }
    };
    DropDownWrapperControl.prototype.onChangeEvent = function () {
        this.parent.entity[this.propertyName] = this.dropDown.getValue();
    };
    DropDownWrapperControl.prototype.onSelectedEvent = function (event) {
    };
    DropDownWrapperControl.prototype.ngOnDestroy = function () {
        if (this.entitySubcribe)
            this.entitySubcribe.unsubscribe();
        if (this.entityTypeSubcribe)
            this.entityTypeSubcribe.unsubscribe();
    };
    __decorate([
        core_1.ViewChild('dropDownJquery'), 
        __metadata('design:type', dropdown_jquery_control_1.DropdownJqueryControl)
    ], DropDownWrapperControl.prototype, "dropDown", void 0);
    DropDownWrapperControl = __decorate([
        core_1.Component({
            template: '<div [formGroup]="customizedForm"><div class="form-group"><label for="ReferenceField">{{propertyName}}</label><dropdown #dropDownJquery [isHighlight]="isHighlight" formControlName="ReferenceField" [(ngModel)]="parent.entity[propertyName]" [displayProperty]="displayProperty" (change)="onChangeEvent()" (selected)="onSelectedEvent($event)" [entityType]="entityType" [additionalFilters]="additionalFilters" [disabled]="disabled"></dropdown><div *ngFor="let validator of validators"><div *ngIf="customizedForm.controls[\'ReferenceField\'].hasError(validator.ErrorCode) && !customizedForm.controls[\'ReferenceField\'].pristine" class="ui error message">{{validator.ErrorMessage}}</div></div></div></div>'
        }), 
        __metadata('design:paramtypes', [logger_1.TestLogger, forms_1.FormBuilder, core_1.NgZone])
    ], DropDownWrapperControl);
    return DropDownWrapperControl;
}());
exports.DropDownWrapperControl = DropDownWrapperControl;
