"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var forms_1 = require('@angular/forms');
var entitybase_1 = require('./../../models/entitybase');
var logger_1 = require('./../../services/logger');
var index_1 = require('./../../interfaces/index');
var dropdown_jquery_control_1 = require('./../dropdown-jquery.control');
var lookup_jquery_control_1 = require('./../lookup-jquery.control');
var index_2 = require('./../../components/index');
var index_3 = require('./../../interfaces/index');
var DropDownAndLookupWrapperControl = (function () {
    function DropDownAndLookupWrapperControl(logger, fb, zone, restService, injector) {
        var _this = this;
        this.logger = logger;
        this.fb = fb;
        this.zone = zone;
        this.restService = restService;
        this.injector = injector;
        this.parent = { entity: new entitybase_1.BaseEntity(), entityForm: null };
        this.propertyName = "ID";
        this.validators = [];
        this.displayProperty = "Name";
        this.referenceComponent = index_2.GenericFormComponent;
        this.showDropDown = false;
        this.showLookup = false;
        this.customizedForm = fb.group({ ReferenceField: [""] });
        logger.log("DropDown And Lookup control constructed!");
        var that = this;
        this.entityTypeSubcribe = index_2.EntityChangeService.entityTypeChange.subscribe(function (entitys) {
            return that.zone.run(function () {
                var entityDic = entitys.filter(function (e) { return e.key == that.propertyReference; })[0];
                if (entityDic) {
                    that.entityType = entityDic.type;
                    var newProvider = core_1.ReflectiveInjector.resolve([{ provide: "entityType", useValue: that.entityType }]);
                    that.entityTypeProvider = core_1.ReflectiveInjector.fromResolvedProviders(newProvider, _this.injector);
                    restService.loadData(that.entityType, [], [], "ID", 20, 0).then(function (entity) {
                        if (entity.totalCount < 20)
                            that.showDropDown = true;
                        else
                            that.showLookup = true;
                    });
                    var entity = new that.entityType();
                    var propertyShortString_1 = null;
                    var propertyLongString_1 = null;
                    var propertyNotEndWithID_1 = null;
                    entity.browseFields.forEach(function (col) {
                        if (col.DataType == index_1.DataTypeEnum.string && propertyShortString_1 == null)
                            propertyShortString_1 = col;
                        else if (col.DataType == index_1.DataTypeEnum.longstring && propertyLongString_1 == null)
                            propertyLongString_1 = col;
                        else if (!col.Name.endsWith('ID') && propertyNotEndWithID_1 == null) {
                            propertyNotEndWithID_1 = col;
                        }
                    });
                    if (propertyShortString_1)
                        that.displayProperty = propertyShortString_1.Name;
                    else if (propertyLongString_1)
                        that.displayProperty = propertyLongString_1.Name;
                    else if (propertyNotEndWithID_1)
                        that.displayProperty = propertyNotEndWithID_1.Name;
                    else
                        that.displayProperty = "ID";
                }
            });
        });
    }
    DropDownAndLookupWrapperControl.prototype.setParentComponent = function (parentComponent, propertyName) {
        var _this = this;
        this.parent = parentComponent;
        this.propertyName = propertyName;
        this.propertyReference = this.parent.entity.browseFields.find(function (item) { return item.Name == _this.propertyName; }).ReferenceType;
        this.validators = this.parent.entity.getValidators()[this.propertyName];
        if (!this.validators)
            this.validators = [];
        this.customizedForm.controls['ReferenceField'].validator = forms_1.Validators.compose(this.validators.map(function (x) { return x.Validator; }));
        parentComponent.entityForm.addControl(this.propertyName, this.customizedForm.controls["ReferenceField"]);
        index_2.EntityChangeService.entiTyIDChange.emit(this.propertyReference);
    };
    DropDownAndLookupWrapperControl.prototype.onChangeEvent = function (value) {
        if (this.showDropDown)
            this.parent.entity[this.propertyName] = this.dropDown.getValue();
        else
            this.parent.entity[this.propertyName] = value;
    };
    DropDownAndLookupWrapperControl.prototype.onSelectedEvent = function (event) {
    };
    DropDownAndLookupWrapperControl.prototype.ngOnDestroy = function () {
        if (this.entitySubcribe)
            this.entitySubcribe.unsubscribe();
        if (this.entityTypeSubcribe)
            this.entityTypeSubcribe.unsubscribe();
    };
    __decorate([
        core_1.ViewChild('dropDownJquery'), 
        __metadata('design:type', dropdown_jquery_control_1.DropdownJqueryControl)
    ], DropDownAndLookupWrapperControl.prototype, "dropDown", void 0);
    __decorate([
        core_1.ViewChild('lookupJquery'), 
        __metadata('design:type', lookup_jquery_control_1.LookupJqueryControl)
    ], DropDownAndLookupWrapperControl.prototype, "lookup", void 0);
    DropDownAndLookupWrapperControl = __decorate([
        core_1.Component({
            template: '<div [formGroup]="customizedForm"><div class="form-group"><label for="ReferenceField">{{propertyName}}</label><dropdown *ngIf="showDropDown" #dropDownJquery formControlName="ReferenceField" [(ngModel)]="parent.entity[propertyName]" [displayProperty]="displayProperty" (change)="onChangeEvent($event)" (selected)="onSelectedEvent($event)" [entityType]="entityType" [additionalFilters]="additionalFilters" [disabled]="disabled"></dropdown><lookup *ngIf="showLookup" #lookupJquery formControlName="ReferenceField" [(ngModel)]="parent.entity[propertyName]" [displayProperty]="displayProperty" [popupComponent]="referenceComponent" (changeEvent)="onChangeEvent($event)" [entityType]="entityType" [dynamicBinding]="entityTypeProvider"></lookup><div *ngFor="let validator of validators"><div *ngIf="customizedForm.controls[\'ReferenceField\'].hasError(validator.ErrorCode) && !customizedForm.controls[\'ReferenceField\'].pristine" class="ui error message">{{validator.ErrorMessage}}</div></div></div></div>',
        }), 
        __metadata('design:paramtypes', [logger_1.TestLogger, forms_1.FormBuilder, core_1.NgZone, index_3.IEntityDataService, core_1.Injector])
    ], DropDownAndLookupWrapperControl);
    return DropDownAndLookupWrapperControl;
}());
exports.DropDownAndLookupWrapperControl = DropDownAndLookupWrapperControl;
