"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
var index_1 = require('./../../models/index');
var index_2 = require('./../../interfaces/index');
var ng2_file_upload_1 = require('ng2-file-upload/ng2-file-upload');
var FileUploadWrapperControl = (function () {
    function FileUploadWrapperControl(entityService, http) {
        this.entityService = entityService;
        this.http = http;
        this.successEvent = new core_1.EventEmitter();
        this.errorEvent = new core_1.EventEmitter();
        this.FileUploadedList = [];
        this.dataEntity = index_1.BaseEntity;
        this.uploaderOptions = {};
        this.totallyUploaded = 0;
        this.multiple = true;
        this.isShowFileList = false;
        this.errorFileSize = false;
    }
    Object.defineProperty(FileUploadWrapperControl.prototype, "entityType", {
        set: function (EntityType) {
            this.dataEntity = EntityType;
        },
        enumerable: true,
        configurable: true
    });
    FileUploadWrapperControl.prototype.ngOnInit = function () {
        this.uploaderOptions.queueLimit = this.queueLimit;
        this.uploaderOptions.maxFileSize = this.maxFileSize * 1024 * 1024;
        this.uploaderOptions.autoUpload = this.autoUpload;
        this.uploaderOptions.allowedMimeType = this.allowedMimeType;
        this.uploaderOptions.allowedFileType = this.allowedFileType;
        this.uploader = new ng2_file_upload_1.FileUploader(this.uploaderOptions);
        this.multiple = (!this.queueLimit || this.queueLimit > 1);
    };
    FileUploadWrapperControl.prototype.getTarget = function (obj) {
        var targ;
        var e = obj;
        if (e.target)
            targ = e.target;
        else if (e.srcElement)
            targ = e.srcElement;
        if (targ.nodeType == 3)
            targ = targ.parentNode;
        return targ;
    };
    FileUploadWrapperControl.prototype.onChange = function ($event) {
        var target = this.getTarget($event);
        if (target.files[0].size > this.maxFileSize * 1024 * 1024) {
            this.errorFileSize = true;
        }
        else {
            this.errorFileSize = false;
            this.uploader.queue.pop();
            this.uploader.addToQueue(target.files);
            this.isShowFileList = this.uploader.queue.length > 0;
            if (this.autoUpload)
                this.uploadAll();
        }
    };
    FileUploadWrapperControl.prototype.uploadAll = function () {
        var that = this;
        that.totallyUploaded = 0;
        for (var index = 0; index < that.uploader.queue.length; index++) {
            var fileItem = that.uploader.queue[index];
            var file = fileItem._file;
            this.readFileToBase64(file, index);
        }
    };
    FileUploadWrapperControl.prototype.readFileToBase64 = function (file, fileIndex) {
        var _this = this;
        var dataBinary;
        var reader = new FileReader();
        var _fileTemp = file;
        reader.onload = function (file) {
            var contents = file.target;
            dataBinary = btoa(contents.result);
            var byteArray = _this.convertStringToByteArray(dataBinary);
            if (_this.url === undefined || _this.url === null)
                _this.saveFileToDatabase(byteArray, _fileTemp, fileIndex);
            else
                _this.saveFileToDatabaseByUrl(byteArray, _fileTemp, fileIndex);
        };
        reader.readAsBinaryString(file);
    };
    FileUploadWrapperControl.prototype.saveFileToDatabase = function (dataBinary, file, fileIndex) {
        var _this = this;
        var that = this;
        var fileEntity = new this.dataEntity();
        fileEntity.FileDataBinary = dataBinary;
        fileEntity.Name = file.name;
        fileEntity.Type = file.type;
        fileEntity.Size = file.size;
        var myFileEntityAction = "SaveFile_" + Math.random() * 10000013;
        that.entityService.dataObserver.subscribe(function (newEntity) {
            if (newEntity.ID == myFileEntityAction) {
                that.totallyUploaded++;
                var ratio = 100 / that.uploader.queue.length;
                that.uploader.progress = that.totallyUploaded * ratio;
                that.uploader.queue[fileIndex].isSuccess = true;
                that.FileUploadedList.push(newEntity.data[0].ID);
                that.uploader.queue[fileIndex].alias = newEntity.data[0].ID;
                that.successEvent.next(that.FileUploadedList);
            }
        });
        that.entityService.createEntity(this.dataEntity, fileEntity, myFileEntityAction);
        that.entityService.errorObserver.subscribe(function (newEntity) {
            that.uploader.queue[fileIndex].isSuccess = false;
            that.uploader.queue[fileIndex].isError = true;
            _this.errorEvent.emit({ ID: "", errorData: null, errorMessage: 'File not upload', inputData: fileEntity });
        });
    };
    FileUploadWrapperControl.prototype.saveFileToDatabaseByUrl = function (dataBinary, file, fileIndex) {
        var _this = this;
        var that = this;
        var fileEntity = new this.dataEntity();
        fileEntity.FileDataBinary = dataBinary;
        fileEntity.Name = file.name;
        fileEntity.Type = file.type;
        fileEntity.Size = file.size;
        var headers = new http_1.Headers({ 'Content-Type': 'application/json' });
        var options = new http_1.RequestOptions({ headers: headers });
        that.http.post(that.url, JSON.stringify(that.fileEntity), options)
            .subscribe(function (data) {
            var ratio = 100 / that.uploader.queue.length;
            that.uploader.progress = (fileIndex + 1) * ratio;
            that.uploader.queue[fileIndex].isSuccess = true;
            that.uploader.queue[fileIndex].isError = false;
            that.FileUploadedList.push(data.json().ID);
            that.uploader.queue[fileIndex].alias = data.json().ID;
            that.successEvent.next(data.json().ID);
        }, function (error) {
            that.uploader.queue[fileIndex].isSuccess = false;
            that.uploader.queue[fileIndex].isError = true;
            _this.errorEvent.emit({ ID: "", errorData: error, errorMessage: 'File not upload', inputData: that.fileEntity });
        });
    };
    FileUploadWrapperControl.prototype.removeAll = function () {
        for (var _i = 0, _a = this.uploader.queue; _i < _a.length; _i++) {
            var file = _a[_i];
            this.removeFile(file);
        }
    };
    FileUploadWrapperControl.prototype.removeFile = function (file) {
        var _this = this;
        var that = this;
        var myFileEntityAction = 'FileUploadDelete_' + (Math.random() * 1000013);
        if (file.alias !== "file") {
            this.entityService.fetchEntity(that.dataEntity, file.alias).then(function (res) {
                var fileEntity = res;
                that.entityService.deleteEntity(_this.dataEntity, fileEntity);
                file.remove();
                var ratio = 100 / that.FileUploadedList.length;
                that.uploader.progress = that.uploader.queue.length * ratio;
                that.removeFromFileUploaded(file.alias);
            });
        }
        else {
            file.remove();
        }
        that.isShowFileList = that.uploader.queue.length > 0;
    };
    FileUploadWrapperControl.prototype.removeFromFileUploaded = function (value) {
        var index = this.FileUploadedList.indexOf(value);
        var item = this.FileUploadedList[index];
        this.FileUploadedList.splice(index, 1);
    };
    FileUploadWrapperControl.prototype.downloadFileById = function (fileId) {
        var _this = this;
        this.entityService.fetchEntity(this.dataEntity, fileId).then(function (res) {
            var fileEntity = res;
            var dataString = _this.convertByteArrayToString(fileEntity.FileDataBinary);
            _this.downloadFile(dataString, fileEntity.Name);
        });
    };
    FileUploadWrapperControl.prototype.downloadFile = function (dataBinaryStr, fileName) {
        var fileUri;
        if (dataBinaryStr != null) {
            var data = atob(dataBinaryStr);
            var arraybuffer = new ArrayBuffer(data.length);
            var view = new Uint8Array(arraybuffer);
            for (var i = 0; i < data.length; i++) {
                view[i] = data.charCodeAt(i) & 0xff;
            }
            try {
                var blob = new Blob([arraybuffer], { type: 'application/octet-stream' });
            }
            catch (e) {
                var bb = new MSBlobBuilder();
                bb.append(arraybuffer);
                var blob = bb.getBlob('application/octet-stream');
            }
            saveAs(blob, fileName);
        }
    };
    FileUploadWrapperControl.prototype.convertByteArrayToString = function (dataByteArray) {
        var dataString = "";
        for (var i = 0; i < dataByteArray.length; i++) {
            dataString += String.fromCharCode(dataByteArray[i]);
        }
        return dataString;
    };
    FileUploadWrapperControl.prototype.convertStringToByteArray = function (dataBinaryStr) {
        var byteNumbers = [];
        for (var i = 0; i < dataBinaryStr.length; i++) {
            byteNumbers.push(dataBinaryStr.charCodeAt(i));
        }
        return byteNumbers;
    };
    FileUploadWrapperControl.prototype.formatMSDate = function (date) {
        var timezonePart = "";
        var tzMin = date.getTimezoneOffset();
        if (date.getTimezoneOffset() > 0)
            timezonePart += '-';
        else {
            timezonePart += '+';
            tzMin = -tzMin;
        }
        if (tzMin < 600)
            timezonePart += '0';
        timezonePart += Math.floor(tzMin / 60).toString();
        if ((tzMin % 60) < 10)
            timezonePart += '0';
        timezonePart += (tzMin % 60).toString();
        return "\/Date(" + date.valueOf() + timezonePart + ")\/";
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], FileUploadWrapperControl.prototype, "url", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], FileUploadWrapperControl.prototype, "queueLimit", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], FileUploadWrapperControl.prototype, "maxFileSize", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], FileUploadWrapperControl.prototype, "autoUpload", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], FileUploadWrapperControl.prototype, "allowedMimeType", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], FileUploadWrapperControl.prototype, "allowedFileType", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object), 
        __metadata('design:paramtypes', [Object])
    ], FileUploadWrapperControl.prototype, "entityType", null);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], FileUploadWrapperControl.prototype, "successEvent", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], FileUploadWrapperControl.prototype, "errorEvent", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Array)
    ], FileUploadWrapperControl.prototype, "FileUploadedList", void 0);
    FileUploadWrapperControl = __decorate([
        core_1.Component({
            selector: 'file-upload',
            template: '<div><span class="btn btn-primary fileinput-button"><i class="fa fa-plus"></i> <span>Add files...</span> <input type="file" (change)="onChange($event)" [multiple]="multiple" multiple></span> <button type="button" class="btn btn-success btn-s" (click)="uploadAll()" [disabled]="!uploader.getNotUploadedItems().length"><span class="fa fa-upload"></span> Upload all</button> <button type="button" class="btn btn-danger btn-s" (click)="removeAll()" [disabled]="!uploader.queue.length"><span class="fa fa-trash"></span> Remove all</button><div *ngIf="errorFileSize" style="color:red">Max file size is {{maxFileSize}} MB.</div><div *ngIf="isShowFileList">Queue progress:<div class="progress progress-striped light active"><div class="progress-bar progress-bar-primary" role="progressbar" aria-valuemin="0" aria-valuemax="100" [ngStyle]="{ \'width\': uploader.progress + \'%\' }">{{uploader.progress + \'%\'}}</div></div></div></div><table class="table" *ngIf="isShowFileList"><thead><tr><th width="50%">Name</th><th>Size</th><th>Status</th><th></th></tr></thead><tbody><tr *ngFor="let item of uploader.queue"><td><strong>{{ item?.file?.name }}</strong></td><td nowrap>{{ item?.file?.size/1024/1024 | number:\'.2\' }} MB</td><td class="text-center"><span *ngIf="item.isSuccess"><i class="fa fa-check"></i></span> <span *ngIf="item.isCancel"><i class="fa fa-ban"></i></span> <span *ngIf="item.isError"><i class="fa fa-remove"></i></span></td><td nowrap><button type="button" class="btn btn-danger btn-xs" (click)="removeFile(item)"><span class="fa fa-trash"></span></button></td></tr></tbody></table>'
        }),
        core_1.Injectable(), 
        __metadata('design:paramtypes', [index_2.IEntityDataService, http_1.Http])
    ], FileUploadWrapperControl);
    return FileUploadWrapperControl;
}());
exports.FileUploadWrapperControl = FileUploadWrapperControl;
