import { EventEmitter } from '@angular/core';
import { Observable } from 'rxjs/Rx';
import { ErrorInCommand } from './../models/index';
import { IEmptyConstruct, IDataStructure, IFieldFilter, IComposableFilter, IActionInfo, IDataChanged } from './index';
import { ChangesCommit, EntityWithTotalCount } from './index';
import { Message } from 'primeng/primeng';
export declare abstract class IEntityDataService {
    data: Array<any>;
    dataObserver: EventEmitter<IDataChanged>;
    errorObserver: EventEmitter<ErrorInCommand>;
    abstract registerNewChangesStream(newStream: Observable<ChangesCommit>): void;
    abstract getEntityNameID(DataStructure: IEmptyConstruct): string;
    abstract reloadData(DataStructure: IEmptyConstruct, loadDataID?: string): string;
    abstract getCurrentLibrary(DataStructure: IEmptyConstruct, filters?: IFieldFilter[]): Array<any>;
    abstract fetchEntityWithID(ID: string): void;
    abstract fetchEntity(DataStructure: IEmptyConstruct, ID: string, serverReload?: boolean): Promise<any>;
    abstract updateEntity(DataStructure: IEmptyConstruct, entity: any, emitID?: string): void;
    abstract createEntity(DataStructure: IEmptyConstruct, entity: IDataStructure, emitID?: string): void;
    abstract deleteEntity(DataStructure: IEmptyConstruct, entity: IDataStructure, emitID?: string): void;
    abstract executeOnEntityList(DataStructure: IEmptyConstruct, actionName: string, entity: IDataStructure[], successMessage: Message, emitID?: string): void;
    abstract executeOnEntity(DataStructure: IEmptyConstruct, actionName: string, entity: IDataStructure, successMessage: Message, emitID?: string): void;
    abstract loadData(DataStructure: IEmptyConstruct, filters: IFieldFilter[], predefinedFilters?: IComposableFilter[], sort?: string, top?: number, skip?: number): Promise<EntityWithTotalCount>;
    abstract getSingleByID(DataStructure: IEmptyConstruct, ID: string): Promise<IDataStructure>;
    abstract getSingle(DataStructure: IEmptyConstruct, route: string, filters?: IFieldFilter[]): Promise<any>;
    abstract findEntity(DataStructure: IEmptyConstruct, route: string, filters?: IFieldFilter[], top?: number, skip?: number): Promise<any>;
    abstract getDummy(DataStructure: IEmptyConstruct): IDataStructure;
    abstract userHasPermission(DataStructure: IEmptyConstruct, permissionRight: string): Promise<boolean>;
    abstract invokeAction(ActionInfo: IActionInfo, data: any): Promise<any>;
    abstract getCurrentPrincipal(): Promise<any>;
}
