export declare enum DataTypeEnum {
    string = 0,
    datetime = 1,
    number = 2,
    boolean = 3,
    binary = 4,
    longstring = 5,
}
export declare enum FilterMatchMode {
    contains = 0,
    startsWith = 1,
    endsWith = 2,
    notContains = 3,
    equals = 4,
    notEquals = 5,
    greater = 6,
    greaterEqual = 7,
    less = 8,
    lessEqual = 9,
}
export interface IFieldDefinition {
    Title?: string;
    Width?: number;
    Name: string;
    Pipe?: string;
    DataType: DataTypeEnum;
    IsFilterEnabled?: boolean;
    FilterMatchMode?: FilterMatchMode;
    ClassName?: string;
    DataStyle?: any;
    IsSortedColumn?: boolean;
    ReferenceType?: string;
}
export declare class FieldDefinition implements IFieldDefinition {
    Title: string;
    Width: number;
    Name: string;
    Pipe: string;
    DataType: DataTypeEnum;
    IsFilterEnabled: boolean;
    FilterMatchMode: FilterMatchMode;
    ClassName: string;
    DataStyle: any;
    IsSortedColumn: boolean;
}
