import { BaseEntity } from './../models/index';
import { ValidatorDefinition, IFieldDefinition } from './../interfaces/index';
export declare class Claim extends BaseEntity {
    ClaimResource: string;
    ClaimRight: string;
    Active: boolean;
    ID: string;
    getNewInstance(): Claim;
    getModuleName(): string;
    getEntityName(): string;
    getValidators(): {
        [propName: string]: ValidatorDefinition[];
    };
    toRhetosRESTQueryString(claim: Claim): string;
    browseFields: Array<IFieldDefinition>;
    setModelData(modelData: Claim): void;
    private jsonReplaceHelper(prop, val);
}
export declare class MyClaim extends Claim {
    ClaimResource: string;
    ClaimRight: string;
    Active: boolean;
    ID: string;
    Applies: boolean;
    constructor(claimResource?: string, claimRight?: string, applies?: boolean);
    getNewInstance(): MyClaim;
    getModuleName(): string;
    getEntityName(): string;
    toRhetosRESTQueryString(claim?: MyClaim): string;
    static readonly READ_CLAIM_RIGHT: string;
    static readonly NEW_CLAIM_RIGHT: string;
    static readonly EDIT_CLAIM_RIGHT: string;
    static readonly REMOVE_CLAIM_RIGHT: string;
}
