"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var index_1 = require('./../models/index');
var index_2 = require('./../interfaces/index');
var Claim = (function (_super) {
    __extends(Claim, _super);
    function Claim() {
        _super.apply(this, arguments);
        this.browseFields = [
            { Name: "ClaimResource", Pipe: "", DataType: index_2.DataTypeEnum.string },
            { Name: "ClaimRight", Pipe: "", DataType: index_2.DataTypeEnum.string }
        ];
    }
    Claim.prototype.getNewInstance = function () { return new Claim(); };
    Claim.prototype.getModuleName = function () { return "Common"; };
    Claim.prototype.getEntityName = function () { return "Claim"; };
    Claim.prototype.getValidators = function () { return {}; };
    Claim.prototype.toRhetosRESTQueryString = function (claim) {
        if (claim)
            return '{"ClaimResource":"' + claim.ClaimResource + '","ClaimRight":"' + claim.ClaimRight + '"}';
        else
            return '{"ClaimResource":"' + this.ClaimResource + '","ClaimRight":"' + this.ClaimRight + '"}';
    };
    Claim.prototype.setModelData = function (modelData) {
        if (modelData) {
            this.ID = modelData.ID;
            this.ClaimResource = modelData.ClaimResource;
            this.ClaimRight = modelData.ClaimRight;
            this.Active = modelData.Active;
        }
    };
    Claim.prototype.jsonReplaceHelper = function (prop, val) {
        if (!val)
            return undefined;
        return val;
    };
    return Claim;
}(index_1.BaseEntity));
exports.Claim = Claim;
var MyClaim = (function (_super) {
    __extends(MyClaim, _super);
    function MyClaim(claimResource, claimRight, applies) {
        _super.call(this);
        this.Applies = false;
        this.ClaimResource = claimResource;
        this.ClaimRight = claimRight;
        this.Applies = applies;
    }
    MyClaim.prototype.getNewInstance = function () { return new MyClaim(); };
    MyClaim.prototype.getModuleName = function () { return "Common"; };
    MyClaim.prototype.getEntityName = function () { return "MyClaim"; };
    MyClaim.prototype.toRhetosRESTQueryString = function (claim) {
        if (claim)
            return '{"ClaimResource":"' + claim.ClaimResource + '","ClaimRight":"' + claim.ClaimRight + '"}';
        else
            return '{"ClaimResource":"' + this.ClaimResource + '","ClaimRight":"' + this.ClaimRight + '"}';
    };
    Object.defineProperty(MyClaim, "READ_CLAIM_RIGHT", {
        get: function () { return "Read"; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MyClaim, "NEW_CLAIM_RIGHT", {
        get: function () { return "New"; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MyClaim, "EDIT_CLAIM_RIGHT", {
        get: function () { return "Edit"; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MyClaim, "REMOVE_CLAIM_RIGHT", {
        get: function () { return "Remove"; },
        enumerable: true,
        configurable: true
    });
    return MyClaim;
}(Claim));
exports.MyClaim = MyClaim;
