import { IEmptyConstruct, IDataStructure, IFieldDefinition, ValidatorDefinition } from './../interfaces/index';
export declare class BaseEntity implements IDataStructure {
    ID: string;
    private getName();
    getValidators(): {
        [propName: string]: ValidatorDefinition[];
    };
    browseFields: Array<IFieldDefinition>;
    getInstance(): IEmptyConstruct;
    getRootEntity(): IDataStructure;
    getNewInstance(): IDataStructure;
    getModuleName(): string;
    getEntityName(): string;
    getHasReadRowPermissions(): boolean;
    getNameID(): string;
    setModelData(modelData: IDataStructure): void;
    entityToJSON(): string;
    fromRawEntity(entity: IDataStructure): IDataStructure;
}
