"use strict";
var index_1 = require('./../interfaces/index');
var BaseEntity = (function () {
    function BaseEntity() {
        this.browseFields = [{ Name: "ID", Pipe: "", DataType: index_1.DataTypeEnum.string }];
    }
    BaseEntity.prototype.getName = function () {
        var funcNameRegex = /function (.{1,})\(/;
        var results = (funcNameRegex).exec(this.constructor.toString());
        return (results && results.length > 1) ? results[1] : "";
    };
    BaseEntity.prototype.getValidators = function () {
        return {};
    };
    BaseEntity.prototype.getInstance = function () { throw this.getName() + ": getInstance has to be overriden."; };
    BaseEntity.prototype.getRootEntity = function () { return this.getNewInstance(); };
    BaseEntity.prototype.getNewInstance = function () { throw this.getName() + ": getNewInstance has to be overriden."; };
    BaseEntity.prototype.getModuleName = function () { return ""; };
    BaseEntity.prototype.getEntityName = function () { return ""; };
    BaseEntity.prototype.getHasReadRowPermissions = function () { return false; };
    BaseEntity.prototype.getNameID = function () { return this.getModuleName() + '_' + this.getEntityName(); };
    BaseEntity.prototype.setModelData = function (modelData) {
        if (modelData) {
            this.ID = modelData.ID;
        }
    };
    BaseEntity.prototype.entityToJSON = function () {
        return JSON.stringify(this, function (k, v) { if (v === null || v === '' || k == 'browseFields')
            return undefined; return v; });
    };
    BaseEntity.prototype.fromRawEntity = function (entity) {
        return entity;
    };
    return BaseEntity;
}());
exports.BaseEntity = BaseEntity;
