"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var index_1 = require('./../interfaces/index');
var DownloadFileService = (function () {
    function DownloadFileService(entityService) {
        this.entityService = entityService;
    }
    DownloadFileService.prototype.downloadFileById = function (entityType, id) {
        var _this = this;
        this.entityService.fetchEntity(entityType, id).then(function (res) {
            var fileEntity = res;
            var dataString = _this.convertByteArrayToString(fileEntity.FileDataBinary);
            _this.downloadFile(dataString, fileEntity.Name);
        });
    };
    DownloadFileService.prototype.convertByteArrayToString = function (dataByteArray) {
        var dataString = "";
        for (var i = 0; i < dataByteArray.length; i++) {
            dataString += String.fromCharCode(dataByteArray[i]);
        }
        return dataString;
    };
    DownloadFileService.prototype.downloadFile = function (dataBinaryStr, fileName) {
        var fileUri;
        if (dataBinaryStr != null) {
            var data = atob(dataBinaryStr);
            var arraybuffer = new ArrayBuffer(data.length);
            var view = new Uint8Array(arraybuffer);
            for (var i = 0; i < data.length; i++) {
                view[i] = data.charCodeAt(i) & 0xff;
            }
            try {
                var blob = new Blob([arraybuffer], { type: 'application/octet-stream' });
            }
            catch (e) {
                var bb = new MSBlobBuilder();
                bb.append(arraybuffer);
                var blob = bb.getBlob('application/octet-stream');
            }
            saveAs(blob, fileName);
        }
    };
    DownloadFileService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [index_1.IEntityDataService])
    ], DownloadFileService);
    return DownloadFileService;
}());
exports.DownloadFileService = DownloadFileService;
