"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var router_1 = require('@angular/router');
var http_1 = require('@angular/http');
var app_settings_1 = require('./../app/app.settings');
var index_1 = require('./../interfaces/index');
var index_2 = require('../services/index');
var FormsLoginService = (function (_super) {
    __extends(FormsLoginService, _super);
    function FormsLoginService(_http, _entityService, router) {
        _super.call(this, _http, _entityService, router);
        this._http = _http;
        this._entityService = _entityService;
        this.router = router;
    }
    FormsLoginService.prototype.forgotPassword = function (params) {
        var headers = new http_1.Headers({ 'Content-Type': 'application/json' });
        var options = new http_1.RequestOptions({ headers: headers });
        var that = this;
        return new Promise(function (resolve, reject) {
            that.http.post(app_settings_1.AppSettings.LOGIN_ENDPOINT + '/forgot-password', JSON.stringify(params), options).subscribe(function (res) {
                if (res.text() == "true") {
                    resolve({ isSuccess: true, message: "Reset password instruction mail has been send to your email!" });
                }
                else {
                    resolve({ isSuccess: false, message: res.text() });
                }
            }, function (res) {
                console.log('Login failure: ' + res.text());
                resolve({ isSuccess: false, message: res.text() });
            }, function () { });
        });
    };
    FormsLoginService.prototype.startResetPassword = function (params) {
        var headers = new http_1.Headers({ 'Content-Type': 'application/json' });
        var options = new http_1.RequestOptions({ headers: headers });
        var that = this;
        var text = '';
        return new Promise(function (resolve, reject) {
            that.http.post(app_settings_1.AppSettings.LOGIN_ENDPOINT + '/start-reset-password', JSON.stringify(params), options).subscribe(function (res) {
                if (res.text() == "true") {
                    resolve({ isSuccess: true, message: "Reset password instruction mail has been send to your email!" });
                }
                else {
                    resolve({ isSuccess: false, message: res.text() });
                }
            }, function (res) {
            }, function () { });
        });
    };
    FormsLoginService.prototype.resetPasswordWithToken = function (params) {
        var headers = new http_1.Headers({ 'Content-Type': 'application/json' });
        var options = new http_1.RequestOptions({ headers: headers });
        var that = this;
        var username = "";
        return new Promise(function (resolve, reject) {
            that.http.post(app_settings_1.AppSettings.LOGIN_ENDPOINT + '/request-reset-password', JSON.stringify(params), options).subscribe(function (res) {
                if (res.text() == "true") {
                    resolve({ isSuccess: true, message: "Your password reset successfully!" });
                }
                else {
                    resolve({ isSuccess: false, message: "Reset token is invalid or expired!" });
                }
            }, function (res) {
                resolve({ isSuccess: false, message: "Reset token is invalid or expired!" });
            });
        });
    };
    FormsLoginService.prototype.activeAccountWithToken = function (params) {
        var headers = new http_1.Headers({ 'Content-Type': 'application/json' });
        var options = new http_1.RequestOptions({ headers: headers });
        var that = this;
        var username = "";
        return that.http.post(app_settings_1.AppSettings.LOGIN_ENDPOINT + '/request-active-account', JSON.stringify(params), options).toPromise().then(function (res) {
            if (res.ok == true) {
                return { isSuccess: true, message: res.text() };
            }
            else {
                return { isSuccess: false, message: res.text() };
            }
        }, function (res) {
            return { isSuccess: false, message: res.text() };
        });
    };
    ;
    FormsLoginService.prototype.activatedAccount = function (username) {
        document.cookie = 'rhetosFormsAuth=' + JSON.stringify({ UserName: username });
        this.UserLoginInfoObservable.next({ UserLoggedIn: true, LoggedAs: username, Message: "Activated successful User: " + username, Success: true });
    };
    FormsLoginService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.Http, index_1.IEntityDataService, router_1.Router])
    ], FormsLoginService);
    return FormsLoginService;
}(index_2.LoginService));
exports.FormsLoginService = FormsLoginService;
