import { EventEmitter, Injector } from "@angular/core";
import { Http } from "@angular/http";
import { Observable } from 'rxjs/Rx';
import { IActionInfo, IDataStructure, IEntityDataService, IComposableFilter, IEmptyConstruct } from "./../interfaces/index";
import { IFieldFilter, ChangesCommit, DataChanged, EntityWithTotalCount } from "./../interfaces/index";
import { ErrorInCommand, DataStructureWithClaims } from "./../models/index";
import { Message } from 'primeng/primeng';
export declare class LocalStorageService implements IEntityDataService {
    private injector;
    private _http;
    data: Array<IDataStructure>;
    dataObserver: EventEmitter<DataChanged>;
    errorObserver: EventEmitter<ErrorInCommand>;
    changesStream: Observable<ChangesCommit>;
    protected _dummyEntityInstances: Array<DataStructureWithClaims>;
    protected entCounter: number;
    private _loadedServerStorage;
    browseFieldRemover(key: string, value: any): any;
    private getDummyWithClaims(DataStructure);
    private getDummyWithClaim(DataStructure);
    private createEntityInstance(DataStructure, entity);
    private getWholeStorageAsJSON();
    getDummy(DataStructure: IEmptyConstruct): IDataStructure;
    userHasPermission(DataStructure: IEmptyConstruct, permissionRight: string): Promise<boolean>;
    registerNewChangesStream(newStream: Observable<ChangesCommit>): void;
    getModuleName(DataStructure: IEmptyConstruct): string;
    getEntityName(DataStructure: IEmptyConstruct): string;
    getEntityNameID(DataStructure: IEmptyConstruct): string;
    entityToJSON(entity: IDataStructure): string;
    fromRawEntity(DataStructure: IEmptyConstruct, entity: IDataStructure): IDataStructure;
    constructor(injector: Injector, _http: Http);
    getCurrentLibrary(DataStructure: IEmptyConstruct, filters?: IFieldFilter[]): Array<typeof DataStructure>;
    fetchEntityWithID(ID: string): void;
    fetchEntity(DataStructure: IEmptyConstruct, id: string, serverReload?: boolean): Promise<typeof DataStructure>;
    reloadData(DataStructure: IEmptyConstruct, loadDataID?: string): string;
    createEntity(DataStructure: IEmptyConstruct, entity: IDataStructure, emitID?: string): void;
    updateEntity(DataStructure: IEmptyConstruct, entity: IDataStructure, emitID?: string): void;
    deleteEntity(DataStructure: IEmptyConstruct, entity: IDataStructure): void;
    loadData(DataStructure: IEmptyConstruct, filters: IFieldFilter[], predefinedFilters?: IComposableFilter[], sort?: string, top?: number, skip?: number): Promise<EntityWithTotalCount>;
    findEntity(DataStructure: IEmptyConstruct, route: string, filters?: IFieldFilter[], top?: number, skip?: number): Promise<any>;
    executeOnEntityList(DataStructure: IEmptyConstruct, actionName: string, entity: IDataStructure[], successMessage: Message, emitID?: string): void;
    executeOnEntity(DataStructure: IEmptyConstruct, actionName: string, entity: IDataStructure, successMessage: Message, emitID?: string): void;
    getSingleByID(DataStructure: IEmptyConstruct, ID: string): Promise<IDataStructure>;
    getSingle(DataStructure: IEmptyConstruct, route: string, filters?: IFieldFilter[]): Promise<any>;
    invokeAction(ActionInfo: IActionInfo, data: any): Promise<any>;
    private sortJS(property);
    getCurrentPrincipal(): Promise<EntityWithTotalCount>;
}
