"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
var Rx_1 = require('rxjs/Rx');
var app_settings_1 = require("./../app/app.settings");
var index_1 = require("./../interfaces/index");
var index_2 = require("./../models/index");
var LocalStorageService = (function () {
    function LocalStorageService(injector, _http) {
        this.injector = injector;
        this._http = _http;
        this.dataObserver = new core_1.EventEmitter();
        this.errorObserver = new core_1.EventEmitter();
        this.changesStream = Rx_1.Observable.prototype.startWith(null);
        this._dummyEntityInstances = new Array();
        this.entCounter = 1;
        this._loadedServerStorage = null;
        this.data = new Array();
        this.changesStream = new core_1.EventEmitter();
        var that = this;
        this._http.get(app_settings_1.AppSettings.API_ENDPOINT).subscribe(function (data) {
            that._loadedServerStorage = data.json();
            that._dummyEntityInstances.map(function (x) { return that.reloadData(x.DataStructureType); });
        }, function (error) {
            console.log('Could not load server storage.');
        });
        var saveBatches = this.dataObserver.debounceTime(2000);
        saveBatches.subscribe(function (change) {
            if (change.ID !== '__RELOADDATA__') {
                var headers = new http_1.Headers({ 'Content-Type': 'application/json' });
                var options = new http_1.RequestOptions({ headers: headers });
                that._http.post(app_settings_1.AppSettings.API_ENDPOINT, that.getWholeStorageAsJSON(), options)
                    .subscribe(function (data) {
                    console.log('Server storage updated.');
                }, function (error) { return console.log('Could not update server storage.'); });
            }
        });
        this.changesStream.subscribe(function (change) {
            if (change) {
                change.data.map(function (item) {
                    switch (change.ChangeType) {
                        case index_1.DataChangeType.Update:
                            that.updateEntity(change.DataType, item, change.ID);
                            break;
                        case index_1.DataChangeType.Insert:
                            that.createEntity(change.DataType, item, change.ID);
                            break;
                        case index_1.DataChangeType.Delete:
                            that.deleteEntity(change.DataType, item);
                            break;
                        default:
                            console.log('Unhandled data change registered ' + change.ChangeType);
                    }
                });
            }
        });
    }
    LocalStorageService.prototype.browseFieldRemover = function (key, value) {
        if (key === "browseFields") {
            return undefined;
        }
        return value;
    };
    LocalStorageService.prototype.getDummyWithClaims = function (DataStructure) {
        var res;
        res = this._dummyEntityInstances.find(function (dummy) { return dummy.dataStructure instanceof DataStructure; });
        if (!res) {
            res = new index_2.DataStructureWithClaims(this.injector, DataStructure);
            this._dummyEntityInstances.push(res);
            this.reloadData(DataStructure);
        }
        return res;
    };
    LocalStorageService.prototype.getDummyWithClaim = function (DataStructure) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var res;
            res = _this._dummyEntityInstances.find(function (dummy) { return dummy.dataStructure instanceof DataStructure; });
            if (!res) {
                res = new index_2.DataStructureWithClaims(_this.injector, DataStructure);
                _this._dummyEntityInstances.push(res);
                _this.reloadData(DataStructure);
            }
            resolve(res);
        });
    };
    LocalStorageService.prototype.createEntityInstance = function (DataStructure, entity) {
        var res = new DataStructure();
        res.setModelData(entity);
        return res;
    };
    LocalStorageService.prototype.getWholeStorageAsJSON = function () {
        this.data.filter(function (ent) { return ent.getNameID != null; }).map(function (x) {
            x.__nameID__ = x.getNameID();
        });
        return JSON.stringify(this.data.filter(function (ent) { return ent.__nameID__ != null; }), this.browseFieldRemover);
    };
    LocalStorageService.prototype.getDummy = function (DataStructure) {
        return this.getDummyWithClaims(DataStructure).dataStructure;
    };
    LocalStorageService.prototype.userHasPermission = function (DataStructure, permissionRight) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.getDummyWithClaim(DataStructure).then(function (perm) {
                resolve(Object.prototype.valueOf.call(perm)[permissionRight + 'Right']);
            });
        });
    };
    LocalStorageService.prototype.registerNewChangesStream = function (newStream) {
        var that = this;
        newStream.subscribe(function (change) {
            that.changesStream.next(change);
        });
    };
    LocalStorageService.prototype.getModuleName = function (DataStructure) { return this.getDummy(DataStructure).getModuleName(); };
    LocalStorageService.prototype.getEntityName = function (DataStructure) { return this.getDummy(DataStructure).getEntityName(); };
    LocalStorageService.prototype.getEntityNameID = function (DataStructure) { return this.getDummy(DataStructure).getNameID(); };
    LocalStorageService.prototype.entityToJSON = function (entity) { return entity.entityToJSON(); };
    LocalStorageService.prototype.fromRawEntity = function (DataStructure, entity) { return this.getDummy(DataStructure).fromRawEntity(entity); };
    LocalStorageService.prototype.getCurrentLibrary = function (DataStructure, filters) {
        this.reloadData(DataStructure);
        if (!filters || filters.length === 0)
            return this.data.filter(function (ent) { return ent instanceof DataStructure; }).map(function (x) { return x; });
        else {
            var res = this.data.filter(function (ent) { return ent instanceof DataStructure; }).map(function (x) { return x; });
            filters.forEach(function (fieldFilter) {
                res = res.filter(function (x) { return x[fieldFilter.Field].toString().includes(fieldFilter.Term); });
            });
            return res;
        }
    };
    LocalStorageService.prototype.fetchEntityWithID = function (ID) { };
    LocalStorageService.prototype.fetchEntity = function (DataStructure, id, serverReload) {
        var _this = this;
        this.reloadData(DataStructure);
        var res = null;
        if (!serverReload) {
            this.data.every(function (t) {
                if (t.ID === id && t instanceof DataStructure) {
                    res = _this.createEntityInstance(DataStructure, t);
                    return false;
                }
                return true;
            });
        }
        if (res) {
            return new Promise(function (resolve, reject) {
                console.log('Entity with ID (' + id + ') found in data store.');
                resolve(res);
            });
        }
        else {
            res = this.createEntityInstance(DataStructure, null);
            return new Promise(function (resolve, reject) {
                console.log('Entity with ID (' + id + ') not found in data store.');
                resolve(res);
            });
        }
    };
    LocalStorageService.prototype.reloadData = function (DataStructure, loadDataID) {
        var _this = this;
        if (loadDataID === void 0) { loadDataID = ""; }
        var thisDummyStructure = this.getDummy(DataStructure);
        var reloadDataID = "LSS_ReloadDataID_" + (Math.random() * 1000013);
        if (loadDataID !== "")
            reloadDataID = loadDataID;
        var that = this;
        for (var index = that.data.length - 1; index >= 0; index--) {
            if (that.data[index] instanceof DataStructure) {
                var foundObj = this._loadedServerStorage.filter(function (ent) { return ent.__nameID__ === thisDummyStructure.getNameID() && ent.ID === that.data[index].ID; });
                if (foundObj.length > 0) {
                    that.data.splice(index, 1);
                }
            }
        }
        if (this._loadedServerStorage != null) {
            this._loadedServerStorage.filter(function (ent) { return ent.__nameID__ === thisDummyStructure.getNameID(); }).map(function (ent) {
                var filledEnt = _this.createEntityInstance(DataStructure, ent);
                _this.data.push(filledEnt);
            });
        }
        setTimeout(function () { return _this.dataObserver.next({ ID: reloadDataID, data: _this.data }); }, 50);
        return reloadDataID;
    };
    LocalStorageService.prototype.createEntity = function (DataStructure, entity, emitID) {
        this.reloadData(DataStructure);
        var perm = this.getDummyWithClaims(DataStructure);
        var that = this;
        this.entCounter++;
        entity.ID = this.getEntityNameID(DataStructure) + this.entCounter;
        perm.saveNew(entity, function (finalEnt) {
            that.data.push(entity);
            that.dataObserver.next({ ID: (emitID) ? emitID : "", data: that.data });
        });
    };
    LocalStorageService.prototype.updateEntity = function (DataStructure, entity, emitID) {
        this.reloadData(DataStructure);
        if (!entity.ID) {
            this.createEntity(DataStructure, entity, emitID);
            return;
        }
        var perm = this.getDummyWithClaims(DataStructure);
        var that = this;
        perm.saveOld(entity, function (finalEnt) {
            that.data.forEach(function (rest, i) {
                if (entity.ID === rest.ID) {
                    that.data[i] = entity;
                }
            });
            setTimeout(function () {
                that.dataObserver.next({ ID: (emitID) ? emitID : "", data: that.data });
            }, 2000);
        });
    };
    LocalStorageService.prototype.deleteEntity = function (DataStructure, entity) {
        var _this = this;
        this.reloadData(DataStructure);
        this.data.forEach(function (t, index) {
            if (t.ID === entity.ID && t instanceof DataStructure) {
                _this.data.splice(index, 1);
            }
        });
        this.dataObserver.next({ ID: "", data: this.data });
    };
    LocalStorageService.prototype.loadData = function (DataStructure, filters, predefinedFilters, sort, top, skip) {
        this.reloadData(DataStructure);
        var res = this.data.filter(function (x) { return x instanceof DataStructure; });
        var totalCount = res.length;
        filters.forEach(function (fieldFilter) {
            res = res.filter(function (x) { return x[fieldFilter.Field].toString().search(new RegExp(fieldFilter.Term, 'i')) !== -1; });
        });
        if (sort) {
            res.sort(this.sortJS(sort));
        }
        return new Promise(function (resolve, reject) {
            resolve({
                records: res.slice((skip) ? skip : 0, (top) ? top + (skip ? skip : 0) : 10),
                totalCount: totalCount
            });
        });
    };
    LocalStorageService.prototype.findEntity = function (DataStructure, route, filters, top, skip) {
        return null;
    };
    LocalStorageService.prototype.executeOnEntityList = function (DataStructure, actionName, entity, successMessage, emitID) {
    };
    LocalStorageService.prototype.executeOnEntity = function (DataStructure, actionName, entity, successMessage, emitID) {
    };
    LocalStorageService.prototype.getSingleByID = function (DataStructure, ID) {
        return null;
    };
    LocalStorageService.prototype.getSingle = function (DataStructure, route, filters) {
        var customFilter = route;
        var that = this;
        return this._http.get(app_settings_1.AppSettings.API_ENDPOINT + this.getModuleName(DataStructure) + '/' + this.getEntityName(DataStructure) + '/' + customFilter)
            .map(function (data) {
            return that.fromRawEntity(DataStructure, data.json());
        }, function (error) {
            console.log('Could not load data. ERR: ' + error.toString());
            return that.createEntityInstance(DataStructure, null);
        }).toPromise();
    };
    LocalStorageService.prototype.invokeAction = function (ActionInfo, data) {
        var headers = new http_1.Headers({ 'Content-Type': 'application/json' });
        var options = new http_1.RequestOptions({ headers: headers });
        var that = this;
        if (ActionInfo.isPostAction)
            return this._http.post(ActionInfo.url, data, options).map(function (res) {
                console.log('Post ' + ActionInfo.url + ' successful.');
                return res;
            }, function (error) {
                console.log('Post ' + ActionInfo.url + ' failure ' + error);
                return '';
            }).toPromise();
        else
            return this._http.put(ActionInfo.url, data, options).map(function (res) {
                console.log('Put ' + ActionInfo.url + ' successful.');
                return res;
            }, function (error) {
                console.log('Put ' + ActionInfo.url + ' failure ' + error);
                return '';
            }).toPromise();
    };
    LocalStorageService.prototype.sortJS = function (property) {
        var sortOrder = 1;
        if (property.indexOf('ASC') !== -1 || property.indexOf('asc') !== -1) {
            sortOrder = -1;
        }
        property = property.split(' ')[0];
        return function (a, b) {
            var result = (a[property] < b[property]) ? -1 : (a[property] > b[property]) ? 1 : 0;
            return result * sortOrder;
        };
    };
    LocalStorageService.prototype.getCurrentPrincipal = function () {
        return null;
    };
    LocalStorageService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [core_1.Injector, http_1.Http])
    ], LocalStorageService);
    return LocalStorageService;
}());
exports.LocalStorageService = LocalStorageService;
