"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var router_1 = require('@angular/router');
var http_1 = require('@angular/http');
var Rx_1 = require('rxjs/Rx');
var app_settings_1 = require('./../app/app.settings');
var index_1 = require('./../interfaces/index');
var index_2 = require('./../services/index');
var LoginLocalStorageService = (function () {
    function LoginLocalStorageService(http, entityService, router) {
        this.http = http;
        this.entityService = entityService;
        this.router = router;
        this.userLoggedIn = false;
        this.loggedAs = 'Guest';
        var cookie = document.cookie;
        var that = this;
        this.UserLoginInfoObservable.subscribe(function (loginInfo) {
            that.userLoggedIn = loginInfo.UserLoggedIn;
            that.loggedAs = loginInfo.LoggedAs;
        });
        this.http.get(app_settings_1.AppSettings.LOGIN_ENDPOINT).subscribe(function (res) {
            that._loadedServerStorage = res.json();
            console.log('Ping OK: ' + res);
        }, function (_) {
            console.log('Ping failure. Clearing user info from cookie.');
            document.cookie = 'formsAuth=' + JSON.stringify({ UserName: '' });
        }, function () { });
    }
    Object.defineProperty(LoginLocalStorageService.prototype, "UserLoginInfoObservable", {
        get: function () { return null; },
        enumerable: true,
        configurable: true
    });
    LoginLocalStorageService.prototype.login = function (params) {
        var headers = new http_1.Headers({ 'Content-Type': 'application/json' });
        var options = new http_1.RequestOptions({ headers: headers });
        var that = this;
        var res = null;
        if (this._loadedServerStorage) {
            this._loadedServerStorage.every(function (t) {
                if (t.UserName === params.UserName && t.Password === params.Password) {
                    res = t;
                    return false;
                }
                return true;
            });
            if (res) {
                console.log('Login success: ' + res.UserName);
                if (params.PersistCookie) {
                    document.cookie = 'formsAuth=' + JSON.stringify({ UserName: params.UserName });
                }
                that.UserLoginInfoObservable.next({ UserLoggedIn: true, LoggedAs: params.UserName, Message: "Successful login: " + params.UserName, Success: true });
            }
            else {
                console.log('Login failure !!!');
                that.UserLoginInfoObservable.next({ UserLoggedIn: false, LoggedAs: that.loggedAs, Message: "Unsuccessful login !!!", Success: false });
            }
        }
    };
    LoginLocalStorageService.prototype.logout = function (returnUrl) {
        var that = this;
        console.log('Logout success !!! ');
        document.cookie = 'formsAuth=' + JSON.stringify({ UserName: '' });
        that.UserLoginInfoObservable.next({ UserLoggedIn: false, LoggedAs: "Guest", Message: "Successful Logout: Guest", Success: true });
        if (returnUrl) {
            that.router.navigate([returnUrl]);
        }
    };
    __decorate([
        index_2.GloballyShared(new Rx_1.Subject()), 
        __metadata('design:type', Rx_1.Subject)
    ], LoginLocalStorageService.prototype, "UserLoginInfoObservable", null);
    LoginLocalStorageService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.Http, index_1.IEntityDataService, router_1.Router])
    ], LoginLocalStorageService);
    return LoginLocalStorageService;
}());
exports.LoginLocalStorageService = LoginLocalStorageService;
