import { Router } from '@angular/router';
import { Http } from '@angular/http';
import { Subject } from 'rxjs/Rx';
import { IEntityDataService, ILoginService } from './../interfaces/index';
import { LoginData, LoginInfo, RegisterData } from './../models/index';
export declare class LoginService implements ILoginService {
    protected http: Http;
    protected entityService: IEntityDataService;
    protected router: Router;
    userLoggedIn: boolean;
    loggedAs: string;
    readonly UserLoginInfoObservable: Subject<LoginInfo>;
    constructor(http: Http, entityService: IEntityDataService, router: Router);
    login(params: LoginData): void;
    logout(returnUrl?: string): void;
    register(params: RegisterData): Promise<string>;
}
