import { Http } from '@angular/http';
import { Observable } from 'rxjs/Rx';
import { MyClaim } from './../models/index';
import { IDataStructure, FieldFilter } from './../interfaces/index';
export declare class PermissionProvider {
    private http;
    data$: Observable<Array<MyClaim>>;
    private dataObserver;
    private initialized;
    private dataStore;
    private _dummyMyClaimInstance;
    constructor(http: Http);
    filterAllClaims(filters: FieldFilter[]): Promise<MyClaim[]>;
    checkPermission(claimResource: string, claimRight: string): boolean;
    checkEntityPermission(entity: IDataStructure, claimRight: string): boolean;
    checkPermissions(claimResource: string): MyClaim[];
    checkEntityPermissions(entity: IDataStructure): MyClaim[];
    reloadPermissionsForMultipleClaims(claims: MyClaim[]): Promise<MyClaim[]>;
    reloadPermissionsForResource(entity: IDataStructure): Promise<MyClaim[]>;
    reloadAllClaims(): Promise<MyClaim[]>;
}
