"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
var Rx_1 = require('rxjs/Rx');
var app_settings_1 = require('./../app/app.settings');
var index_1 = require('./../models/index');
var index_2 = require('./../interfaces/index');
var PermissionProvider = (function () {
    function PermissionProvider(http) {
        var _this = this;
        this.http = http;
        this.initialized = false;
        this._dummyMyClaimInstance = new index_1.MyClaim();
        this.data$ = new Rx_1.Observable(function (observer) { return _this.dataObserver = observer; }).share();
        this.dataStore = { data: [] };
    }
    PermissionProvider.prototype.filterAllClaims = function (filters) {
        if (app_settings_1.AppSettings.API_ENDPOINT.length == 0)
            return new Promise(function (resolve, reject) {
                resolve([]);
            });
        else {
            return this.http.get(app_settings_1.AppSettings.API_ENDPOINT + 'Common/Claim/'
                + '?Filters=[' + filters.map(function (filter) { return index_2.FieldFilter.toRhetosRESTQueryString(filter); }).join() + ']')
                .map(function (data) {
                return Array.from(data.json().Records, function (rec) { return rec; });
            }, function (error) {
                console.log('Could not filter data. ERR: ' + error.toString());
                return null;
            }).toPromise();
        }
    };
    PermissionProvider.prototype.checkPermission = function (claimResource, claimRight) {
        var storedPermission = this.dataStore.data.find(function (claim) {
            return (claim.ClaimResource == claimResource) && (claim.ClaimRight == claimRight);
        });
        if (storedPermission)
            return storedPermission.Applies;
        else
            return false;
    };
    PermissionProvider.prototype.checkEntityPermission = function (entity, claimRight) {
        var claimResource = (entity.getModuleName() + '.' + entity.getEntityName());
        return this.checkPermission(claimResource, claimRight);
    };
    PermissionProvider.prototype.checkPermissions = function (claimResource) {
        return this.dataStore.data.filter(function (claim) { return claim.ClaimResource == claimResource; });
    };
    PermissionProvider.prototype.checkEntityPermissions = function (entity) {
        var claimResource = (entity.getModuleName() + '.' + entity.getEntityName());
        return this.checkPermissions(claimResource);
    };
    PermissionProvider.prototype.reloadPermissionsForMultipleClaims = function (claims) {
        var _this = this;
        return this.http.get(app_settings_1.AppSettings.API_ENDPOINT + 'Common/MyClaim/'
            + '?Filters=[{"Filter":"Common.Claim[]","Value":[' + claims.map(function (claim) { return claim.toRhetosRESTQueryString(); }).join() + ']}]')
            .map(function (data) {
            var exResult = Array.from(data.json().Records, function (rec, ix) {
                claims[ix].Applies = rec.Applies;
                var loadedAlready = false;
                for (var i = 0; i < _this.dataStore.data.length; i++)
                    if (_this.dataStore.data[i].ClaimResource === claims[ix].ClaimResource && _this.dataStore.data[i].ClaimRight === claims[ix].ClaimRight) {
                        _this.dataStore.data[i].Applies = claims[ix].Applies;
                        loadedAlready = true;
                    }
                if (!loadedAlready)
                    _this.dataStore.data.push(claims[ix]);
                return claims[ix];
            });
            if (_this.dataObserver)
                _this.dataObserver.next(_this.dataStore.data);
            return exResult;
        }, function (error) {
            console.log('Could not filter data. ERR: ' + error.toString());
            return null;
        }).toPromise();
    };
    PermissionProvider.prototype.reloadPermissionsForResource = function (entity) {
        var _this = this;
        return this.filterAllClaims([{ Field: "ClaimResource", Operator: "Equals", Term: entity.getModuleName() + "." + entity.getEntityName() }]).then(function (res) {
            return _this.http.get(app_settings_1.AppSettings.API_ENDPOINT + 'Common/MyClaim/'
                + '?Filters=[{"Filter":"Common.Claim[]","Value":[' + res.map(function (claim) { return _this._dummyMyClaimInstance.toRhetosRESTQueryString(claim); }).join() + ']}]')
                .map(function (data) {
                var exResult = Array.from(data.json().Records, function (rec, ix) {
                    res[ix].Applies = rec.Applies;
                    var loadedAlready = false;
                    for (var i = 0; i < _this.dataStore.data.length; i++)
                        if (_this.dataStore.data[i].ClaimResource === res[ix].ClaimResource && _this.dataStore.data[i].ClaimRight === res[ix].ClaimRight) {
                            _this.dataStore.data[i].Applies = res[ix].Applies;
                            loadedAlready = true;
                        }
                    if (!loadedAlready)
                        _this.dataStore.data.push(res[ix]);
                    return rec;
                });
                if (_this.dataObserver)
                    _this.dataObserver.next(_this.dataStore.data);
                return exResult;
            }, function (error) {
                console.log('Could not filter data. ERR: ' + error.toString());
                return null;
            }).toPromise();
        });
    };
    PermissionProvider.prototype.reloadAllClaims = function () {
        this.dataStore.data = [];
        var that = this;
        return this.http.get(app_settings_1.AppSettings.API_ENDPOINT + 'Common/GetAllClaims/').map(function (data) {
            var exResult = Array.from(data.json().Records, function (rec) {
                that.dataStore.data.push(rec);
                return rec;
            });
            if (that.dataObserver)
                that.dataObserver.next(that.dataStore.data);
            return exResult;
        }, function (error) {
            console.log('Could not filter data. ERR: ' + error.toString());
            return null;
        }).toPromise();
    };
    PermissionProvider = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.Http])
    ], PermissionProvider);
    return PermissionProvider;
}());
exports.PermissionProvider = PermissionProvider;
