import { EventEmitter, Injector } from '@angular/core';
import { Http } from '@angular/http';
import { Observable } from 'rxjs/Rx';
import { MyClaim } from './../models/index';
import { PermissionProvider } from './../services/permission-provider.service';
import { IDataChanged, IActionInfo, IDataStructure, IEntityDataService, IComposableFilter, IEmptyConstruct, IFieldFilter } from './../interfaces/index';
import { ErrorInCommand, DataStructureWithClaims } from './../models/index';
import { ChangesCommit, EntityWithTotalCount } from './../interfaces/index';
import { NotificationService } from "./index";
import { Message } from 'primeng/primeng';
export declare class WebAPIRestService implements IEntityDataService {
    private injector;
    private permissionProvider;
    private notificationService;
    data: Array<IDataStructure>;
    dataObserver: EventEmitter<IDataChanged>;
    errorObserver: EventEmitter<ErrorInCommand>;
    changesStream: Observable<ChangesCommit>;
    protected _http: Http;
    protected _dummyEntityInstances: Array<DataStructureWithClaims>;
    private getDummyWithClaim(DataStructure);
    private getHasReadRowPermissions(DataStructure);
    private createEntityInstance(DataStructure, model);
    registerNewChangesStream(newStream: Observable<ChangesCommit>): void;
    getModuleName(DataStructure: IEmptyConstruct): string;
    getEntityName(DataStructure: IEmptyConstruct): string;
    getEntityNameID(DataStructure: IEmptyConstruct): string;
    entityToJSON(entity: IDataStructure): string;
    fromRawEntity(DataStructure: IEmptyConstruct, entity: IDataStructure): IDataStructure;
    constructor(http: Http, injector: Injector, permissionProvider: PermissionProvider, notificationService: NotificationService);
    userHasPermission(DataStructure: IEmptyConstruct, permissionRight: string): Promise<boolean>;
    getDummy(DataStructure: IEmptyConstruct): IDataStructure;
    updatePermissions(permissions: MyClaim[]): void;
    fetchEntityWithID(id: string): void;
    fetchEntity(DataStructure: IEmptyConstruct, id: string, serverReload?: boolean): Promise<typeof DataStructure>;
    createEntity(DataStructure: IEmptyConstruct, entity: IDataStructure, emitID?: string): void;
    updateEntity(DataStructure: IEmptyConstruct, entity: IDataStructure, emitID?: string): void;
    deleteEntity(DataStructure: IEmptyConstruct, entity: IDataStructure, emitID?: string): void;
    getCurrentLibrary(DataStructure: IEmptyConstruct, filters?: IFieldFilter[]): Array<typeof DataStructure>;
    reloadData(DataStructure: IEmptyConstruct, loadID?: string): string;
    loadData(DataStructure: IEmptyConstruct, filters: IFieldFilter[], predefinedFilters?: IComposableFilter[], sort?: string, top?: number, skip?: number): Promise<EntityWithTotalCount>;
    getSingleByID(DataStructure: IEmptyConstruct, ID: string): Promise<IDataStructure>;
    getSingle(DataStructure: IEmptyConstruct, route: string, filters?: IFieldFilter[]): Promise<any>;
    findEntity(DataStructure: IEmptyConstruct, route: string, filters?: IFieldFilter[], top?: number, skip?: number): Promise<any>;
    executeOnEntityList(DataStructure: IEmptyConstruct, actionName: string, entity: IDataStructure[], successMessage: Message, emitID?: string): void;
    executeOnEntity(DataStructure: IEmptyConstruct, actionName: string, entity: IDataStructure, successMessage: Message, emitID?: string): void;
    invokeAction(ActionInfo: IActionInfo, data: any): Promise<any>;
    getCurrentPrincipal(): Promise<EntityWithTotalCount>;
}
