"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
var app_settings_1 = require('./../app/app.settings');
var entitybase_1 = require('./../models/entitybase');
var permission_provider_service_1 = require('./../services/permission-provider.service');
var index_1 = require('./../interfaces/index');
var index_2 = require('./../models/index');
var index_3 = require('./../interfaces/index');
var index_4 = require("./index");
var WebAPIRestService = (function () {
    function WebAPIRestService(http, injector, permissionProvider, notificationService) {
        var _this = this;
        this.injector = injector;
        this.permissionProvider = permissionProvider;
        this.notificationService = notificationService;
        this.dataObserver = new core_1.EventEmitter();
        this.errorObserver = new core_1.EventEmitter();
        this._dummyEntityInstances = new Array();
        this.data = new Array();
        this._http = http;
        this.permissionProvider.data$.subscribe(function (newPermissions) { return _this.updatePermissions(newPermissions); });
        this.changesStream = new core_1.EventEmitter();
        this.changesStream.subscribe(function (change) {
            if (change) {
                change.data.map(function (item) {
                    switch (change.ChangeType) {
                        case index_3.DataChangeType.Update:
                            _this.updateEntity(change.DataType, item, change.ID);
                            break;
                        case index_3.DataChangeType.Insert:
                            _this.createEntity(change.DataType, item, change.ID);
                            break;
                        case index_3.DataChangeType.Delete:
                            _this.deleteEntity(change.DataType, item);
                            break;
                        default:
                            console.log('Unhandled data change registered ' + change.ChangeType);
                    }
                });
            }
        });
    }
    WebAPIRestService.prototype.getDummyWithClaim = function (DataStructure) {
        var res;
        res = this._dummyEntityInstances.find(function (dummy) { return dummy.dataStructure instanceof DataStructure; });
        if (!res) {
            res = new index_2.DataStructureWithClaims(this.injector, DataStructure);
            this._dummyEntityInstances.push(res);
        }
        if (!res.PermissionLoaded) {
            var that = this;
            return new Promise(function (resolve, reject) {
                that.permissionProvider.reloadPermissionsForResource(res.dataStructure).then(function (newClaims) {
                    that.updatePermissions(newClaims);
                    resolve(res);
                });
            });
        }
        else {
            return new Promise(function (resolve, reject) { return resolve(res); });
        }
    };
    WebAPIRestService.prototype.getHasReadRowPermissions = function (DataStructure) { return this.getDummy(DataStructure).getHasReadRowPermissions(); };
    WebAPIRestService.prototype.createEntityInstance = function (DataStructure, model) {
        var res = new DataStructure();
        res.setModelData(model);
        return res;
    };
    WebAPIRestService.prototype.registerNewChangesStream = function (newStream) {
        var that = this;
        newStream.subscribe(function (change) {
            that.changesStream.next(change);
        });
    };
    WebAPIRestService.prototype.getModuleName = function (DataStructure) { return this.getDummy(DataStructure).getModuleName(); };
    WebAPIRestService.prototype.getEntityName = function (DataStructure) { return this.getDummy(DataStructure).getEntityName(); };
    WebAPIRestService.prototype.getEntityNameID = function (DataStructure) { return this.getDummy(DataStructure).getNameID(); };
    WebAPIRestService.prototype.entityToJSON = function (entity) {
        var entityJson = entity.entityToJSON();
        return JSON.stringify(JSON.parse(entityJson), function (k, v) { if (v === null || v === '' || k == 'browseFields')
            return undefined; return v; });
    };
    WebAPIRestService.prototype.fromRawEntity = function (DataStructure, entity) {
        var res = new DataStructure();
        res.setModelData(entity);
        return res;
    };
    WebAPIRestService.prototype.userHasPermission = function (DataStructure, permissionRight) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.getDummyWithClaim(DataStructure).then(function (perm) {
                resolve(Object.prototype.valueOf.call(perm)[permissionRight + 'Right']);
            });
        });
    };
    WebAPIRestService.prototype.getDummy = function (DataStructure) {
        var res;
        res = this._dummyEntityInstances.find(function (dummy) { return dummy.dataStructure instanceof DataStructure; });
        if (!res) {
            res = new index_2.DataStructureWithClaims(this.injector, DataStructure);
        }
        return res.dataStructure;
    };
    WebAPIRestService.prototype.updatePermissions = function (permissions) {
        var that = this;
        permissions.map(function (claim) {
            that._dummyEntityInstances.filter(function (dum) { return dum.dataStructure.getModuleName() + '.' + dum.dataStructure.getEntityName() === claim.ClaimResource; })
                .forEach(function (dum) {
                if (claim.ClaimRight === "Edit")
                    dum.EditRight = claim.Applies;
                if (claim.ClaimRight === "New")
                    dum.NewRight = claim.Applies;
                if (claim.ClaimRight === "Remove")
                    dum.RemoveRight = claim.Applies;
                if (claim.ClaimRight === "Read") {
                    if (!dum.ReadRight && claim.Applies) {
                        dum.ReadRight = claim.Applies;
                        that.reloadData(dum.DataStructureType);
                    }
                }
                dum.PermissionLoaded = true;
            });
        });
    };
    WebAPIRestService.prototype.fetchEntityWithID = function (id) {
        var _this = this;
        var that = this;
        if (id) {
            this.data.map(function (t) {
                if (t instanceof entitybase_1.BaseEntity && t.ID === id)
                    _this.fetchEntity(t.getInstance(), id, true);
            });
        }
    };
    WebAPIRestService.prototype.fetchEntity = function (DataStructure, id, serverReload) {
        var _this = this;
        var res = null;
        if (!serverReload) {
            this.data.every(function (t) {
                if (t instanceof DataStructure && t.ID === id) {
                    res = _this.createEntityInstance(DataStructure, t);
                    return false;
                }
                return true;
            });
        }
        if (res) {
            return new Promise(function (resolve, reject) {
                console.log('Entity with ID (' + id + ') found in data store.');
                resolve(res);
            });
        }
        else {
            var that = this;
            if (id) {
                return this._http.get(app_settings_1.AppSettings.API_ENDPOINT + this.getModuleName(DataStructure) + '/' + this.getEntityName(DataStructure) + '/' + id
                    + (this.getHasReadRowPermissions(DataStructure) ? '?Filters=[{"Filter":"Common.RowPermissionsReadItems"}]' : ""))
                    .map(function (data) {
                    var entObj = that.fromRawEntity(DataStructure, data.json());
                    var found = false;
                    that.data.forEach(function (rest, i) {
                        if (rest instanceof DataStructure && entObj.ID === rest.ID) {
                            that.data[i] = entObj;
                            found = true;
                        }
                    });
                    if (!found)
                        that.data.push(entObj);
                    that.dataObserver.next({ ID: "", data: [entObj] });
                    return that.createEntityInstance(DataStructure, entObj);
                }, function (error) {
                    console.log('Could not create entity.');
                    return that.createEntityInstance(DataStructure, null);
                }).toPromise();
            }
            else
                return new Promise(function (resolve, reject) { resolve(that.createEntityInstance(DataStructure, null)); });
        }
    };
    WebAPIRestService.prototype.createEntity = function (DataStructure, entity, emitID) {
        var _this = this;
        var that = this;
        this.getDummyWithClaim(DataStructure).then(function (perm) {
            if (!perm.NewRight) {
                if (perm.PermissionLoaded) {
                    console.log('User does not have "New" right on "' + that.getModuleName(DataStructure) + '.' + that.getEntityName(DataStructure) + '".');
                }
            }
            else {
                var baseURL = app_settings_1.AppSettings.API_ENDPOINT + _this.getModuleName(DataStructure) + '/' + _this.getEntityName(DataStructure) + '/';
                perm.saveNew(entity, function (finalEnt) {
                    var headers = new http_1.Headers({ 'Content-Type': 'application/json' });
                    var options = new http_1.RequestOptions({ headers: headers });
                    _this._http.post(baseURL, _this.entityToJSON(entity), options)
                        .subscribe(function (data) {
                        entity.ID = data.json().ID;
                        that.data.push(entity);
                        that.dataObserver.next({ ID: (emitID) ? emitID : "", data: [entity], dataChangedType: index_3.DataChangeType.Insert, dataStructure: DataStructure });
                    }, function (error) {
                        var errorMessage = "Error in creating entity " + that.getModuleName(DataStructure) + '.' + that.getEntityName(DataStructure);
                        try {
                            errorMessage = error.json().UserMessage;
                        }
                        catch (_) { }
                        that.errorObserver.emit({ ID: (emitID) ? emitID : "", errorData: error, errorMessage: errorMessage, inputData: entity });
                        console.log('Could not create entity.');
                    });
                });
            }
        });
    };
    WebAPIRestService.prototype.updateEntity = function (DataStructure, entity, emitID) {
        var _this = this;
        if (!entity.ID) {
            this.createEntity(DataStructure, entity, emitID);
            return;
        }
        var that = this;
        this.getDummyWithClaim(DataStructure).then(function (perm) {
            if (!perm.EditRight) {
                if (perm.PermissionLoaded) {
                    console.log('User does not have "New" right on "' + that.getModuleName(DataStructure) + '.' + that.getEntityName(DataStructure) + '".');
                }
            }
            else {
                var baseURL = app_settings_1.AppSettings.API_ENDPOINT + _this.getModuleName(DataStructure) + '/' + _this.getEntityName(DataStructure) + '/' + entity.ID;
                perm.saveOld(entity, function (finalEnt) {
                    var headers = new http_1.Headers({ 'Content-Type': 'application/json' });
                    var options = new http_1.RequestOptions({ headers: headers });
                    that._http.put(baseURL, that.entityToJSON(entity), options)
                        .subscribe(function (data) {
                        that.fetchEntityWithID(entity.ID);
                        that.dataObserver.next({ ID: (emitID) ? emitID : "", data: [entity] });
                    }, function (error) {
                        var errorMessage = "Error in creating entity " + _this.getModuleName(DataStructure) + '.' + _this.getEntityName(DataStructure);
                        try {
                            errorMessage = error.json().UserMessage;
                        }
                        catch (_) { }
                        that.errorObserver.emit({
                            ID: (emitID) ? emitID : "", errorData: error,
                            errorMessage: errorMessage,
                            inputData: entity
                        });
                        console.log('Could not update entity.');
                    });
                });
            }
        });
    };
    WebAPIRestService.prototype.deleteEntity = function (DataStructure, entity, emitID) {
        var that = this;
        this._http.delete(app_settings_1.AppSettings.API_ENDPOINT + this.getModuleName(DataStructure) + '/' + this.getEntityName(DataStructure) + '/' + entity.ID).subscribe(function (response) {
            var datas = [];
            that.data.forEach(function (ent, index) {
                if (ent.ID === entity.ID) {
                    datas.push(ent);
                    that.data.splice(index, 1);
                }
            });
            that.notificationService.emitter.emit({ severity: 'info', summary: 'Delete Success', detail: 'You deleted data with ID: ' + entity.ID });
            that.dataObserver.next({ ID: "", data: datas, dataChangedType: index_3.DataChangeType.Delete, dataStructure: DataStructure });
        }, function (error) {
            var errorMessage = "Error in deleting entity " + that.getModuleName(DataStructure) + '.' + that.getEntityName(DataStructure);
            try {
                errorMessage = error.json().UserMessage;
            }
            catch (_) { }
            that.errorObserver.emit({ ID: (emitID) ? emitID : "", errorData: error, errorMessage: errorMessage, inputData: entity });
            that.notificationService.emitter.emit({ severity: 'warn', summary: 'Delete Fail', detail: 'You can not deleted data with ID: ' + entity.ID });
            console.log('Could not delete entity.');
        });
    };
    WebAPIRestService.prototype.getCurrentLibrary = function (DataStructure, filters) {
        if (!filters || filters.length == 0)
            return this.data.filter(function (ent) { return ent instanceof DataStructure; }).map(function (x) { return x; });
        else {
            var res = this.data.filter(function (ent) { return ent instanceof DataStructure; }).map(function (x) { return x; });
            filters.forEach(function (fieldFilter) {
                res = res.filter(function (x) { return x[fieldFilter.Field].toString().includes(fieldFilter.Term); });
            });
            return res;
        }
    };
    WebAPIRestService.prototype.reloadData = function (DataStructure, loadID) {
        var _this = this;
        if (loadID === void 0) { loadID = ""; }
        var reloadDataID = loadID;
        var that = this;
        if (reloadDataID == "")
            reloadDataID = "RRS_ReloadData_" + (Math.random() * 1000013);
        this.getDummyWithClaim(DataStructure).then(function (perm) {
            if (perm.ReadRight) {
                var url = app_settings_1.AppSettings.API_ENDPOINT + _this.getModuleName(DataStructure) + '/' + _this.getEntityName(DataStructure) + '/'
                    + (_this.getHasReadRowPermissions(DataStructure) ? '?Filters=[{"Filter":"Common.RowPermissionsReadItems"}]' : "");
                console.log(url);
                _this._http.get(app_settings_1.AppSettings.API_ENDPOINT + _this.getModuleName(DataStructure) + '/' + _this.getEntityName(DataStructure) + '/'
                    + (_this.getHasReadRowPermissions(DataStructure) ? '?Filters=[{"Filter":"Common.RowPermissionsReadItems"}]' : ""))
                    .subscribe(function (data) {
                    var toAdd = new Array();
                    data.json().Records.map(function (rec) {
                        var preparedEnt = that.fromRawEntity(DataStructure, rec);
                        var found = false;
                        that.data.forEach(function (rest, i) {
                            if (rest instanceof DataStructure && preparedEnt.ID === rest.ID) {
                                that.data[i] = preparedEnt;
                                found = true;
                            }
                        });
                        if (!found)
                            toAdd.push(preparedEnt);
                    });
                    that.data = that.data.concat(toAdd);
                    that.dataObserver.next({ ID: reloadDataID, data: that.data });
                }, function (error) {
                    _this.errorObserver.emit({ ID: reloadDataID, errorData: error, errorMessage: "Error in loading data for " + _this.getModuleName(DataStructure) + '.' + _this.getEntityName(DataStructure), inputData: _this.getModuleName(DataStructure) + '.' + _this.getEntityName(DataStructure) });
                    console.log('Could not load data.');
                });
            }
            else {
                if (perm.PermissionLoaded) {
                    throw new Error('User does not have right to load: ' + _this.getEntityNameID(DataStructure));
                }
            }
        });
        return reloadDataID;
    };
    WebAPIRestService.prototype.loadData = function (DataStructure, filters, predefinedFilters, sort, top, skip) {
        var _this = this;
        var customFilter;
        var that = this;
        var res;
        return this.getDummyWithClaim(DataStructure).then(function (perm) {
            if (perm.ReadRight) {
                if (!predefinedFilters)
                    predefinedFilters = [];
                if (predefinedFilters.filter(function (qu) { return qu.FilterName !== ''; }).length > 0 || (filters != null && (filters.filter(function (qu) { return qu.Term !== ""; }).length > 0 || _this.getHasReadRowPermissions(DataStructure))))
                    customFilter = '/RecordsAndTotalCount?Filters=[' + filters.filter(function (qu) { return qu.Term !== ""; }).map(function (filter) { return index_1.FieldFilter.toRhetosRESTQueryString(filter); }).join()
                        + (((filters.filter(function (qu) { return qu.Term !== ""; }).length > 0) && ((predefinedFilters.length > 0) || _this.getHasReadRowPermissions(DataStructure))) ? ',' : '')
                        + (_this.getHasReadRowPermissions(DataStructure) ? '{"Filter":"Common.RowPermissionsReadItems"}' : "")
                        + ((((filters.filter(function (qu) { return qu.Term !== ""; }).length > 0) || _this.getHasReadRowPermissions(DataStructure)) && (predefinedFilters.length > 0)) ? ',' : '')
                        + predefinedFilters.map(function (filter) { return JSON.stringify({ Filter: filter.FilterName, Value: filter.FilterData }); }).join() + ']'
                        + (sort ? '&sort=' + sort.toString() : '') + (top ? '&top=' + top.toString() : '') + (skip ? '&skip=' + skip.toString() : '');
                else
                    customFilter = '/RecordsAndTotalCount' + (sort ? '?sort=' + sort.toString() : '') + (top ? '&top=' + top.toString() : '') + (skip ? '&skip=' + skip.toString() : '');
                return _this._http.get(app_settings_1.AppSettings.API_ENDPOINT + _this.getModuleName(DataStructure) + '/' + _this.getEntityName(DataStructure)
                    + customFilter)
                    .map(function (data) {
                    data.json().Records.map(function (entity) {
                        var found = false;
                        var ent = _this.fromRawEntity(DataStructure, entity);
                        that.data.forEach(function (rest, i) {
                            if (rest instanceof DataStructure && ent.ID === rest.ID) {
                                that.data[i] = ent;
                                found = true;
                            }
                        });
                        if (!found)
                            that.data.push(ent);
                    });
                    return {
                        records: Array.from(data.json().Records, function (rec) { return (that.fromRawEntity(DataStructure, rec)); }),
                        totalCount: data.json().TotalCount
                    };
                }, function (error) {
                    console.log('Could not load data. ERR: ' + error.toString());
                    return that.createEntityInstance(DataStructure, null);
                }).toPromise();
            }
            else {
                if (perm.PermissionLoaded) {
                    throw new Error('User does not have right to load: ' + _this.getEntityNameID(DataStructure));
                }
                return that.getCurrentPrincipal();
            }
        });
    };
    WebAPIRestService.prototype.getSingleByID = function (DataStructure, ID) {
        var that = this;
        return this._http.get(app_settings_1.AppSettings.API_ENDPOINT + this.getModuleName(DataStructure) + '/' + this.getEntityName(DataStructure) + '/' + ID).map(function (data) {
            return that.fromRawEntity(DataStructure, data.json());
        }, function (error) {
            console.log('Could not load data. ERR: ' + error.toString());
            return that.createEntityInstance(DataStructure, null);
        }).toPromise();
    };
    WebAPIRestService.prototype.getSingle = function (DataStructure, route, filters) {
        var customFilter = route;
        var that = this;
        if (filters && (filters.filter(function (qu) { return qu.Term !== ""; }).length > 0)) {
            customFilter += '?Filters=[';
            customFilter += filters.filter(function (qu) { return qu.Term !== ""; }).map(function (filter) { return index_1.FieldFilter.toRhetosRESTQueryString(filter); }).join();
            customFilter += ']' + '&top=1&skip=0';
        }
        return this._http.get(app_settings_1.AppSettings.API_ENDPOINT + this.getModuleName(DataStructure) + '/' + this.getEntityName(DataStructure) + '/' + customFilter)
            .map(function (data) {
            return that.fromRawEntity(DataStructure, data.json());
        }, function (error) {
            console.log('Could not load data. ERR: ' + error.toString());
            return that.createEntityInstance(DataStructure, null);
        }).toPromise();
    };
    WebAPIRestService.prototype.findEntity = function (DataStructure, route, filters, top, skip) {
        var _this = this;
        var customFilter = route;
        var that = this;
        if (filters && (filters.filter(function (qu) { return qu.Term !== ""; }).length > 0)) {
            customFilter += '?Filters=[';
            customFilter += filters.filter(function (qu) { return qu.Term !== ""; }).map(function (filter) { return index_1.FieldFilter.toRhetosRESTQueryString(filter); }).join();
            customFilter += ']' + (top ? '&top=' + top.toString() : '') + (skip ? '&skip=' + skip.toString() : '');
        }
        return this._http.get(app_settings_1.AppSettings.API_ENDPOINT + this.getModuleName(DataStructure) + '/' + this.getEntityName(DataStructure) + '/' + customFilter)
            .map(function (data) {
            data.json().Records.map(function (entity) {
                var found = false;
                var ent = _this.fromRawEntity(DataStructure, entity);
                that.data.forEach(function (rest, i) {
                    if (rest instanceof DataStructure && ent.ID === rest.ID) {
                        that.data[i] = ent;
                        found = true;
                    }
                });
                if (!found)
                    that.data.push(ent);
            });
            return {
                records: Array.from(data.json().Records, function (rec) { return (that.fromRawEntity(DataStructure, rec)); }),
                totalCount: data.json().TotalCount
            };
        }, function (error) {
            console.log('Could not load data. ERR: ' + error.toString());
            return that.createEntityInstance(DataStructure, null);
        }).toPromise();
    };
    WebAPIRestService.prototype.executeOnEntityList = function (DataStructure, actionName, entity, successMessage, emitID) {
        var _this = this;
        var headers = new http_1.Headers({ 'Content-Type': 'application/json' });
        var options = new http_1.RequestOptions({ headers: headers });
        var that = this;
        var baseUrl = app_settings_1.AppSettings.API_ENDPOINT + this.getModuleName(DataStructure) + '/' + this.getEntityName(DataStructure) + '/' + actionName;
        this._http.post(baseUrl, JSON.stringify(entity), options).subscribe(function (data) {
            that.dataObserver.next(new index_3.DataChanged((emitID) ? emitID : "", entity));
            that.notificationService.emitter.next(successMessage);
        }, function (error) {
            var errorMessage = "Error in execute entity " + _this.getModuleName(DataStructure) + '.' + _this.getEntityName(DataStructure);
            try {
                errorMessage = error.json().UserMessage;
            }
            catch (_) { }
            that.errorObserver.emit({
                ID: (emitID) ? emitID : "", errorData: error,
                errorMessage: errorMessage,
                inputData: entity
            });
            console.log('Could not update entity.');
        });
    };
    WebAPIRestService.prototype.executeOnEntity = function (DataStructure, actionName, entity, successMessage, emitID) {
        var _this = this;
        var headers = new http_1.Headers({ 'Content-Type': 'application/json' });
        var options = new http_1.RequestOptions({ headers: headers });
        var that = this;
        var baseUrl = app_settings_1.AppSettings.API_ENDPOINT + this.getModuleName(DataStructure) + '/' + this.getEntityName(DataStructure) + '/' + actionName + '/' + entity.ID;
        this._http.post(baseUrl, that.entityToJSON(entity), options).subscribe(function (data) {
            that.fetchEntityWithID(entity.ID);
            that.dataObserver.next({ ID: (emitID) ? emitID : "", data: [entity] });
            that.notificationService.emitter.next(successMessage);
        }, function (error) {
            var errorMessage = "Error in execute entity " + _this.getModuleName(DataStructure) + '.' + _this.getEntityName(DataStructure);
            try {
                errorMessage = error.json().UserMessage;
            }
            catch (_) { }
            that.errorObserver.emit({
                ID: (emitID) ? emitID : "", errorData: error,
                errorMessage: errorMessage,
                inputData: entity
            });
            console.log('Could not update entity.');
        });
    };
    WebAPIRestService.prototype.invokeAction = function (ActionInfo, data) {
        var headers = new http_1.Headers({ 'Content-Type': 'application/json' });
        var options = new http_1.RequestOptions({ headers: headers });
        var that = this;
        if (ActionInfo.isPostAction)
            return this._http.post(ActionInfo.url, data, options).map(function (res) {
                console.log('Post ' + ActionInfo.url + ' successful.');
                return res;
            }, function (error) {
                console.log('Post ' + ActionInfo.url + ' failure ' + error);
                return '';
            }).toPromise();
        else
            return this._http.put(ActionInfo.url, data, options).map(function (res) {
                console.log('Put ' + ActionInfo.url + ' successful.');
                return res;
            }, function (error) {
                console.log('Put ' + ActionInfo.url + ' failure ' + error);
                return '';
            }).toPromise();
    };
    WebAPIRestService.prototype.getCurrentPrincipal = function () {
        return new Promise(function (resolve, reject) { resolve(); });
    };
    WebAPIRestService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.Http, core_1.Injector, permission_provider_service_1.PermissionProvider, index_4.NotificationService])
    ], WebAPIRestService);
    return WebAPIRestService;
}());
exports.WebAPIRestService = WebAPIRestService;
